﻿(function ($) {
	$.fn.fileViewer = function (options) {
		let $this = $(this), 
			$frame = null,
			$btn_action = null,
			_random = null;
		//настройки контрола по умолчанию
		options = $.extend({
			dialog: false, // в диалоге
			title: "Просмотр файла", //заголовок диалога
			corheight: 0.7, //параметр для корректировки высоты 			
			height: 350, //мин. высота 
			onLoad: undefined,//событие загрузки файла
			actionBtn: [],
			onPrev: undefined,
			onNext: undefined,
			onHome: undefined,
			onBlank: undefined,
			onAction: undefined,
			onScroll: undefined 
		}, options);

		let _template = "<div class='container-fluid file-viewer-container'>" +
			"<div class='row file-viewer-navs mt-2 d-none'>" +
			"<div class='col-2 text-left'>" +
			'<button data-action="0" type="button" class="btn btn-sm btn-info js-navs-prev" title="Назад">' +
			'<span class="mdi mdi-skip-previous pr-lg-1"></span>' +
			"</button>" +
			"</div>" +
			"<div class='col-8 text-center'>" +
			'<button data-action="1" type="button" class="btn btn-sm btn-info js-navs-home" title="Перейти к оглавлению">' +
			'<span class="mdi mdi-home pr-lg-1"></span>' +
			'</button>&nbsp' +
			'<button data-action="2" type="button" class="btn btn-sm btn-info js-navs-blank" title="Открыть в новом окне">' +
			'<span class="mdi mdi-microsoft-internet-explorer pr-lg-1"></span>' +
			'</button>&nbsp' +
			'</div>' +
			"<div class='col-2 text-right'>" +
			'<button data-action="3"  type="button" class="btn btn-sm btn-info js-navs-next" title="Вперед">' +
			'<span class="mdi mdi-skip-next pr-lg-1"></span>' +
			'</button>' +
			'</div>' +
			'</div>' +
			"<div class='row mt-2'>" +
			"<div class='col-md-12 form-group'>" +
			"<iframe style='width:100%; height:98%;' src='' id='file-viewer-frame'></iframe>"
			"</div>" +
			"</div>" +
			"</div>";

		if (options.dialog) {
			$this.addClass('modal').attr("data-backdrop", 'static')
				.attr("data-keyboard", 'false')
				.attr("tabindex", '-1')
				.attr("role", 'dialog')
				.attr("aria-labelledby", 'modal-label')
				.attr("aria-hidden", 'true').css("z-index", 1051); 

			$this.append("<div class='modal-dialog modal-xl' role='document'>" +
				"<div class='modal-content'>" +
				"<div class='modal-header'>" +
				"<h5 class='modal-title' id='modal-label'></h5>" +
				"<button type='button' class='close' data-dismiss='modal' aria-label='Close'>" +
				"<span aria-hidden='true'>&times;</span>" +
				"</button>" +
				"</div>" +
				"<div class='modal-body' style='padding: 0px !important;'>" +
				_template +
				"</div>" +
				"</div>" +
				"</div>"); 

			$this.find(".modal-dialog").draggable({
				handle: ".modal-header"
			});
		} else {
			$this.append(_template);
		}
		$frame = $this.find('#file-viewer-frame');

		$btn_action = $this.find('.file-viewer-navs');
		$.each(options.actionBtn, function (index, item) {
			$(".col-8", $btn_action).append(_getBtnItem(index, item));
		});

		$("button", $btn_action).on("click", function (e) {
			e.preventDefault();
			let btn = $(this).attr("data-action");
			switch (btn) {
				case "0": {
					if (options.onPrev) {
						options.onPrev();
					} else {
						history.go(-1);
						return !1;
					}
					break;
				}
				case "1": {
					if (options.onHome) {
						options.onHome();
					} else {
						let src = $frame.attr('src');
						if (src !== undefined) {
							$frame.attr('src', src.substring(0, src.lastIndexOf('/')) + '/Index.htm?random=' + _random);
						}
					}
					break;
				}
				case "2": {
					if (options.onBlank) {
						options.onBlank();
					} else {
						let src = $frame.attr('src');
						if (src !== undefined) {
							window.open(src.substring(0, src.lastIndexOf('/')) + '/Index.htm?random=' + _random, '_blank');
						}
					}
					break;
				}
				case "3": {
					if (options.onNext) {
						options.onNext();
					} else {
						history.go(+1);
						return !1;
					}
					break;
				}
				default: {
					if (options.onAction) {
						options.onAction(btn);
					}
					break;
				}
			}
		});
	 
		function api() {
			return {
				hide: function () {
					$this.hide();
				},
				show: function () {
					$this.show();
				},
				disabledActionBtn: function (arr) {
					for (var i = 0; i < arr.length; i++) {
						$("button[data-action='" + arr[i] + "']", $btn_action).attr("disabled", true);
					}
				},
				enabledActionBtn: function (arr) {
					for (var i = 0; i < arr.length; i++) {
						$("button[data-action='" + arr[i] + "']", $btn_action).attr("disabled", false);
					}
				},
				hideActionBtn: function (arr) {
					for (var i = 0; i < arr.length; i++) {
						$("button[data-action='" + arr[i] + "']", $btn_action).addClass("d-none");
					}
				},
				showActionBtn: function (arr) {
					for (var i = 0; i < arr.length; i++) {
						$("button[data-action='" + arr[i] + "']", $btn_action).removeClass("d-none");
					}
				},
				hideActionMenu: function () {
					$btn_action.addClass("d-none");
				},
				showActionMenu: function () {
					$btn_action.removeClass("d-none");
				},
				gotoAnchor: function (anchor) {
					if (!!anchor) {
						let src = $frame.attr('src');
						if (!!src) {
							if (src.indexOf("viewer.html") !== -1) {
								_goToPdfAnchor(anchor);
							} else {
								let splitAnchor = anchor.split('#');
								let basePath = src.substring(0, src.lastIndexOf('/'));
								if (splitAnchor.length == 2) {
									$frame.attr('src', basePath + "/" + splitAnchor[0] + "?random=" + _random + "#" + splitAnchor[1]);
								} 
							}
						}
					}
				},
				close: function () {
					if ($this.hasClass('modal')) {
						$this.modal('hide');
					}
				},
				view: function (file, anchor) {
					_destroy(function () {
						if (file.extension === ".zip") {
							let src = '../temp/' + file.id + '/';
							if (!!anchor) {
								let splitAnchor = anchor.split('#');
								if (splitAnchor.length == 2) {
									src += splitAnchor[0] + "?random=" + _random + "#" + splitAnchor[1];
								} else {
									src += 'Index.htm?random=' + _random;
								}
							} else {
								src += 'Index.htm?random=' + _random;
							}
							$frame.attr('src', src).on("load", function (e, data) {
								api().showActionMenu();
								api().enabledActionBtn([0, 1, 2, 3]);
								_dialogOpen(file.name, function () {
									if (options.onLoad) {
										options.onLoad($frame);
									}
								});
							});
						} else if (file.extension === ".pdf") {
							let src = "../lib/Pdf.js/web/viewer.html?file=/temp/" + file.id + file.extension;
							_dialogOpen(file.name, function () {
								$frame.attr('src', src).on("load", function (e, data) {
									let doc = $(this)[0].contentWindow
										|| $(this)[0].contentDocument;
									if (doc.document) {
										doc = doc.document;
										doc.body.addEventListener('outlineloaded', function () {
											if (!!anchor) {
												_goToPdfAnchor(anchor);
											}
											if (options.onLoad) {
												options.onLoad($frame);
											}
										});
									};
								});
							});
						} else if (file.extension === ".html") {
							let src = '../temp/' + file.id + file.extension + "?random=" + _random;
							$frame.attr('src', src).on("load", function (e, data) {
								_dialogOpen(file.name, function () {
									if (options.onLoad) {
										options.onLoad($frame);
									}
								});
							});
						} else if (file.extension == ".png" || file.extension == ".jpg" || file.extension == ".jpeg") {
							$frame.contents().find("body")
								.html("<img style='display: block; margin-left: auto; margin-right: auto; width: 80%;' src='../temp/" + file.id + file.extension + "?random=" + _random + "' />");
							_dialogOpen(file.name, function () {
								if (options.onLoad) {
									options.onLoad($frame);
								}
							});
						} else {
							$frame.contents().find("body")
								.html("<p><em>Отображение документов формата " + file.extension + " не поддерживается веб-браузером</em></p><a class='btn-download-file btn btn-link' attr-id='" + file.id + "' href='#'>Скачать файл на локальный диск компьютера</a>");
							_dialogOpen(file.name, function () {
								if (options.onLoad) {
									options.onLoad($frame);
								}
							});
							$frame.contents().find(".btn-download-file").on("click", function (e) {
								we_helper.getDataDB("/Designer/DownloadFile", { pageid: "documentfile", id: $(this).attr("attr-id") }, "query", false, function (entity) {
									window.open('../temp/' + entity, "_blank");
									we_helper.hideLoader();
								});
								e.preventDefault();
							});
							 
						}
					});
				},
                resize: function () {
					$frame.css("height", $(window).height() * options.corheight);
				},
				getframe: function () {
					return $frame;
                }
			}
		}
		$(window).resize(function (e) {
			api().resize();
		});

		function _getActionBtnModel() {
			return {
				title: "",
				icon: "mdi mdi-alert-circle-outline",
				className: "btn btn-sm btn-outline-primary",
				disabled: false
			}
		}
		function _getBtnItem(index, item) {
			item = $.extend(true, _getActionBtnModel(), item);
			return '<button data-action="' + (index + 4) + '"  ' + (item.disabled ? "disabled" : "") + ' type="button" class="' + item.className + '" title="' + item.title + '"><i class="' + item.icon + ' pr-lg-1"></i></button>&nbsp';
		}
		function _destroy(callback) {
			_random = (new Date()).getTime() + Math.floor(Math.random() * 1000000);
			$frame.off("load").removeAttr('src');
			api().hideActionMenu();
			api().disabledActionBtn([0, 1, 2, 3]);
			if (callback) {
				setTimeout(function () {
					callback();
				}, 10);
            }
		}
		function _goToPdfAnchor(anchor) {
			$frame.contents().find('a:contains("' + anchor + '")').filter(function (index) {
				return $(this).text() === anchor;
			}).click();
		}
		function _dialogOpen(title, callback) {
			if ($this.hasClass('modal')) {
				if (title) {
					$this.find('.modal-title').text(title);
				}
				$this.modal('show'); 
			}
			api().resize();
			if (callback) {
				callback();
			}
		}

		return {
			api: api
		};
	}
})(jQuery);
 