﻿(function ($) {
    $.fn.searchPanel = function (opts) {
        let $this = $(this),
            $select_data = [],
            $search_param = null,
            $search_data = null,
            $dt_start = null,
            $dt_end = null,
            $cb_remember_search_param = null,
            $btn_search = null,
            $btn_clear = null,
            $jq_sp_box = null,
            $btn_action = null;

        let stgs = $.extend({  
            uid: "",
            prefix: "",
            dateBlock: {
                show: true
            },
            autocomplete: {
                enable: false,
                url: null,
                data: {}
            },
            searchParam: {
                params: [],
                default: {
                    param: 0,
                    data: ""
                }
            },
            actionBtn: [],
            selectParam: [],
            defBtn: false,
            onAction: undefined,
            onClear: undefined,
            onSearch: undefined 
        }, opts);

        function _createDatepicker(conatinerId) {
            return '<div class="form-group">' +
                '<div class="input-group date" data-provide="datepicker">' +
                '<input type="text" class="form-control form-control-sm input-datepicker ' + conatinerId + '" />' +
                '<span class="input-group-addon-datepicker input-group-addon input-group-addon-sm">' +
                '<span class="mdi mdi-calendar-outline" style="cursor:pointer"></span>' +
                '</span>' +
                '</div>' +
                '</div>';
        }
        function _createSelect(arrOption, conatinerId, attr_id) {
            let content = "<select class='" + conatinerId + " select2' attr-id='" + attr_id + "'> ";
            for (let i = 0; i < arrOption.length; i++)
                content += "<option value='" + i + "'>" + arrOption[i].text + "</option>";
            content += "</select>";
            return content;
        };

        // Собираю шаблон. 
        $this.append("<div class='row align-items-end js-search-panel-box'></div>");
        $jq_sp_box = $this.find('.js-search-panel-box');

          let fcol = "col-md-2",
            dtcol = "col-lg-3";
        if (!!stgs.selectParam) {
            let arr_length = stgs.selectParam.length;
            if (arr_length > 1) {
                fcol = "col-md-4";
                dtcol = "col-lg-4";
            }

            for (let i = 0; i < arr_length; i++) {
                $jq_sp_box.append(
                    "<div class='" + fcol+" form-group'>" +
                    "<label for='js-select-" + stgs.selectParam[i].id + stgs.prefix + "' class='font-weight-500 m-0'>" + stgs.selectParam[i].title + "</label>" +
                    _createSelect([], 'js-select-' + stgs.selectParam[i].id + stgs.prefix, stgs.selectParam[i].id) +
                    "</div>"
                );
                $select_data.push($this.find('.js-select-' + stgs.selectParam[i].id + stgs.prefix));
            }

            for (let i = 0; i < arr_length; i++) {
                let _param = {
                    "pageid": stgs.selectParam[i].id
                };

                for (let j = 0; j < i; j++) {
                    let attr_id = $select_data[j].attr("attr-id");
                    if (!!attr_id) {
                        _param[attr_id + "id"] = function () {
                            return $select_data[j].val();
                        };
                    }
                }

                we_helper.initSelect(stgs.selectParam[i].url, $select_data[i], _param, true, false, function () {
                    if (!!stgs.selectParam[i].def_selected && !!stgs.selectParam[i].def_selected.id) {
                        $select_data[i].append(new Option(stgs.selectParam[i].def_selected.text, stgs.selectParam[i].def_selected.id))
                            .val(stgs.selectParam[i].def_selected.id).trigger('change');
                    }
                }, function () {
                        for (let j = i + 1; j < arr_length; j++) {
                            $select_data[j].val([0]).trigger('change');
                        }
                    //выполняем поиск записей
                    $btn_search.click();
                });
            }
        }
     
        if (stgs.dateBlock.show) {
            $jq_sp_box.append(
                "<div class='" + dtcol + " col-md-4'> " +
                "<label class='font-weight-500 m-0'>Период изменения записи</label>" +
                "<div class='row'>" +
                "<div class='col-sm-6'>" +
                _createDatepicker('js-dt-start' + stgs.prefix) +
                "</div>" +
                "<div class='col-sm-6'>" +
                _createDatepicker('js-dt-end' + stgs.prefix) +
                "</div>" +
                "</div>" +
                "</div>");
            $dt_start = $this.find('.js-dt-start' + stgs.prefix);
            $dt_end = $this.find('.js-dt-end' + stgs.prefix);

            we_helper.initDatePicker($(".date", $this));
        }

        let rememberTemplate = "",
            cache_uid = "";
        if (!!stgs.uid) {
            cache_uid = "search_" + stgs.uid;
            rememberTemplate = "<div class='input-group-prepend'>" +
                "<div class='input-group-text'>" +
                "<input type='checkbox' title='Сохранить поиск' class='js-remember-search-param" + stgs.prefix + "'>" +
                "</div>" +
                "</div>";
        }
        $jq_sp_box.append(
            "<div class='col-md-2 form-group'>" +
            "<label for='js-search-param" + stgs.prefix + "' class='font-weight-500 m-0'>Параметр поиска</label>" +
                _createSelect(stgs.searchParam.params, 'js-search-param' + stgs.prefix)  +
            "</div>" +
            "<div class='" + (stgs.actionBtn.length>0 ? 'col-md col-sm-10 col-10' : 'col') + " form-group'>" +
            "<label for='js-search-data" + stgs.prefix + "' class='font-weight-500 m-0'>Текст запроса</label>" +
            "<div class='input-group'>" + rememberTemplate +
            "<input type='text' class='js-search-data" + stgs.prefix + " form-control form-control-sm' placeholder='" + stgs.searchParam.params[0].placeholder + "'>" +
            "<div class='input-group-append'>" +
            "<button class='js-btn-search" + stgs.prefix + " btn btn-sm btn-info' title='Найти'>" +
            "<span class='mdi mdi-magnify pr-lg-1'></span>" +
            //"<span class='d-none d-lg-inline-block'> Найти</span>" +
            "</button > " +
            "<button class='js-btn-clear" + stgs.prefix + " btn btn-sm btn-danger' title='Очистить'>" +
            "<span class='mdi mdi-broom pr-lg-1'></span>" +
            //"<span class='d-none d-lg-inline-block'> Очистить</span>" +
            "</button > " +
            "</div>" +
            "</div>" +
            "</div>");

        $cb_remember_search_param = $this.find(".js-remember-search-param" + stgs.prefix);
        $search_param = $this.find('.js-search-param' + stgs.prefix +'.select2');
        $search_data = $this.find(".js-search-data" + stgs.prefix);
        $search_param.val(stgs.searchParam.default.param);
        $search_data.val(stgs.searchParam.default.data);

        $btn_search = $this.find(".js-btn-search" + stgs.prefix);
        $btn_clear = $this.find(".js-btn-clear" + stgs.prefix);
        we_helper.selectToSelect2($search_param, true);

        if (!!stgs.autocomplete && stgs.autocomplete.enable && !!stgs.autocomplete.url && !!$search_data) {
            if ($search_data.data('ui-autocomplete')) {
                $search_data.autocomplete("destroy");
            }
            $search_data.autocomplete({
                delay: 500,
                minLength: 1,
                source: function (request, response) {
                    let dt = api().get_data();
                    if (!!stgs.autocomplete.data) {
                        $.each(stgs.autocomplete.data, function (key, value) {
                            if (typeof value === 'function') {
                                dt[key] = value.call();
                            } else {
                                dt[key] = value;
                            }
                        });
                    }
                    we_helper.getDataDB(stgs.autocomplete.url, dt, "body", true, function (entity) {
                        response(entity);
                    });
                },
                select: function (e, ui) {
                    $search_data.val(ui.item.label);
                    $btn_search.click();
                }
            });
        }
        if (stgs.actionBtn.length === 1) {
            $jq_sp_box.append(
                "<div class='col-md-1 col-sm-2 col-2 form-group'><div class='float-right'>" +
                "<a class='text-white search-panel-action-btn btn btn-sm btn-" + stgs.actionBtn[0].style + " js-action-btn" + stgs.prefix + "' data-key='" + stgs.actionBtn[0].id + "' title='" + stgs.actionBtn[0].text + "'>" +
                "<span class='" + stgs.actionBtn[0].icon + "'></span><span class='pl-lg-1 d-none d-lg-inline-block'> " + stgs.actionBtn[0].text + "</span></a></div></div>");
        } else if (stgs.actionBtn.length > 1) {
            let content = '<div class="col-md-1 col-sm-2 col-2">';
            if (stgs.defBtn) {
                content += '<div class="dropdown float-right btn-group">' +
                    '<button type="button" class="btn btn-sm btn-' + stgs.actionBtn[0].style + " js-action-btn" + stgs.prefix + '" data-key="' + stgs.actionBtn[0].id + '" title="' + stgs.actionBtn[0].text + '"><span class="' + stgs.actionBtn[0].icon + '"></span></button>' +
                    '<button type="button" class="btn btn-sm btn-' + stgs.actionBtn[0].style + ' dropdown-toggle dropdown-toggle-split" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" title="Открывать меню действий">' +
                    '<span class="sr-only">Toggle Dropdown</span>' +
                    '</button>';
            } else {
                content += "<div class='dropdown float-right form-group'>" +
                    "<button type='button' class='btn btn-sm btn-success dropdown-toggle' data-toggle='dropdown' data-display='static' id='js_action_btn_" + stgs.prefix + "'> " +
                    "<span class='mdi mdi-settings-outline pr-lg-1'></span><span class='caret'></span></button>";
            }
            content += "<div class='dropdown-menu dropdown-menu-right' aria-labelledby='js_action_btn_" + stgs.prefix + "'>";
            $.each(stgs.actionBtn, function (key, val) {
                content += "<a class='text-dropdown dropdown-item js-action-btn" + stgs.prefix + " " + val.class + "' data-key='" + val.id + "' title='" + val.text + "'>" +
                    "<span class='" + val.icon + " text-" + val.style + " pr-lg-1'></span>" + val.text + "</a>";
            });
            content += "</div></div></div>";
            $jq_sp_box.append(content);
        }

        $btn_action = $this.find('.js-action-btn' + stgs.prefix);
        if (!!$btn_action) {
            $btn_action.on('click', function () {
                if (stgs.onAction) {
                    stgs.onAction($(this).attr("data-key"), api().get_data());
                }
            });
        }
       
        // Кнопка поиска.
        $btn_search.on('click', function () {
            let dt = api().get_data();
            if (!!cache_uid && $cb_remember_search_param.prop('checked')) {
                we_helper.setCache(cache_uid, dt);
            } 
            if (stgs.onSearch) {
                stgs.onSearch(dt);
            }
        });

        // Выбор параметра.
        $search_param.on('change', function () {
            $search_data.prop('placeholder', stgs.searchParam.params[this.value].placeholder);
        });

        // Кнопка очистки.
        $btn_clear.on('click', function () {
            if (stgs.dateBlock.show) {
                $dt_start.val('');
                $dt_end.val('');
            }
            $search_data.val('');
            if (!!cache_uid) {
                $cb_remember_search_param.prop('checked', false);
                we_helper.removeCache(cache_uid);
            }
            if (stgs.onClear) {
                stgs.onSearch(api().get_data());
            }
        });

        // Обработка нажатия "Enter".
        $search_data.keydown(function(e) {
            if ($(this).is(":focus") && e.keyCode === 13)
                $btn_search.click();
        });

        if (!!cache_uid) {
            $cb_remember_search_param.on('change', function () {
                if ($cb_remember_search_param.prop('checked')) {
                    we_helper.setCache(cache_uid, api().get_data());
                } else {
                    we_helper.removeCache(cache_uid);
                }
            });
            let cache_search_param = we_helper.getCache(cache_uid);
            if (!!cache_search_param) {
                if (!!cache_search_param.removeAfterInit) {
                    we_helper.removeCache(cache_uid);
                } else {
                    $cb_remember_search_param.prop('checked', true);
                }
                api().set_data(cache_search_param);
            }
        }

        function api() {
            return { 
                get_data: function () {
                    let data = we_helper.searchToObject();
                    data.search_param = $search_param.val();
                    data.search_data = $search_data.val();
                    if (stgs.dateBlock.show) {
                        data.dt_start = $dt_start.val();
                        data.dt_end = $dt_end.val();
                    }
                    for (let i = 0; i < $select_data.length; i++) {
                        let attr_id = $select_data[i].attr("attr-id");
                        if (!!attr_id) {
                            let _seldata = $select_data[i].select2('data')[0];
                            if (!!_seldata) {
                                data[attr_id + "id"] = _seldata.id;
                                data[attr_id + "name"] = _seldata.text;
                            } else {
                                data[attr_id + "id"] = null;
                                data[attr_id + "name"] = null;
                            }
                        }
                    }
                    return data;
                },
                get_selects_full_data: function () {
                    let data = {};
                    for (let i = 0; i < $select_data.length; i++) {
                        let attr_id = $select_data[i].attr("attr-id");
                        if (!!attr_id) {
                            data[attr_id + "id"] = $select_data[i].select2('data')[0];
                        }
                    }
                    return data;
                },
                get_filial_id: function () {
                    for (let i = 0; i < $select_data.length; i++) {
                        if ($select_data[i].attr("attr-id") ==="filial") {
                            return $select_data[i].val();
                        }
                    }
                    return null;
                },
                set_data: function (data) {
                    if (!!data.search_param) {
                        $search_param.val(data.search_param).trigger('change');
                    }
                    if (!!data.search_data) {
                        $search_data.val(data.search_data);
                    }
                    if (stgs.dateBlock.show) {
                        if (!!data.dt_start) {
                            $dt_start.val(data.dt_start);
                        }
                        if (!!data.dt_end) {
                            $dt_end.val(data.dt_end);
                        } 
                    }
                    for (let i = 0; i < $select_data.length; i++) {
                        let attr_id = $select_data[i].attr("attr-id");
                        if (!!attr_id && !!data[attr_id + "id"] && !!data[attr_id + "name"]) {
                            $select_data[i].append(new Option(data[attr_id + "name"], data[attr_id + "id"]))
                                .val(data[attr_id + "id"]).trigger('change');
                        } else {
                            $select_data[i].val(0).trigger('change');
                        }
                    }
                },
                search: function () {
                    $btn_search.click();
                }
            }
        }

        return {
            api: api
        };
    };
})(jQuery);