﻿var we_alert = {
    /** Метод загрузки непрочитанных оповещений */
    loadUserAlerts: function () {
        we_helper.getDataDB('/Account/GetUnreadAlerts', null, "query", true, function (response) {
            let notify_box= $('.js-notify-box');
            notify_box.children().remove();
            if (response != null && response.alerts.length != 0) {
                $.each(response.alerts, function (key, value) {
                    notify_box.append("<div class='notify-item js-notify-item'>" +
                        "<div class='col-7 notify-title'><p class='text-black-50'>" + value.event + "</p></div>" +
                        "<div class='col-3 notify-title'><p class='text-black-50'>" + we_helper.convertDate(value.dateOfChange) + "</p></div>" +
                        "<div class='col-2 notify-title'><span class='mdi mdi-window-close menu-notify-close js-menu-notify-close' onclick='we_alert.readUserAlerts($(this));' data-key='" + value.id + "'></span></div>" +
                        "<div class='col-12'><p class='text-black'>" + value.message + "</p>" +
                        "</div>" +
                        "</div>");
                });
                we_alert.setAlertCount(response.total);
			} else {
                notify_box.append("<p class='notify-empty-text'>Оповещений нет</p>");
                we_alert.setAlertCount(0);
			}   
        });
	},
    /** Загрузка количества непрочитанных сообщений */
    loadUserAlertCount: function () {
        we_helper.getDataDB('/Account/GetUnreadAlertCount', null, "query", true, function (response) {
            we_alert.setAlertCount(response);
        });
    },
    /** Установка количества непрочитанных сообщений */
    setAlertCount: function (count) {
        let jq_icon_count = $('.js-notify-count'),
            jq_menu_icon = $('.js-menu-notify-icon');
        if (!!count) {
            jq_menu_icon.removeClass('mdi-bell').addClass('mdi-bell-ring');
            jq_icon_count.text("").show().append(count);
        } else {
            jq_icon_count.hide();
            jq_menu_icon.removeClass('mdi-bell-ring').addClass('mdi-bell');
        }
    },
    /** Прочитать непрочитанные сообщения */
    readUserAlerts: function (o_sender) {
        let o_data = [];
        if (o_sender) {
            o_data.push(o_sender.attr("data-key"));
        } else {
            $.each($('.js-menu-notify-close'), function (index, item) {
                o_data.push($(item).attr("data-key"));
            });
        }
        if (o_data.length == 0) {
            return;
        }

        we_helper.updateDataDB('/Account/ReadUserAlerts', { ids: o_data, viewed: true }, function () {
            if (o_sender) {
                o_sender.closest('.js-notify-item').remove();
            } else {
                $('.js-notify-box').children().remove();
            }
            we_alert.loadUserAlertCount();
            we_helper.hideLoader();
		}, false);
    }
};