﻿var we_helper = {
    getEmptyGuid: function () {
        return "00000000-0000-0000-0000-000000000000";
    },
    getCurUserFilial: function () {
        return {
            id: $(".cur-user-filial-id").attr("attr-id"),
            text: $(".cur-user-filial-text").text()
        };
    },
    getSystemOwnerFilial: function () {
        return {
            id: $("#cur-install-filial-id").attr("attr-id"),
            text: $("#cur-install-filial-text").text()
        }
    },
    alert: function (msg, msg_type) {
        let jq_notification = $(".js-notification-container");
        if (!!jq_notification.length) {
            jq_notification.notify(msg, msg_type);
        } else {
            alert('Ошибка загрузки страницы. Закройте все окна браузера и повторите попытку.');
        }
    },
	getPageName: function () {
		let pageName = window.location.pathname;
        let pageid = we_helper.getPageId();
		if (pageName === "/") {
			pageName = "/Home";
        } else if (pageid !== null) {
            pageName += "?pageid=" + pageid;
		}
		return pageName; 
    },
    getPageId: function () {
        return we_helper.urlParam("pageid");
    },
    clearModal: function (_modal, _data) {
        we_helper.clearData(_data);
        if (_modal) {
            _modal.find(':input:not([readonly])').val("").removeAttr("disabled");
            _modal.find('textarea').val("");
            _modal.removeClass('was-validated');
            _modal.find('.select2').val([0]).trigger('change');
            _modal.find("[type=checkbox]").prop('checked', false);
        }
    },
    clearData: function (_data) {
        if (_data) {
            $.each(_data, function (key) {
                _data[key] = null;
            });
        }
    },
    dataToUrlParam: function (_data) {
        let tmp = "";
        $.each(_data, function (key) {
            if (_data[key] != null) {
                tmp += "&" + key + "=" + _data[key];
            }
        });
        return tmp;
    },
    searchToObject: function () {
        var pairs = window.location.search.substring(1).split("&"),
            obj = {},
            pair,
            i;

        for (i in pairs) {
            if (pairs[i] === "") continue;

            pair = pairs[i].split("=");
            obj[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
        }

        return obj;
    },
    checkValidation: function (o_sender) {
        $this = $(o_sender);
        o_sender.find($('input[name]')).each(function (key, element) {
            let $el = $(element);
            if ($el.prop('required') && $el.attr('type') !== "checkbox") {
                let vl = $el.val();
                if (vl) {
                    $el.val(vl.trim());
                }
            }
            // Проверка на целое число.
            if ($el.attr('pattern') === "^[0-9]*$") {
                if (!isFinite($el.val()) && $el.val() !== parseInt($el.val(), 10))
                    $el.val("");
            }
        });

        $this.addClass("was-validated");

        let err_count = $this.find(".form-control\:invalid").length;
        if (err_count == 0) {
            $this.removeClass("was-validated");
            return true;
        }
        return false;
    },
    showLoader: function (selector) {
        if (!selector) {
            selector = '.loader-fade';
        }
        $(selector).fadeIn(100);
    },
    hideLoader: function (selector) {
        if (!selector) {
            selector = '.loader-fade';
        }
        $(selector).fadeOut(100);
    },
    initDatePicker: function (datePicker) {
        datePicker.datepicker({
            language: 'ru',
            format: 'dd.mm.yyyy'
        });
    },
    initTimePicker: function (timePicker) {
        timePicker.datetimepicker({
            format: 'HH:mm',
            locale: 'ru',
            stepping: 5
        });
    },
    initDateTimePicker: function (dateTimePicker) {
        dateTimePicker.datetimepicker({
            locale: 'ru',
            format: 'DD.MM.YYYY HH:mm',
            icons: {
                time: "mdi mdi-clock-outline", 
                date: "mdi mdi-calendar",
                up: "mdi mdi-chevron-up",
                down: "mdi mdi-chevron-down",
                previous: "mdi mdi-chevron-left",
                next: "mdi mdi-chevron-right",
                today: "mdi mdi-crosshairs",
                clear: "mdi mdi-delete",
                close: "mdi mdi-close"
            }
        });
    },
    urlParam: function (name) {
        var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
        if (!results) {
            return null;
        }
        return results[1] || null;
    },
    newGuid: function () {
        var d = new Date().getTime();
        var id = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
        });
        return id;
    },
    /**
     * Метод получения данных для страницы.
     * 
     * @param {String} _url Путь запроса.
     * @param {Object} _data Дополнительные данные.
     * @param {Object} _bindtype: query, body тип привязки данных.
     * @param {Function} callback Функция обратного вызова.
     * @param {Boolean} isload Отключение loader.
     */
    getDataDB: function (_url, _data, _bindtype, _offloader, callback) {
        if (!_offloader) {
            we_helper.showLoader();
        }
        let _settings = {};
        switch (_bindtype) {
            case "query": {
                _settings = {
                    type: 'GET',
                    data: _data,
                };
                break;
            }
            case "body": {
                _settings = {
                    type: 'POST',
                    datatype: 'json',
                    contentType: 'application/json', 
                    data: JSON.stringify(_data),
                };
                break;
            }
            default: {
                we_helper.alert('Hе удалось установить тип привязки данных. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                return;
            }
        } 
        $.ajax($.extend({ 
            url: _url,
            cache: false,
            success: function (response) {
                if (response.result == 1) {
                    if (callback) {
                        callback(response.data);
                    }
                } else {
                    we_helper.hideLoader();
                    we_helper.alert(response.message, notificatioType.danger);
                }
            },
            error: function (err) {
                we_helper.hideLoader();
                we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
            }
        }, _settings));
    }, 
    /**
     * Метод добавления/редактирования записи. 
     * @param {any} s_url Путь к методу.
     * @param {any} o_data Объект отправки.
     * @param {any} callback Функция обратного вызова.
     */
    updateDataDB: function (s_url, o_data, callback, showLoader) {
        if (showLoader === undefined || showLoader === null || showLoader === true) {
            we_helper.showLoader();
        }
        $.ajax({
            url: s_url,
            type: 'POST',
            cache: false,
            data: o_data,
            success: function (response) {
                if (response.result == 1) {
                    if (callback && !!response.data) {
                        callback(response.data);
                    } else if (callback && !response.data) {
                        we_helper.alert("Данные успешно сохранены.", notificatioType.success);
                        callback();
                    } else {
                        we_helper.alert("Данные успешно сохранены.", notificatioType.success);
                        we_helper.hideLoader();
                    }
                } else {
                    we_helper.hideLoader();
                    we_helper.alert(response.message, notificatioType.danger);
                } 
            },
            error: function (err) {
                we_helper.hideLoader();
                we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
            }
        });
    },
    /**
     * Метод загрузки файла.
     * @param {any} s_url
     * @param {any} f_data
      * @param {any} callback Функция обратного вызова.
     */
    uploadFile: function (s_url, f_data, callback) {
        we_helper.showLoader();
        $.ajax({
            url: s_url,
            type: "POST",
            contentType: false,
            processData: false,
            data: f_data,
            success: function (response) {
                if (response.result == 1) {
                    we_helper.alert("Данные успешно сохранены.", notificatioType.success);

                } else {
                    we_helper.alert(response.message, notificatioType.danger);
                }

                if (callback) {
                    callback();
                } else {
                    we_helper.hideLoader();
                }
            },
            error: function (err) {
                we_helper.hideLoader();
                we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
            }
        });
    },
    /**
     * Метод передачи данных на добавления/редактирования записи. (Обертка метода updateDataDB).
     * @param {Object} o_modal Модальное окно.
     * @param {String} s_url Путь к методу, который будет вызываться.
     * @param {Object} o_data Данные для отправки.
     */
    updateRecordDb: function (o_modal, s_url, o_data, callback) {
        o_data = $.extend(o_data, we_helper.getFormData(o_modal));
        we_helper.updateDataDB(s_url, o_data, callback);
        we_helper.clearModal(o_modal, o_data);
    },
    /**
     * Метод передачи данных на удаление  записи.
     * @param {String} s_url Путь к методу, который будет вызываться.
     * @param {Object} ids Данные для отправки.
      * @param {any} callback Функция обратного вызова.
     */
    deleteDataDB: function (s_url, data, callback, alert_users) {
        data["notify"] = false;
        let msg = "Вы уверены, что хотите удалить выбранные записи (" + data.ids.length + ")?";
        if (!!alert_users) {
            msg += '<div class="col-12 form-group align-self-center pt-3">' +
                '<input type="checkbox" id="deleteDataAlertUsers" class="delete-data-alert-users" />' +
                '<label for="deleteDataAlertUsers" title="Уведомить пользователей об изменениях"></label> - Уведомить пользователей об изменениях' +
                '</div>';
        }
        bootbox.confirm({
            message: msg,
            swapButtonOrder :true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    let $delete_data_notify = $(".delete-data-alert-users");
                    if ($delete_data_notify.length != 0) {
                        data["notify"] = $delete_data_notify.prop("checked");
                    }
                    $.ajax({
                        url: s_url,
                        type: 'POST',
                        cache: false,
                        data: data,
                        success: function (response) {
                            if (response.result == 1) {
                                we_helper.alert("Данные успешно удалены.", notificatioType.success);

                            } else {
                                we_helper.alert(response.message, notificatioType.danger);
                            }

                            if (callback) {
                                callback();
                            } else {
                                we_helper.hideLoader();
                            }
                        },
                        error: function (err) {
                            we_helper.hideLoader();
                            we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                        }
                    });
                }
            }
        });
    },
    copyDataDB: function (s_url, ids, callback) {
        bootbox.confirm({
            message: "Вы уверены, что хотите выполнить создание копии для выбранных записей (" + ids.length + ")?",
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    $.ajax({
                        url: s_url,
                        type: 'POST',
                        cache: false,
                        data: { ids: ids },
                        success: function (response) {
                            if (response.result == 1) {
                                we_helper.alert("Данные успешно скопированы.", notificatioType.success);

                            } else {
                                we_helper.alert(response.message, notificatioType.danger);
                            }

                            if (callback) {
                                callback();
                            } else {
                                we_helper.hideLoader();
                            }
                        },
                        error: function (err) {
                            we_helper.hideLoader();
                            we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                        }
                    });
                }
            }
        });
    },
    clearDataDB: function (s_url, callback) {
        bootbox.confirm({
            message: "Вы уверены, что хотите выполнить очистку данных?",
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    $.ajax({
                        url: s_url,
                        type: 'POST',
                        cache: false, 
                        success: function (response) {
                            if (response.result == 1) {
                                we_helper.alert("Данные успешно очищены.", notificatioType.success);

                            } else {
                                we_helper.alert(response.message, notificatioType.danger);
                            }

                            if (callback) {
                                callback();
                            } else {
                                we_helper.hideLoader();
                            }
                        },
                        error: function (err) {
                            we_helper.hideLoader();
                            we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                        }
                    });
                }
            }
        });
    },
    syncZupDataDB: function (s_url, data, callback) {
        let msg = "Вы уверены, что хотите выполнить синхронизацию справочных данных с ЦС «ЗУП»?";
        bootbox.confirm({
            message: msg,
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    $.ajax({
                        url: s_url,
                        type: 'POST',
                        cache: false,
                        data: data,
                        success: function (response) {
                            if (response.result == 1) {
                                we_helper.alert("Синхронизация выполнена успешно", notificatioType.success);

                            } else {
                                we_helper.alert(response.message, notificatioType.danger);
                            } 
                            if (callback) {
                                callback();
                            } else {
                                we_helper.hideLoader();
                            }
                        },
                        error: function (err) {
                            we_helper.hideLoader();
                            we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                        }
                    });
                }
            }
        });
    },
	/**
	 * Метод отображение модального окна с установкой титула, сообщения.
	 * @param {String} confirmTitle Сообщение в шапке модального окна.
	 * @param {String} confirmMsg Сообщение в теле модального окна.
	 * @param {any} callback Функции после выполнения основной функции.
	 */
    updateDataDbWithConfirm: function (confirmTitle, confirmMsg, callback) {
        bootbox.confirm({
            title: confirmTitle,
            message: confirmMsg,
            buttons: {
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span>Да",
                    className: 'btn-sm btn-success'
                },
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span>Нет",
                    className: 'btn-sm btn-danger'
                }
            },
            callback: function (result) {
                if (result)
                    callback();
            }
        });
    },
    /**
     * Функция инициализации таблицы.
     * @param {Object} o_sender Объект для привязки плагина.
     * @param {Object} options Настройки плагина. Обязательные поля объекта: <ul>
     * <li>@param {Array} url Ссылка для отправки запроса.</li>
     * <li>@param {Array} colNames Массив названий полей (порядок важен).</li>
     * <li>@param {Array} colModel Массив объектов моделей (порядок важен).</li>
     * <li>@param {String} sortOrder Пареметр сортировки таблицы.</li>
     * <li>@param {String} sortName Поле сортировки таблицы.</li>
     * </ul>
     */
    initJqGrid: function (o_sender, options, _postData, callback) {
        let settings = $.extend({ 
            uid: "",
            rowNum: 50,
            autowidth: true,
            mtype: 'POST',
            datatype: 'json',
            ajaxGridOptions: { contentType: 'application/json' },
            postData: _postData, 
            serializeGridData: function (data) {
                return JSON.stringify(data, function (key, value) {
                    if (typeof value === 'function') {
                        return value();
                    } else {
                        return value;
                    }
                });
            },
            loadonce: false,
            pager: true,
            idPrefix: "g1_",
            guiStyle: "bootstrap4",
            rownumbers: true,
            rowList: [10, 25, 50, 100, 500],
            viewrecords: true,
            height: '100%',
            subTable: false,
            auto_height: false,
            widthContainer: ".container-fluid",
            jsonReader: {
                root: "rows",
                page: "page",
                total: "total",
                records: "records",
                repeatitems: false
            },
            loadComplete: function (response) {
                if (response && response.result === 0) {
                    we_helper.alert(response.message, notificatioType.danger);
                }
                we_helper.hideLoader();
            },
            gridComplete: function () {
                if (!!options["uid"]) { 
                    we_helper.setCache('grid_' + options.uid, {
                        sortname: o_sender.getGridParam('sortname'),
                        sortorder: o_sender.getGridParam('sortorder'),
                        rowNum: o_sender.getGridParam('rowNum')
                    });
                }
                if (callback) {
                    callback();
                }
            },
            loadError: function (jqXHR, textStatus, errorThrown) {
                we_helper.alert(jqXHR.status + ' ' + errorThrown, notificatioType.danger); 
            }
        }, options);

        if (!!settings.uid) {
            settings = $.extend(settings, we_helper.getCache('grid_' + settings.uid));
        }
        o_sender.jqGrid(settings);

        // Изменение размера таблицы.
        $(window).bind("resize", function () {
            o_sender.jqGrid("setGridWidth",
                o_sender.closest(settings.widthContainer).width());

            let height = $(window).height(),
                height_grid = height - 210;

            if (!!settings.corr_height) {
                if (Math.floor(settings.corr_height) === 0) {
                    height_grid *= settings.corr_height;
                } else {
                    height_grid += settings.corr_height;
                }
            }

            if (settings.auto_height)
                height_grid = "auto";

            o_sender.jqGrid("setGridHeight", height_grid);
        }).triggerHandler("resize");
    },
    reloadJqGrid: function ($table, _postData, _page) {
        if (!_page) {
            _page = $table.getGridParam('page');
        }
        $table.setGridParam({
            page: _page,
            datatype: 'json',
            postData: _postData
        }).trigger("reloadGrid");
    },
    initAnswersJqGrid: function ($table, subgrid_id, row_id, uid, cor_width) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let questionid = row_id.split('_')[1];
        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            uid: uid,
            postData: {
                questionid: questionid,
                pageid: "answer"
            },
            url: "/Designer/GetRecords",
            colNames: [
                '', 'Код', 'Ответ', 'Ассоциация', 'Верно', 'Эталон', 'Точность', 'Дата изменения', 'Изменил'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num', hidden: true },
                { name: "name", sortable: true, align: 'left', width: 150, index: 'name', hidden: true },
                { name: "conformity", sortable: true, align: 'left', width: 150, index: 'conformity', hidden: true },
                {
                    name: "correct", sortable: true, align: 'center', width: 30, index: 'correct', hidden: true,
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.correct) {
                            return 'ДА';
                        }
                        return 'НЕТ';
                    }
                },
                { name: "numeric", sortable: true, align: 'left', width: 100, index: 'numeric', hidden: true },
                { name: "prec", sortable: true, align: 'left', width: 100, index: 'prec', hidden: true },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 30, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 40, index: 'userHasChanged' },
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        }, null, function () {
            let row = $table.jqGrid('getRowData', "g1_" + questionid);
            if (!!row) {
                if (row.questType === "0") {
                    $("#" + subgrid_table_id).showCol(["num", "name", "correct"]);
                } else if (row.questType === "1") {
                    $("#" + subgrid_table_id).showCol(["num", "name"]);
                } else if (row.questType === "2") {
                    $("#" + subgrid_table_id).showCol(["name", "conformity"]);
                } else if (row.questType === "3") {
                    $("#" + subgrid_table_id).showCol(["numeric", "prec"]);
                }
            }
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * cor_width);
        }).trigger('resize');
    }, 
    initJqTreeGrid: function (o_sender, options,  callback) {
        let settings = $.extend({
            datatype: "local",
            treedatatype: "json",
            height: 'auto',
            autowidth: true,
           // iconSet: "fontAwesome",
            guiStyle: "bootstrap4",
            treeGrid: true,
            treeGridModel: 'adjacency',
            ExpandColumn: 'name',
            loadComplete: function (response) {
                if (response && response.result === 0) {
                    we_helper.alert(response.message, notificatioType.danger);
                }
                we_helper.hideLoader();
            },
            gridComplete: function () {
                if (callback) {
                    callback();
                }
            },
            loadError: function (jqXHR, textStatus, errorThrown) {
                we_helper.alert(jqXHR.status + ' ' + errorThrown, notificatioType.danger);
            }
        }, options);

        o_sender.jqGrid(settings);

        $(window).bind("resize", function () {
            o_sender.jqGrid("setGridWidth", o_sender.closest(".container-fluid").width());
        }).triggerHandler("resize");
    },
    reloadJqTreeGrid: function ($table, _postData, _page) {
        if (!_page) {
            _page = $table.getGridParam('page');
        }
        $table.setGridParam({
            page: _page,
            datatype: 'json',
            postData: _postData
        }).trigger("reloadGrid");
    },
    jqGridTreeExpandToNode: function (o_tree, row) {
        if (row != null && row.parent) {
            let parentRow = o_tree.jqGrid('getLocalRow', row.parent);
            if (parentRow != null) {
                if (!parentRow.expanded) {
                    o_tree.jqGrid('expandNode', parentRow).jqGrid('expandRow', parentRow);
                }
                we_helper.jqGridTreeExpandToNode(o_tree, parentRow);
            }
        }
    },
    /**
     * Метод собирает все значения инпутов с формы.     
     * @param {Object} o_form Объект формы.
     */
    getFormData: function (o_form, a_class) {
        let filter = "[name]";
        if (a_class) {
            filter += "." + a_class;
        }

        let a_data = {},
            a_jq_values = o_form.find($(filter));

        if (!!a_jq_values) {
            a_jq_values.each(function (key, element) {
                if ($(element).attr('type') === "checkbox") {
                    a_data[$(element).attr('name')] = $(element).is(":checked");
                } else if ($(element).attr('type') === "number") {
                    a_data[$(element).attr('name')] = $(element).val().replace('.', ',');
                } else {
                    a_data[$(element).attr('name')] = $(element).val();
                }
            });
        }

        return a_data;
    },
	/**
     * Метод устанавливает значения в инпуты на форме.
     * @param {Object} o_form Объект формы.
     * @param {Object} data Данные для заполнения.
	 * @param {Object} a_class доп класс для фильтра элементов
     */
    setFormData: function (o_form, data, a_class) {
        if (data) {
            let filter = "[name]";
            if (a_class) {
                filter += "." + a_class;
            }

            o_form.find($(filter)).each(function (key, element) {
                let $el = $(element);
                let vl = data[$el.attr('name')];
                if ($el.is("label")) {
                    $el.text(vl);
                } else if ($el.is('textarea')) {
                    $el.val(vl);
                } else if ($el.is("input")) {
                    if ($el.attr('type') === "checkbox") {
                        $el.prop('checked', vl);
                    } else if ($el.attr('type') !== "hidden" || !$el.attr('readonly')) {
                        $el.val(vl);
                    } 
                } else if ($el.is("select")) {
                   /* //if ($el.attr("multiple") !== undefined) {
                    //    if (!!vl && vl.length !== 0) {
                    //        if (typeof vl[0] === 'object' && vl[0] !== null) {
                    //            let arr = [];
                    //            for (var i = 0; i < vl.length; i++) {
                    //                arr.push(vl[i].id);
                    //                if ($el.find("option[value='" + vl[i].id + "']").length === 0) {
                    //                    $el.append(new Option(vl[i].text, vl[i].id));
                    //                }
                    //            }
                    //            $el.val(arr);
                    //        } else {
                    //            $el.val(vl);
                    //        }
                    //    }
                    //}
                    //else {
                    //    if (!!vl) {
                    //        let optionName = $el.attr("option-name");
                    //        if (!!optionName && $el.find("option[value='" + vl + "']").length === 0) {
                    //            $el.append(new Option(data[optionName], vl));
                    //        }
                    //        $el.val(vl);
                    //    } else if ($el.prop('required')) {
                    //        $el.find('option:eq(0)').prop('selected', true);
                    //    }
                    //}*/
                    if (!!vl && vl !== we_helper.getEmptyGuid()) {
                        let optionName = $el.attr("option-name");
                        if (!!optionName) {
                            let arr = [];
                            if ($el.attr("multiple") === undefined) {
                                arr.push(vl);
                            } else {
                                arr = vl;
                            }

                            let dt_opt = data[optionName];
                            if (!!dt_opt) {
                                var names = dt_opt.split(',');
                                for (var i = 0; i < arr.length; i++) {
                                    if ($el.find("option[value='" + arr[i] + "']").length === 0) {
                                        $el.append(new Option(names[i], arr[i]));
                                    }
                                }
                            }
                        }
                        $el.val(vl);
                    } else if ($el.prop('required')) {
                        $el.find('option:eq(0)').prop('selected', true);
                    }

                    if ($el.hasClass('select2')) {
                        $el.trigger('change');
                    }
                }
            });
        }
    },
    /**
     * Метод конвертирует в дату вида: DD.MM.YYYY
     * @param {any} date
     */
    convertDate: function (date) {
        return moment.parseZone(date).format("DD.MM.YYYY");
    },
    /**
     * Метод конвертирует в дату вида: DD.MM.YYYY HH:mm:ss
     * @param {any} date
     */
    convertDateFull: function (date) {
        return moment.parseZone(date).format("DD.MM.YYYY HH:mm:ss");
    },
    /**
     * Метод конвертирует в дату вида: DD.MM.YYYY HH:mm
     * @param {any} date
     */
    convertDateMin: function (date) {
        return moment.parseZone(date).format("DD.MM.YYYY HH:mm");
    },
    convertDateToTime: function (date) {
        return moment.parseZone(date).format("HH:mm");
    },
    /**
     * Метод генерации года от текущего.
     * @param {any} offset Смещение. Пример: offset=3, 2019-2016.
      */
    generationYear: function (offset) {
        let currentYear = new Date().getFullYear(),
            year = [];

        for (let i = currentYear - offset; i <= currentYear; i++)
            year.unshift({ id: i, text: i });

        return year;
    },
    fillSelect: function (data, o_select, callback) {
        let count = 0,
            option = '';

        if (!o_select.prop('required') && !o_select.prop('multiple')) {
            option = '<option value="">...</option>';
        }

        if (data) {
            $.each(data, function (key, value) {
                option += '<option value="' + value.id + '">' + value.text + '</option>';
                count++;
            });
        }

      //  o_select.html(option).selectpicker('refresh');

        if (callback) {
            callback(count);
        }
    },
    loadModalSelect: function (url, o_select, data, callback) {
        we_helper.getDataDB(url, data, "query", false, function (entity) {
            $.each(o_select, function (key, value) {
                we_helper.fillSelect(entity, $(value), callback);
            });
        });
    },
    selectToSelect2: function (o_select, required, callback) {
        let opt = {
            theme: "bootstrap",
            width: '100%',
            delay: 500,
            language: "ru",
            placeholder: null,
            allowClear: false,
            containerCssClass: "select2-sm"
        };

        if (!required) {
            opt.placeholder = '. . .';
            opt.allowClear = true;
        }

        if (o_select.attr("multiple") !== undefined) {
            opt.closeOnSelect = false;
        }

        o_select.select2($.extend(opt, {
            minimumResultsForSearch: Infinity,
        }));

        if (callback) {
            callback();
        }
    },
    initSelect: function (_url, _select, _data, _live_search, _required, callback, onSelect) {
        let option = {
            theme: "bootstrap",
            width: '100%',
            delay: 500,
            language: "ru",
            placeholder: null,
            allowClear: false,
            containerCssClass: "select2-sm"
        };

        if (!_required) {
            option.placeholder = '. . .';
            option.allowClear = true;
        }

        if (_select.attr("multiple") !== undefined) {
            option.closeOnSelect = false;
            option.containerCssClass = "";
        }
       
        if (!!_live_search) {
            _select.select2(
                $.extend(option, {
                    minimumInputLength: 1,
                    ajax: {
                        url: _url,
                        type: "POST",
                        dataType: 'json', 
                        contentType: 'application/json',
                        data: function (params) {
                            if (!_data) {
                                _data = {};
                            }
                            _data["search_data"] = params.term;
                            return JSON.stringify(_data, function (key, value) {
                                if (typeof value === 'function') {
                                    return value();
                                } else {
                                    return value;
                                }
                            });
                        },
                        cache: false,
                        processResults: function (response) {
                            if (response.result == 1) {
                                return {
                                    results: response.data
                                };
                            }
                            we_helper.alert(response.message, notificatioType.danger);
                            return {
                                results: []
                            };
                        }
                    }
                })).on('select2:select', function (e) {
                    if (onSelect) {
                        onSelect(e.params.data);
                    }
                });
            if (callback) {
                callback();
            }
        } else {
            we_helper.getDataDB(_url, _data, "body", false, function (entity) {
                _select.select2($.extend(option, {
                    minimumResultsForSearch: Infinity,
                    data: entity
                }));
                we_helper.hideLoader();
                if (callback) {
                    callback();
                }
            });
        }
    },
    /**
     * Метод обработки моножественного выбора.
     * @param {Object} o_sender Чекбокс по которому кликают.
     * @param {Array} checkedRows Результирующий массив.
     */
    multipleSelection: function (o_sender, checkedRows) {
        let id = o_sender.attr("attr-id"),
            index = $.inArray(id, checkedRows);

        if (o_sender.is(":checked") && index === -1) {
            checkedRows.push(id);
        } else if (!o_sender.is(":checked") && index !== -1) {
            checkedRows.splice(index, 1);
        }
    },
    /**
     * Метод обработки выбора всех элементов таблицы.
     * @param {Object} a_checkbox Массив объектов checkbox
     * @param {Object} o_check_all checkbox выбрать все.
     * @param {Array} checkedRows Результирующий массив.
     */
    selectAllRows: function (a_checkbox, check_all, checkedRows) {
        $.each(a_checkbox, function (k, el) {
            $(el).prop('checked', check_all);
            we_helper.multipleSelection($(el), checkedRows)
        });
    },
    /**
     * Проверяет все ли checkbox в таблице выбранны, если true, тогда устанавливает CheckAll.
     * @param {Object} a_checkbox Массив объектов checkbox
      */
    isAllSelected: function (a_checkbox) {
        let all_selected = true;
        $.each(a_checkbox, function (k, el) {
            if (!$(el).is(":checked")) {
                return all_selected = false;
            }
        });
        return all_selected;
    },
    /**
     * Метод добавления cache.
     * @param {String} key
     * @param {Object} a_data
     */
    setCache: function (key, a_data) {
        localStorage[key] = JSON.stringify(a_data);
    },
    /**
     * Метод получения cache.
     * @param {String} key
     */
    getCache: function (key) {
        let data = localStorage[key],
            cache_data = null;
        if (data) {
            cache_data = JSON.parse(data);
        }
        return cache_data;
    },
    existInCache: function (key) {
        return !!localStorage[key];
    },
    removeCache: function (key) {
        localStorage.removeItem(key);
    },
    /**
     * Метод сравнения дат, начальной и конечной.
     * @param {any} o_dt_start
     * @param {any} o_dt_end
     */
    checkValidEndStartDate: function (o_dt_start, o_dt_end) {
        let dt_end = moment(o_dt_end.val(), 'DD.MM.YYYY HH:mm'),
            dt_start = moment(o_dt_start.val(), 'DD.MM.YYYY HH:mm'),
            fl_valid = false;

        if (dt_end) {
            if (Date.parse(dt_start) <= Date.parse(dt_end))
                fl_valid = true;
            else
                o_dt_end.val("");
        }

        return fl_valid;
    },
    setBreadcrumb: function (breadcrumb) {
        if (breadcrumb === undefined) {
            return;
        }
        let container = $(".breadcrumb");
        $.each(breadcrumb, function (index, crumb) {
            if (!!crumb.path) {
                container.append('<li class="d-none d-md-inline breadcrumb-item"><a href="' + crumb.path + '">' + crumb.page + '</a></li>');
            } else {
                container.append('<li class="breadcrumb-item active">' + crumb.page + '</li>');
                $("head > title").html(crumb.page);
            }
        });
    },
    shuffleArray: function (array) {
        var currentIndex = array.length, randomIndex;
        // While there remain elements to shuffle...
        while (currentIndex != 0) {
            // Pick a remaining element...
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex--;
            // And swap it with the current element.
            [array[currentIndex], array[randomIndex]] = [
                array[randomIndex], array[currentIndex]];
        }
        return array;
    }
};