﻿function delim(c) {
    return c == ' ';
}

function is_op(c) {
    return c == '+' || c == '-' || c == '*' || c == '/' || c == '%';
}

function priority(op) {
    if (op < 0) {
        return 4;
    } // op == -'+' || op == -'-'
    else
        if (op == 43 || op == 45) {
            return 1;
        }
        else
            if (op == 42 || op == 47 || op == 37) {
                return 2;
            }
            else {
                return -1;
            }
}

function process_op(st, op) {
    if (op < 0) {
        var l = back(st); st.pop();
        switch (Math.abs(op)) {
            case 43: st.push(l); break;
            case 45: st.push(-l); break;
        }
    }
    else {
        var r = back(st); st.pop();
        var l = back(st); st.pop();
        switch (op) {
            case 37: st.push(l % r); break;
            case 42: st.push(l * r); break;
            case 43: st.push(l + r); break;
            case 45: st.push(l - r); break;
            case 47: st.push(l / r); break;
        }
    }
}

function back(arr) {
    return arr[arr.length - 1];
}

function empty(arr) {
    return  arr.length ==0;
}

function isAlnum(aChar) {
    return (isDigit(aChar) || isAlpha(aChar));
}

function isDigit(aChar) {
    myCharCode = aChar.charCodeAt(0);

    if ((myCharCode > 47) && (myCharCode < 58)) {
        return true;
    }

    return false;
}

function isAlpha(aChar) {
    myCharCode = aChar.charCodeAt(0);

    if (((myCharCode > 64) && (myCharCode < 91)) ||
      ((myCharCode > 96) && (myCharCode < 123))) {
        return true;
    }

    return false;
}

$.rpn_calc = function (s) {
    var may_unary = true;
    var st = [], op = [];
    for (var i = 0; i < s.length; ++i) {
        if (!delim(s[i])) {
            if (s[i] == '(') {
                op.push('('.charCodeAt(0));
                may_unary = true;
            }
            else if (s[i] == ')') {
                while (back(op) != '('.charCodeAt(0)) {
                    process_op(st, back(op));
                    op.pop();
                }
                op.pop();
                may_unary = false;
            }
            else if (is_op(s[i])) {
                var curop = s[i].charCodeAt(0);
                if (may_unary) curop = -curop;
                while (!empty(op) && (
					curop >= 0 && priority(back(op)) >= priority(curop)
					|| curop < 0 && priority(back(op)) > priority(curop))
					) {
                    process_op(st, back(op));
                    op.pop();
                }
                op.push(curop);
                may_unary = true;
            }
            else {
                var operand = "";
                while (i < s.length && (isAlnum(s[i])||s[i]=='.')) {
                    operand += s[i++];
                }
                --i;
                if (isDigit(operand[0]))
                    st.push(parseFloat(operand));
                may_unary = false;
            }
        }
    }
    while (!empty(op)) {
        process_op(st, back(op));
        op.pop();
    }
    return back(st);
}
 