﻿var we_testing = {
    buildTestingAdditionalUrl: function (urlParam) {
        let url = "";
        if (urlParam.programid !== null) {
            url += "&programid=" + urlParam.programid;
        }
        if (urlParam.groupid !== null) {
            url += "&groupid=" + urlParam.groupid;
        }
        if (urlParam.filialid !== null) {
            url += "&filialid=" + urlParam.filialid;
        }
        if (urlParam.controltype !== null) {
            url += "&controltype=" + urlParam.controltype;
        }
        return url;
    },
    gotoTestingByTheme: function (protocolThemeInfo, addUrl, target) {
        if (addUrl === undefined || addUrl === null) {
            addUrl = "&protocolid=" + protocolThemeInfo.protocolId + "&themeid=" + protocolThemeInfo.id;
            let params = window.location.search.split('&');
            if (params.length > 2) {
                for (var i = 2; i < params.length; i++) {
                    addUrl += "&" + params[i];
                }
            }
        } else {
            addUrl = "&protocolid=" + protocolThemeInfo.protocolId + "&themeid=" + protocolThemeInfo.id + addUrl;
        }
        if (target === undefined || target === null) {
            target = '_self';
        }
        switch (protocolThemeInfo.componentType) {
            case 0: {
                window.open("testing?pageid=testtheorytasks" + addUrl, target);
                break;
            }
            case 1: {
                window.open("testing?pageid=testtrainings" + addUrl, target);
                break;
            }
            case 2: {
                window.open("testing?pageid=testsequencetasks" + addUrl, target);
                break;
            }
            case 3: {
                window.open("testing?pageid=testprogrammabletasks" + addUrl, target);
                break;
            }
            default: {
                we_helper.alert("Не удалось определить тип задания. Обновите страницу и повторите попытку.", notificatioType.danger);
            }
        }
    },
    finishTestingByTheme: function (protocolId, themeId, isTimeOff, isEnd, callback) {
        we_helper.updateDataDB("/Testing/FinishTestingByTask", {
            protocolId: protocolId,
            themeId: themeId,  
            isTimeOff: isTimeOff,
            isEnd: isEnd
        }, function (entity) {
            if (callback) {
                callback(entity);
            }
        });
    },
    goToTestingProtocol: function (protocolId, addUrl) {
        let stamp = (new Date()).getTime();
        window.open("testing?pageid=testprotocol&protocolid=" + protocolId + addUrl + "&tstamp=" + stamp, "_self");
    },
    createTimer: function (testTime, onStopTesting) {
        var startTime = testTime;
        var endTime = "00:00";
        if (testTime === null) {
            startTime = "00:00";
            endTime = testTime;
        }

        let timer = $(".timer").testTimer({
            startTime: startTime,
            endTime: endTime,
            onEndedTime: function (isTime) {
                if (isTime) {
                    alert("Время контроля истекло!");
                }
                if (onStopTesting) {
                    onStopTesting("stop-test");
                }
            }
        });
        timer.init();

        return timer;
    },
    createFinishBtn: function (isLastModule) {
        if (isLastModule) {
            let container = $(".btn-finish-container");
            $(".dropdown-toggle-split, .dropdown-menu", container).addClass('d-none');
            let btn = $(".stop-testing-first", container);
            btn.attr("attr-id", "stop-test").attr("title", "Завершить контроль");
            $(".d-lg-inline-block", btn).text("Завершить контроль")
            btn.parent().removeClass("btn-group");
        }
    },
    createAnswers: function (questType, answers, $listAnswers) {
        $listAnswers.html("");
        let shuffleAnsw = we_helper.shuffleArray(answers.slice());
        shuffleAnsw.forEach(function (el, index) {
            let control = "";
            if (questType === 0) {
                control = we_testing.createMultipleChoiceAnswer(el);
            } else if (questType === 1) {
                control = we_testing.createSequenceDefinitionAnswer(el);
            } else if (questType === 2) {
                control = we_testing.createEstablishmentConformityAnswer(index + 1, answers[index], el);
            } else if (questType == 3) {
                control = we_testing.createNumericalAnswer(el);
            }
            if (control.length > 0) {
                $listAnswers.append('<li class="list-group-item" style="border:none; padding: .15rem 2.5rem;">' + control + '</li>');
            }
        });
    },
    createMultipleChoiceAnswer: function (answ) {
        let checked = !!answ.answer ? "checked" : "";
        return '<div class="custom-control custom-checkbox">' +
            '<input type="checkbox" ' + checked +
            ' class="answer-input custom-control-input" id="' + answ.id + '">' +
            '<label class="custom-control-label" for="' + answ.id + '">' + answ.name + '</label>' +
            '</div>';
    },
    createNumericalAnswer: function (answ) {
        return '<input style="max-width:150px; min-width:150px;" id="' + answ.id + '" type="number" step="0.00001" placeholder="Введите число..."' +
            ' class="answer-input form-control form-control-sm" value="' + answ.answer + '">';
    },
    createEstablishmentConformityAnswer: function (index, answ, shuffle) {
        let lb = '<strong>' + index + '.</strong> ';
        if (index != answ.name) {
            lb += answ.name;
        }

        return '<div class="row">' +
            '<div class="col-5">' +
            '<label class="col-sm-12 col-form-label col-form-label-sm">' + lb + '</label>' +
            '</div>' +
            '<div class="col-7">' +
            '<div class="row">' +
            '<div class="col-sm-auto">' +
            '<input style="min-width:60px;max-width:60px;" id="' + shuffle.id + '" type="number" min="0" max="20" step="1" value="' + shuffle.answer + '" class="answer-input form-control form-control-sm">' +
            '</div>' +
            '<label class="col-sm-8 col-form-label col-form-label-sm">' + shuffle.conformity + '</label>' +
            '</div>' +
            '</div>' +
            '</div>';
    },
    createSequenceDefinitionAnswer: function (answ) {
        return '<div class="row">' +
            '<div class="col-sm-auto">' +
            '<input style="max-width:60px; min-width:60px;" min="0" max="30" step="1" id="' + answ.id + '" type="number" value="' + answ.answer + '" class="answer-input form-control form-control-sm">' +
            '</div>' +
            '<label class="col-sm-10 col-form-label col-form-label-sm">' + answ.name + '</label>' +
            '</div>';
    },

};