﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _table_selected_rows: [],
    _search: null,
    $search_panel: $('.js_search_panel'),
    $table: $(".js_table"),
    init: function () {
        we_helper.setBreadcrumb([{ page: "Пользователь", path: "#" }, { page: "Журнал оповещений" }]);
        page.$table.on('click', 'a.js_del_table_record', function () {
            let id = $(this).attr("attr-id");
            page.deleteRecords([id], function () {
                let index = $.inArray(id, page._table_selected_rows);
                if (index !== -1) {
                    page._table_selected_rows.splice(index, 1);
                }
                we_helper.reloadJqGrid(page.$table);
            });
        });
        page.$table.on('click', 'a.js_mark_table_record', function () {
            page.markNotify([$(this).attr("attr-id")], $(this).hasClass("text-primary"), function () {
                page._table_selected_rows = [];
                we_helper.reloadJqGrid(page.$table);
            });
        });
        page.$table.on('click', '.js-select-row', function () {
            we_helper.multipleSelection($(this), page._table_selected_rows);

            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));  
        });
        page.$table.parent().on('click', '.js-select-all-row', function () {
            we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
        });
        page._search = page.$search_panel.searchPanel({
            uid: "alert_" + page._id,
            autocomplete: {
                enable: true,
                url: "/Account/GetAutocompleteRecords",
            },
            actionBtn: [
                {
                    id: "read",
                    icon: "mdi mdi-email-open",
                    style: "info",
                    text: "Отметить как прочитанные"
                },
                {
                    id: "unread",
                    icon: "mdi mdi-email",
                    style: "info",
                    text: "Отметить как непрочитанные"
                },
                {
                    id: "delete",
                    icon: "mdi mdi-delete",
                    style: "danger",
                    text: "Удалить выбранные записи"
                }
            ],
            searchParam: {
                params: [
                    { text: 'Событие', placeholder: 'Введите часть наименования события' },
                    { text: 'Сообщение', placeholder: 'Введите часть текста сообщения' },
                    { text: 'Структурная единица', placeholder: 'Введите часть наименования структурной единицы публикатора' },
                    { text: 'Публикатор', placeholder: 'Введите часть фамилии (логина) публикатора' },
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            defBtn:true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onAction: function (keyBtn, search_data) {
                switch (keyBtn) {
                    case "delete": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.deleteRecords(page._table_selected_rows, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    case "read": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.markNotify(page._table_selected_rows, true, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    case "unread": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.markNotify(page._table_selected_rows, false, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        we_helper.initJqGrid(page.$table, { 
            uid: "alert_" + page._id,
            url: "/Account/GetRecords",
            colNames: [
                '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Статус', 'Дата публикации', 'Событие', 'Сообщение', 'Структурная единица', 'Публикатор', 'Уд.',
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                {
                    name: "viewed", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        if (cellvalue) {
                            return "<a class='mdi mdi-brightness-1 text-9 text-light-gray js_mark_table_record' style='cursor:pointer;'  href='#' attr-id='" + rowObject.id + "' title='Пометить непрочитанным'></a>";
                        } else {
                            return "<a class='mdi mdi-brightness-1 text-9 text-primary js_mark_table_record' style='cursor:pointer;' href='#' attr-id='" + rowObject.id + "' title='Пометить прочитанным'></a>";
                        }
                    }
                },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "event", sortable: true, align: 'left', width: 100, index: 'event' },
                {
                    name: "message", sortable: false, align: 'left', width: 230, index: 'message',
                    formatter: function (cellvalue, options, rowObject) {
                        return rowObject.message;
                    }
                },
                { name: "filialName", sortable: true, align: 'left', width: 90, index: 'filialName' },
                { name: "userHasChanged", sortable: true, align: 'left', width: 80, index: 'userHasChanged' },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 25, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                },
            ],
            sortname: 'dateOfChange',
            sortorder: 'desc',
            beforeSelectRow: function (rowid, e) { return false; }
        }, page._search.api().get_data(), function () {
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));  
        });
    },
    deleteRecords: function (ids, callback) {
        we_helper.deleteDataDB("/Account/DeleteRecords", {
            pageid: page._id,
            ids: ids
        }, function () {
            if (callback) {
                callback();
            }
        });
    }, 
    markNotify: function (ids, viewed, callback) {
        we_helper.updateDataDB("/Account/ReadUserAlerts", { ids: ids, viewed: viewed }, function () {
            if (callback) {
                callback();
            }
        });
    }
};
