﻿$(function () {
    page.init();
    $(document).on('click', '#general-tab', function () {
        page.loadProfileData();
    });

    $(document).on('click', '#subscription-tab', function () {
        page.loadUserSubscriptions();
    });

    $(document).on('click', '.js_change_profile', function (e) {
        if (we_helper.checkValidation($("#general")) === true) {
            page.updateProfileData();
        }
        e.preventDefault();
    });

    $(document).on('click', '.js_change_subscrip', function (e) {
        page.updateUserSubscriptions();
        e.preventDefault();
    });

});

var page = {
    _id: we_helper.getPageId(),
    init: function () {
        we_helper.setBreadcrumb([{
            page: "Пользователь",
            path: "#"
        }, { page: "Учётная запись" }]);

        let $user_roles = $('.select2.js-user-roles'),
            $select_filial = $('.select2.js-filial'),
            $user_post = $('.select2.js-user-post'),
            $user_depart = $('.select2.js-user-department');

        $("#isDepartmentCurator").attr("disabled", "disabled");
        $(".js-num, .js-login").attr("disabled", "disabled");
        $user_roles.attr("disabled", "disabled");
        $select_filial.attr("disabled", "disabled");

        we_helper.initSelect('/Admin/GetRecordsKeyText', $select_filial, {
            pageid: "filial",
        }, true, true);

        we_helper.initSelect('/Admin/GetRecordsKeyText', $user_post, {
            pageid: "post",
            filialid: function () {
                return $select_filial.val();
            }
        }, true, false);

        we_helper.initSelect('/Admin/GetRecordsKeyText', $user_depart, {
            pageid: "department",
            filialid: function () {
                return $select_filial.val();
            }
        }, true, false);

        we_helper.initSelect('/Designer/GetEnums?name=roles', $user_roles, null, false, true, function () {
            $("#general").removeClass("d-none");
            page.loadProfileData();
        });
    },
    loadProfileData: function () {
        let url = !!page._id ? "/Account/GetUserProfile" : "/Admin/GetUserFromAD";
        we_helper.getDataDB(url, null, "query", false, function (entity) {
            page._data = entity;
            we_helper.setFormData($("#general"), page._data);
            we_helper.hideLoader();
        });
    },
    updateProfileData: function () {
        page._data = $.extend(page._data, we_helper.getFormData($("#general")));
        if (!!page._id) {
            we_helper.updateDataDB('/Account/UpdateUserProfile', page._data);
        } else {
            we_helper.updateDataDB('/Account/ConfirmProfile', page._data, function () {
                window.open("/home", '_self');
            });
        }
    },
    loadUserSubscriptions: function () {
        $(".js_change_subscrip").addClass("d-none");
        we_helper.getDataDB("/Account/GetUserSubscriptions", null, "query", false, function (entity) {
            let $container = $("#subscrip_container");
            if (entity.length == 0) {
                $container.html('Для вашего набора ролей подписки не предусмотрены.');
            } else {
                $container.html("");
                $.each(entity, function (i1, category) {
                    let tmp = '<div class="mt-2 col-12 col-md-6 col-lg-4"><div class="card"><h5 class="card-header">' + category.categoryName + '</h5><div class="card-body">';
                    $.each(category.userEvents, function (i2, event) {
                        tmp += '<p class="card-text"><input type="checkbox" ' + (event.isSubscrip ? "checked" : "") + ' id="' + event.id + '" /><label for="' + event.id + '"> - ' + event.eventName + '</label></p>';
                    });
                    tmp += '</div></div></div>';
                    $container.append(tmp);
                });
                $(".js_change_subscrip").removeClass("d-none");
            }
            we_helper.hideLoader();
        });
    },
    updateUserSubscriptions: function () {
        var ids = [];
        $("#subscrip_container").find("input:checkbox:checked").each(function () {
            ids.push(this.id);
        });
        we_helper.updateDataDB('/Account/UpdateUserSubscriptions', { ids: ids });
    }
};
 
        