﻿$(function () {
	page.init();
	$(window).resize(function () {
		page.resizeTree();
	});
});

var page = {
	_edition: $("#assembly-config-edition").attr("value"),
	_cur_user_filial: we_helper.getCurUserFilial(),
	_data: {},
	$tree: $(".js_filial_tree"),
	$modal: $(".js_detail_modal"),
	$dlgReportSettings: $(".js_modal_report_settings"),
	init: function () {
		we_helper.setBreadcrumb([{ page: "Администрирование", path: "#" }, { page: "Структурные единицы" }]);

		page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page.$dlgReportSettings);
		});
		$('.btn-success', page.$dlgReportSettings).on('click', function (e) {
			we_helper.getDataDB("/Admin/SaveReport", {
				pageid: "filial",
				sidx: "fullNum",
				sord: "asc",
				format: $('input[name="fileformattype"]:checked').attr("id")
			}, "body", false, function (entity) {
				window.open('../temp/' + entity, "_blank");
				we_helper.hideLoader();
			});
		});
		if (this._edition === "SO UPS") {
			$(".so-ups").removeClass("so-ups"); 
		}
		$('label.js_goto_page').on('click', function () {
			let row = page.getTreeSelectRowData();
			if (!row) {
				we_helper.alert("Функция не применима для выбранного объекта!", notificatioType.danger);
				return;
			}
			let pageid = $(this).attr("page-id");
			let url = "/admin?pageid=" + pageid,
				cache_uid = "search_admin_" + pageid;
			let cache_data = {
				filialid: row.id,
				filialname: row.name,
				removeAfterInit: !we_helper.existInCache(cache_uid)
			};
			we_helper.setCache(cache_uid, cache_data);
			window.open(url, "_self");
		});
		$("#btn-create-filial").on("click", function () {
			page.showModal("add");
		});
		$("#btn-edit-filial").on("click", function () {
			page.showModal("edit");
		});
		$("#btn-delete-filial").on("click", function () {
			let row = page.getTreeSelectRowData();
			if (!row) {
				we_helper.alert("Функция не применима для выбранного объекта!", notificatioType.danger);
				return;
			}
			we_helper.deleteDataDB("/Admin/DeleteFilial", {
				ids: [row.id]
			}, function () {
				page.setSideBarCache(row.parent);
				page.reloadTree();
			});
		});
		$("#btn-export-filials").on("click", function () {
			page.$dlgReportSettings.modal('show');
		});
		$("#btn-corporate-sync").on("click", function () {
			we_helper.syncZupDataDB("/Admin/CorporateDataSync", { pageId: 'filial' }, function () {
				we_helper.reloadJqGrid(page.$tree);
			});
		});
		page.$modal.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page.$modal, page._data);
		});
		$('.js_modal_save_change', page.$modal).on('click', function (e) {
			if (we_helper.checkValidation(page.$modal) === true) {
				page.updateRecord();
			}
			e.preventDefault();
		});
		we_helper.initSelect('/Admin/GetRecordsKeyText', $('.select2.js-filial', page.$modal), {
			pageid: "filial"
		}, true, true, null, function (_data) {
			we_helper.getDataDB("/Admin/GetNextRecordNumber", {
				pageid: "filial",
				filialid: _data.id
			}, "query", false, function (entity) {
				$("input[name=num]", page.$modal).val(entity);
				we_helper.hideLoader();
			});
		});
		we_helper.initJqTreeGrid(page.$tree, {
			url: "/Admin/GetFilialTree",
			colNames: ['id', 'Дерево оргструктуры'],
			colModel: [
				{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
				{
					name: "name", sortable: false, align: 'left', width: 150, index: 'name',
					formatter: function (cellvalue, options, rowObject) {
						let current = "";
						if (rowObject.current) {
							current = '<span class="text-danger" title="Доступ к системным данным">*</span>';
						}
						return current + "<span class='text-secondary " + page.getTreeNodeIcon(rowObject.level) + " pr-1 icon-size'></span>" + page.getZupSyncNodeIcon(rowObject.globalId) +
							rowObject.fullNum + ". " + rowObject.name;
					}
				}
			],
			sortname: 'num',
			sortorder: 'asc',
			beforeSelectRow: function (rowid, e) {
				if ($(e.target).hasClass("treeclick")) {
					return false;
				}
				return $(this).getGridParam('selrow') != rowid;
			},
			onSelectRow: function (id) {
				page.setSideBarCache(id);
				we_helper.getDataDB("/Admin/GetRecord?pageid=filial", {
					id: id
				}, "query", false, function (entity) {
					$("[name=departmentCount], [name=postCount], [name=userCount]").removeClass("badge-success").addClass("badge-danger");
					if (entity.departmentCount > 0) {
						$("[name=departmentCount]").removeClass("badge-danger").addClass("badge-success");
					}
					if (entity.postCount > 0) {
						$("[name=postCount]").removeClass("badge-danger").addClass("badge-success");
					}
					if (entity.userCount > 0) {
						$("[name=userCount]").removeClass("badge-danger").addClass("badge-success");
					}

					entity.dateOfChange = we_helper.convertDateFull(entity.dateOfChange);
					we_helper.setFormData($(".tree-node-info"), entity);
					we_helper.hideLoader();
				});
			}
		}, function () {
			$(".tree-leaf").addClass("d-none");
			let filialid = page.getSideBarCache();
			if (!filialid) {
				let ids = page.$tree.jqGrid("getDataIDs");
				if (ids && ids.length > 0) {
					filialid = ids[0];
					page.setSideBarCache(filialid);
				}
			}
			page.$tree.jqGrid('setSelection', filialid);
			we_helper.jqGridTreeExpandToNode(page.$tree, page.getTreeSelectRowData(filialid));
			$(".jqgrow", page.$tree).addClass("cursor-pointer");
		});
		page.resizeTree();
		page.reloadTree();
		$(".tree-node-info").removeClass("d-none");
	},
	reloadTree: function () {
		page.$tree.setGridParam({
			page: 1, datatype: 'json'
		}).trigger("reloadGrid");
		page.$tree.jqGrid('resetSelection');
	},
	resizeTree: function () {
		$('#split-0 .ui-jqgrid-bdiv').css({ 'height': ($(window).height() - 90) + 'px' });
	},
	getTreeSelectRowId: function () {
		return page.$tree.jqGrid('getGridParam', 'selrow');
	},
	getTreeSelectRowData: function (rowId) {
		if (!rowId) {
			rowId = page.getTreeSelectRowId();
		}
		if (rowId == null) { return null; }
		return page.$tree.jqGrid('getLocalRow', rowId);
	},
	getTreeNodeIcon: function (level) {
		if (level === 0) {
			return "mdi mdi-domain";
		} else if (level === 1) {
			return "mdi mdi-home-city";
		} else {
			return "mdi mdi-home";
		}
	},
	getZupSyncNodeIcon: function (syncKey) {
		if (this._edition === "SO UPS") {
			if (syncKey) {
				return "<span class='mdi mdi-sync text-success pr-1 icon-size' style='cursor:pointer;' title='Синхронизовано с ЦС «ЗУП»'></span>";
			} else {
				return "<span class='mdi mdi-sync-alert text-danger pr-1 icon-size' style='cursor:pointer;' title='Запись в ЦС «ЗУП» не найдена'></span>";
			}
		}
		return "";
	},
	showModal: function (act) {
		let row = page.getTreeSelectRowData();
		if (!row) {
			we_helper.alert("Функция не применима для выбранного объекта!", notificatioType.danger);
			return;
		}
		if (act === "edit") {
			we_helper.getDataDB("/Admin/GetRecord", {
				pageid: "filial",
				id: row.id
			}, "query", false, function (entity) {
				page._data = entity;
				we_helper.setFormData(page.$modal, page._data);
				$('.modal-title', page.$modal).text('Редактирование параметров структурной единицы');
				page.$modal.modal('show');
				we_helper.hideLoader();
			});
		} else if (act === "add") {
			we_helper.getDataDB("/Admin/GetNextRecordNumber", {
				pageid: "filial",
				filialid: row.id
			}, "query", false, function (entity) {
				we_helper.setFormData(page.$modal, {
					filialId: row.id,
					filialName: row.name,
					num: entity
				});
				$('.modal-title', page.$modal).text('Создание новой структурной единицы');
				page.$modal.modal('show');
				we_helper.hideLoader();
			});
		} else {
			we_helper.alert("Некорректно задан код действия: " + act, notificatioType.warning);
		}
	},
	updateRecord: function () {
		page._data = $.extend(page._data, we_helper.getFormData(page.$modal));
		let arcionUrl = "/Admin/CreateFilial";
		if (!!page._data.id) {
			arcionUrl = "/Admin/UpdateFilial";
		}
		we_helper.updateDataDB(arcionUrl, page._data, function () {
			page.reloadTree();
			page.$modal.modal('hide');
		});
	},
	setSideBarCache: function (filialid) {
		we_helper.setCache("filial_" + page._id + "_tree", {
			filialid: filialid
		});
	},
	getSideBarCache: function () {
		let cache = we_helper.getCache("filial_" + page._id + "_tree");
		if (!!cache && !!cache.filialid) {
			return cache.filialid;
		}
		return null;
	},
};