﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _table_selected_rows: [],
    _search: null,
    $search_panel: $('.js_search_panel'),
    $dlgReportSettings: $(".js_modal_report_settings"),
    $table: $(".js_table"),
    init: function () {
        page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$dlgReportSettings);
        });
        $('.btn-success', page.$dlgReportSettings).on('click', function (e) {
            let search_data = page._search.api().get_data();
            let gridParam = page.$table.jqGrid('getGridParam', 'postData');
            search_data["sidx"] = gridParam.sidx;
            search_data["sord"] = gridParam.sord;
            search_data["format"] = $('input[name="fileformattype"]:checked').attr("id");
            we_helper.getDataDB("/Admin/SaveReport", search_data, "body", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            }); 
        });
        page.$table.on('click', 'a.js_del_table_record', function () {
            let id = $(this).attr("attr-id");
            page.deleteRecords([id], function () {
                let index = $.inArray(id, page._table_selected_rows);
                if (index !== -1) {
                    page._table_selected_rows.splice(index, 1);
                }
                we_helper.reloadJqGrid(page.$table);
            });
        });
        page.$table.on('click', '.js-select-row', function () {
            we_helper.multipleSelection($(this), page._table_selected_rows);

            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));  
        });
        page.$table.parent().on('click', '.js-select-all-row', function () {
            we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
        });

        let _searchParam = {
            params: [],
            default: {
                param: 0,
                data: ""
            }
        };
        let _selectParam = [];
        let _table_stg = {
            uid: "admin_" + page._id,
            url: "/Admin/GetRecords",
            colNames: [],
            colModel: [],
            sortname: 'dateOfChange',
            sortorder: 'desc',
            beforeSelectRow: function (rowid, e) { return false; }
        };
        let _searchAutocomplete = {
            enable: true,
            url: "/Admin/GetAutocompleteRecords",
        };
        let _actionBtn = [
            {
                id: "delete",
                icon: "mdi mdi-delete",
                style: "danger",
                text: "Удалить"
            },
            {
                id: "clear",
                icon: "mdi mdi-broom",
                style: "danger",
                text: "Очистить"
            },
            {
                id: "export",
                icon: "mdi mdi-database-export",
                style: "info",
                text: "Отчёт"
            },
        ];
        let crumb = [{
            page: "Администрирование",
            path: "#"
        }];
        switch (page._id) {
            case "session": {
                crumb.push({ page: "Журнал сессий пользователей" });
                _searchParam.params = [
                    { text: 'Пользователь', placeholder: 'Введите часть фамилии пользователя' },
                    { text: 'Логин', placeholder: 'Введите часть логина пользователя' },
                    { text: 'IP', placeholder: 'Введите IP-адрес пользователя' }
                ];
                _table_stg.colNames = [
                    '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Дата начала сессии', 'Дата последнего действия', 'Пользователь', 'Логин', 'IP', 'Уд.'
                ]; 
                _table_stg.sortname = 'loginDate';
                _table_stg.colModel = [
                    { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                    {
                        name: "selected", width: 15, align: "center", sortable: false, title: false,
                        formatter: function (cellvalue, options, rowObject) {
                            var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                            if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                                res += ' checked="checked"';
                            }
                            return res + '/>';
                        }
                    },
                    {
                        name: "loginDate", sortable: true, align: 'center', width: 60, index: 'loginDate',
                        formatter: "date",
                        formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                    },
                    {
                        name: "dateOfChange", sortable: true, align: 'center', width: 60, index: 'dateOfChange',
                        formatter: "date",
                        formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                    },
                    { name: "userHasChanged", sortable: true, align: 'left', width: 80, index: 'userHasChanged' },
                    { name: "login", sortable: true, align: 'left', width: 50, index: 'login' },
                    { name: "ip", sortable: true, align: 'left', width: 80, index: 'ip' },
                    {
                        name: "btnDelete", classes: 'overflow-none', width: 25, align: "center", sortable: false,
                        formatter: function (cellvalue, options, rowObject) {
                            return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                        }
                    },
                ];
                break;
            }
            case "systemlog": {
                crumb.push({ page: "Журнал системных событий" });
                _searchParam.params = [
                    { text: 'Подсистема', placeholder: 'Введите часть наименования подсистемы' },
                    { text: 'Операция', placeholder: 'Введите часть наименования выполняемой операции' },
                    { text: 'Уровень', placeholder: 'Введите часть наименования уровня логирования' },
                    { text: 'Описание', placeholder: 'Введите часть описания выполняемой операции' },
                    { text: 'Результат', placeholder: 'Введите часть результирующего сообщения' },
                    { text: 'Пользователь', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ];

                _table_stg.colNames = [
                    '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Время записи', 'Подсистема',
                    'Операция', 'Уровень', 'Описание', 'Результат', 'Пользователь', 'Уд.'
                ];
                _table_stg.colModel = [
                    { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                    {
                        name: "selected", width: 15, align: "center", sortable: false, title: false,
                        formatter: function (cellvalue, options, rowObject) {
                            var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                            if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                                res += ' checked="checked"';
                            }
                            return res + '/>';
                        }
                    },
                    {
                        name: "dateOfChange", sortable: true, align: 'center', width: 70, index: 'dateOfChange',
                        formatter: "date",
                        formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                    },
                    { name: "subSystem", sortable: true, align: 'left', width: 100, index: 'subSystem' },
                    { name: "operation", sortable: true, align: 'center', width: 50, index: 'operation' },
                    { name: "debugLevel", sortable: true, align: 'center', width: 40, index: 'debugLevel' },
                    { name: "message", sortable: true, align: 'left', width: 150, index: 'message' },
                    { name: "description", sortable: true, align: 'left', width: 300, index: 'description' },
                    { name: "userHasChanged", sortable: true, align: 'left', width: 70, index: 'userHasChanged' },
                    {
                        name: "btnDelete", classes: 'overflow-none', width: 25, align: "center", sortable: false,
                        formatter: function (cellvalue, options, rowObject) {
                            return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                        }
                    },
                ];
                break;
            }
            case "interaction": {
                crumb.push({ page: "Журнал взаимодействий с внешними системами" });
                _searchParam.params = [
                   { text: 'Внешняя система', placeholder: 'Введите часть наименования внешней системы' },
                   { text: 'Результат взаимодействия', placeholder: 'Введите результат взаимодействия' },
                   { text: 'Входные параметры', placeholder: 'Введите часть входных параметров' },
                   { text: 'Описание результата', placeholder: 'Введите часть описания результата' },
                   { text: 'Количество попыток', placeholder: 'Введите количество попыток' },
                   { text: 'Пользователь', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ];

                _table_stg.colNames = [
                    '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Время записи', 'Внешняя система', 'Результат взаимодействия', 'Входящие параметры', 'Описание', 'Попыток', 'Пользователь', 'Уд.'
                ];
                _table_stg.colModel = [
                    { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                    {
                        name: "selected", width: 15, align: "center", sortable: false, title: false,
                        formatter: function (cellvalue, options, rowObject) {
                            var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                            if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                                res += ' checked="checked"';
                            }
                            return res + '/>';
                        }
                    },
                    {
                        name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
                        formatter: "date",
                        formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                    },
                    { name: "externalSystem", sortable: true, align: 'left', width: 100, index: 'externalSystem' },
                    { name: "interactionResult", sortable: true, align: 'left', width: 100, index: 'interactionResult' },
                    { name: "inputParams", sortable: true, align: 'left', width: 200, index: 'inputParams' },
                    { name: "description", sortable: true, align: 'left', width: 250, index: 'description' },
                    { name: "requestCount", sortable: true, align: 'left', width: 50, index: 'requestCount' },
                    { name: "userHasChanged", sortable: true, align: 'left', width: 90, index: 'userHasChanged' },
                    {
                        name: "btnDelete", classes: 'overflow-none', width: 25, align: "center", sortable: false,
                        formatter: function (cellvalue, options, rowObject) {
                            return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                        }
                    },
                ];

                break;
            }
            default: {
                window.open('/', '_self');
            }
        }
        we_helper.setBreadcrumb(crumb);
        page._search = page.$search_panel.searchPanel({
            uid: "admin_" + page._id,
            selectParam: _selectParam,
            actionBtn: _actionBtn,
            searchParam: _searchParam,
            autocomplete: _searchAutocomplete,
            defBtn:true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1); 
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onAction: function (keyBtn, search_data) {
                switch (keyBtn) {
                    case "export": { 
                        page.$dlgReportSettings.modal('show');
                        break;
                    }
                    case "clear": {
                        page.clearLogs(function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    case "delete": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.deleteRecords(page._table_selected_rows, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        we_helper.initJqGrid(page.$table, _table_stg, page._search.api().get_data(), function () {
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));  
        });
    }, 
    deleteRecords: function (ids, callback) {
        we_helper.deleteDataDB("/Admin/DeleteRecords", {
            pageid: page._id,
            ids: ids
        }, function () {
            if (callback) {
                callback();
            }
        });
    },
    clearLogs: function (callback) {
        we_helper.clearDataDB("/Admin/ClearLog?pageid=" + page._id, function () {
            if (callback) {
                callback();
            }
        });
    } 
};
