﻿$(function () {
	page.init();
});

var page = {
	_edition: $("#assembly-config-edition").attr("value"),
	_id: we_helper.getPageId(),
	_cur_user_filial: we_helper.getCurUserFilial(),
	_sys_owner_filial: we_helper.getSystemOwnerFilial(),
	_data: {},
	_cruc: {
		url: [],
		title: [],
		$modal: $(".js_detail_modal"),
		$saveBtn: $('.js_modal_save_change', $(".js_detail_modal"))
	},
	_table_selected_rows: [],
	_search: null,
	$search_panel: $('.js_search_panel'),
	$table: $(".js_table"),
	$dlgImport: $(".js_modal_import"),
	$btn_start_import: $('.js_modal_import_start'),
	$btn_download_import_template: $('.js_modal_download_template'),
	$dlgSetRoles: $(".js_modal_set_roles"),
	$btn_update_user_roles: $('.js_modal_roles_update'),
	$dlgReportSettings: $(".js_modal_report_settings"),
	_tinymce: null,
	init: function (_pageInfo) {
		let crumb = [{
			page: "Администрирование",
			path: "#"
		}];
		page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page.$dlgReportSettings);
		});
		$('.btn-success', page.$dlgReportSettings).on('click', function (e) {
			let data = page._search.api().get_data();
			let gridParam = page.$table.jqGrid('getGridParam', 'postData');
			data["sidx"] = gridParam.sidx;
			data["sord"] = gridParam.sord;
			data["format"] = $('input[name="fileformattype"]:checked').attr("id");
			we_helper.getDataDB("/Admin/SaveReport", data, "body", false, function (entity) {
				window.open('../temp/' + entity, "_blank");
				we_helper.hideLoader();
			});
		});
		page._cruc.$modal.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page._cruc.$modal, page._data);
		});
		page.$dlgImport.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page.$dlgImport);
		});
		page.$table.on('click', 'a.js_edit_table_record', function () {
			page.showModal($(this).attr("attr-id"));
		});
		page.$table.on('click', 'a.js_goto_page', function () {
			let rowid = "g1_" + $(this).attr("attr-id");
			let pageid = $(this).attr("page-id");
			let row = page.$table.jqGrid('getRowData', rowid);
			if (!!row) {
				let url = "",
					cache_uid = "";
				let cache_data = {};
				switch (page._id) {
					case "post": {
						url = "/admin?pageid=user";
						cache_uid = "search_admin_user";
						cache_data = {
							search_param: 6,
							search_data: row.name,
							filialname: row.filialName,
							filialid: row.filialId,
							removeAfterInit: !we_helper.existInCache(cache_uid)
						};
						break;
					}
					case "department": {
						url = "/admin?pageid=user";
						cache_uid = "search_admin_user";
						if (pageid === "curator") {
							cache_data = {
								search_param: 5,
								search_data: "Проверяющий"
							};
						} else if (pageid === "user") {
							cache_data = {
								search_param: 7,
								search_data: row.name
							};
						}
						cache_data.filialname = row.filialName;
						cache_data.filialid = row.filialId;
						cache_data.removeAfterInit = !we_helper.existInCache(cache_uid);
						break;
					}
					case "filial": {
						url = "/admin?pageid=" + pageid;
						cache_uid = "search_admin_" + pageid;
						cache_data = {
							filialid: row.id,
							filialname: row.name,
							removeAfterInit: !we_helper.existInCache(cache_uid)
						};
						break;
					}
					default: {
						return;
					}
				}
				we_helper.setCache(cache_uid, cache_data);
				window.open(url, "_self");
			}
		});
		page.$table.on('click', 'a.js_del_table_record', function () {
			let id = $(this).attr("attr-id");
			page.deleteRecords([id], function () {
				let index = $.inArray(id, page._table_selected_rows);
				if (index !== -1) {
					page._table_selected_rows.splice(index, 1);
				}
				we_helper.reloadJqGrid(page.$table);
			});
		});
		page.$table.on('click', 'a.js_mark_table_record', function () {
			let id = $(this).attr("attr-id");
			page.logonSessions([id], function () {
				let index = $.inArray(id, page._table_selected_rows);
				if (index !== -1) {
					page._table_selected_rows.splice(index, 1);
				}
				we_helper.reloadJqGrid(page.$table);
			});
		});

		page._cruc.$saveBtn.on('click', function (e) {
			if (we_helper.checkValidation(page._cruc.$modal) === true) {
				page.updateRecord();
			}
			e.preventDefault();
		});
		page.$table.on('click', '.js-select-row', function () {
			we_helper.multipleSelection($(this), page._table_selected_rows);

			$('.js-select-all-row').prop('checked',
				we_helper.isAllSelected($('.js-select-row', page.$table)));
		});
		page.$table.parent().on('click', '.js-select-all-row', function () {
			we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
		});
		page.$btn_start_import.on('click', function (e) {
			let $upload = $("#importDataFileUploader");
			if ($upload.length <= 0 || $upload.get(0).files.length != 1) {
				we_helper.alert("Выберите файл!", notificatioType.warning);
				return;
			}

			let filialid = $(".js-filial-import-data").val();
			if (filialid === undefined || filialid === null || filialid === "") {
				we_helper.alert("Выберите структурную единицу!", notificatioType.warning);
				return;
			}

			let files = $upload.get(0).files;
			var formData = new FormData();
			formData.append(files[0].name, files[0]);
			formData.append("filialid", filialid);
			formData.append("pageid", page._id);
			we_helper.uploadFile("/Admin/ImportData", formData, function () {
				page.$dlgImport.modal('hide');
				we_helper.reloadJqGrid(page.$table);
			});
		});
		page.$btn_download_import_template.on('click', function (e) {
			we_helper.getDataDB("/Admin/DownloadImportTemplate", { pageid: page._id }, "query", false, function (entity) {
				window.open('../temp/' + entity, "_blank");
				we_helper.hideLoader();
			});
		});
		let _searchParam = {
			params: [],
			default: {
				param: 0,
				data: ""
			}
		};
		let _selectParam = [{
			id: "filial",
			title: "Структурная единица",
			url: "/Admin/GetRecordsKeyText",
			def_selected: page._cur_user_filial
		}];
		let _searchAutocomplete = {
			enable: true,
			url: "/Admin/GetAutocompleteRecords",
		};
		let _table_stg = {
			uid: "admin_" + page._id,
			url: "/Admin/GetRecords",
			colNames: [],
			colModel: [],
			sortname: 'num',
			sortorder: 'asc',
			beforeSelectRow: function (rowid, e) { return false; }
		};
		let _actionBtn = [
			{
				id: "add",
				icon: "mdi mdi-plus",
				style: "success",
				text: "Создать"
			},
			{
				id: "delete",
				icon: "mdi mdi-delete",
				style: "danger",
				text: "Удалить"
			},
			{
				id: "export",
				icon: "mdi mdi-database-export",
				style: "info",
				text: "Отчёт"
			}];
		if (this._edition === "SO UPS") {
			_actionBtn.push({
				id: "zup-sync",
				icon: "mdi mdi-cloud-sync-outline",
				style: "info",
				text: "Синхронизировать с ЦС «ЗУП»",
			});
		}
		let $user_post = $('.select2.js-user-post', page._cruc.$modal);
		let $user_depart = $('.select2.js-user-department', page._cruc.$modal);
		let $select_filial = $('.select2.js-filial', page._cruc.$modal);
		if ($select_filial.length != 0) {
			we_helper.initSelect('/Admin/GetRecordsKeyText', $select_filial, {
				pageid: "filial"
			}, true, true, null, function (_data) {
				we_helper.getDataDB("/Admin/GetNextRecordNumber", {
					pageid: page._id,
					filialid: _data.id
				}, "query", false, function (entity) {
					$("input[name=num]", page._cruc.$modal).val(entity);
					we_helper.hideLoader();
				});

				if ($user_post.length != 0) {
					$user_post.val([0]).trigger('change');
				};

				if ($user_depart.length != 0) {
					$user_depart.val([0]).trigger('change');
				};
			});
		}

		let $importDataFilial = $(".js-filial-import-data");
		if ($importDataFilial.length !== 0) {
			we_helper.initSelect('/Admin/GetRecordsKeyText', $importDataFilial, {
				pageid: "filial"
			}, true, true);
		}

		switch (page._id) {
			case "user": {
				crumb.push({ page: "Пользователи" });
				page.$dlgSetRoles.on('hidden.bs.modal', function (e) {
					we_helper.clearModal(page.$dlgSetRoles);
				});
				page.$btn_update_user_roles.on('click', function (e) {
					we_helper.updateDataDB("/Admin/UpdateUsersRoles", {
						ids: page._table_selected_rows,
						roles: $(".js-select-user-roles").val()
					}, function () {
						page._table_selected_rows = [];
						page.$dlgSetRoles.modal('hide');
						we_helper.reloadJqGrid(page.$table);
					});
				});
				let $user_roles = $('.select2.js-user-roles, .select2.js-select-user-roles');
				we_helper.initSelect('/Admin/GetEnums?name=roles', $user_roles, null, false, true, function () {
					$user_roles.find('option:eq(0)').remove();
				});
				we_helper.initSelect('/Admin/GetRecordsKeyText', $user_post, {
					pageid: "post",
					filialId: function () {
						return $select_filial.val();
					}
				}, true, false);
				we_helper.initSelect('/Admin/GetRecordsKeyText', $user_depart, {
					pageid: "department",
					filialid: function () {
						return $select_filial.val();
					}
				}, true, false);

				page._cruc.url = ["/Admin/CreateUser", "/Admin/UpdateUser"];
				page._cruc.title = ["Создание новой учётной записи пользователя", "Редактирование параметров учётной записи пользователя"];
				_searchParam.params = [
					{ text: 'Фамилия или код', placeholder: 'Введите часть фамилии или код пользователя' },
					{ text: 'Код', placeholder: 'Введите код пользователя' },
					{ text: 'Фамилия', placeholder: 'Введите часть фамилии пользователя' },
					{ text: 'Логин', placeholder: 'Введите часть логина пользователя' },
					{ text: 'Email', placeholder: 'Введите часть наименования почтового ящика пользователя' },
					{ text: 'Роль', placeholder: 'Введите часть наименования роли' },
					{ text: 'Должность', placeholder: 'Введите часть наименования должности пользователя' },
					{ text: 'Подразделение', placeholder: 'Введите часть наименования подразделения пользователя' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' },
				];
				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', ' ', '', 'Код', 'ФИО', 'Логин', 'Email', 'Роль', 'Должность', 'Подразделение', 'Проверяющий',
					'Структурная единица', 'Дата изменения', 'Изменил', 'Ред.', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{
						name: "onLine", sortable: false, align: 'center', width: 15, index: 'onLine',
						formatter: function (cellvalue, options, rowObject) {
							if (cellvalue) {
								return "<a class='mdi mdi-account text-success js_mark_table_record' style='cursor:pointer;'  href='#' attr-id='" + rowObject.id + "' title='Онлайн. Завершить сессию?'></a>";
							} else {
								return "<span class='mdi mdi-account text-danger' title = 'Офлайн'></span>";
							}
						}
					},
					{
						name: "globalId", sortable: false, align: 'center', width: 15, index: 'globalId', hidden: this._edition === "SO UPS" ? false : true,
						formatter: function (cellvalue, options, rowObject) {
							if (cellvalue) {
								return "<span class='mdi mdi-sync text-success' style='cursor:pointer;' title='Синхронизовано с ЦС «ЗУП»'></span>";
							} else {
								return "<span class='mdi mdi-sync-alert text-danger' style='cursor:pointer;' title='Запись в ЦС «ЗУП» не найдена'></span>";
							}
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 120, index: 'name' },
					{ name: "login", sortable: true, align: 'left', width: 70, index: 'login' },
					{ name: "email", sortable: true, align: 'left', width: 80, index: 'email' },
					{ name: "roleNames", sortable: false, align: 'left', width: 110, index: 'roleNames' },
					{ name: "postName", sortable: true, align: 'left', width: 70, index: 'postName' },
					{ name: "departmentName", sortable: true, align: 'left', width: 90, index: 'departmentName' },
					{
						name: "departmentCurator", sortable: true, align: 'center', width: 20, index: 'departmentCurator',
						formatter: function (cellvalue, options, rowObject) {
							if (cellvalue) {
								return "<span class='mdi mdi-checkbox-marked-outline' title='Проверяющий'></span>";
							} else {
								return "<span class='mdi mdi-checkbox-blank-outline'></span>";
							}
						}
					},
					{ name: "filialName", sortable: true, align: 'left', width: 70, index: 'filialName' },
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 60, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 60, index: 'userHasChanged' },
					{
						name: "btnEdit", classes: 'overflow-none', width: 25, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 25, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				_actionBtn.push({
					id: "import",
					icon: "mdi mdi-database-import",
					style: "primary",
					text: "Импорт"
				}, {
					id: "ad_search",
					icon: "mdi mdi-account-search",
					style: "primary",
					text: "Поиск в Службе каталогов"
				}, {
					id: "set_roles",
					icon: "mdi mdi-account-check",
					style: "primary",
					text: "Изменить роли"
				}, {
					id: "session_logon",
					icon: "mdi mdi-account-off",
					style: "success",
					text: "Завершить активные сессии"
				});
				break;
			}
			case "adsearch": {
				crumb.push({ page: "Пользователи", path: "/admin?pageid=user" }, { page: "Поиск в Службе каталогов" });

				page.$table.on('click', 'a.js_add_user_table_record', function () {
					we_helper.getDataDB("/Admin/GetUserFromAD", {
						userName: $(this).attr("attr-id")
					}, "query", false, function (entity) {
						we_helper.setFormData(page._cruc.$modal, entity);
						$('.modal-title', page._cruc.$modal).text("Создание новой учётной записи пользователя");
						page._cruc.$modal.modal('show');
						we_helper.hideLoader();
					});
				});
				let $user_roles = $('.select2.js-user-roles', page._cruc.$modal);
				we_helper.initSelect('/Admin/GetEnums?name=roles', $user_roles, null, false, true, function () {
					$user_roles.find('option:eq(0)').remove();
				});
				we_helper.initSelect('/Admin/GetRecordsKeyText', $user_post, {
					pageid: "post",
					filialid: function () {
						return $select_filial.val();
					}
				}, true, false);
				we_helper.initSelect('/Admin/GetRecordsKeyText', $user_depart, {
					pageid: "department",
					filialid: function () {
						return $select_filial.val();
					}
				}, true, false);

				page._cruc.url = ["/Admin/CreateUser"];
				page._cruc.title = ["Создание новой учётной записи пользователя"];
				_searchParam.params = [
					{ text: 'Фамилия', placeholder: 'Введите часть фамилии пользователя' },
					{ text: 'Имя', placeholder: 'Введите часть имени пользователя' },
					{ text: 'Логин', placeholder: 'Введите часть логина пользователя' },
					{ text: 'Email', placeholder: 'Введите часть наименования почтового ящика пользователя' }
				];
				_table_stg.colNames = [
					'Фамилия', 'Имя', 'Логин', 'Email', 'Структурная единица', 'Создать'
				];
				_table_stg.colModel = [
					{ name: "surname", sortable: true, align: 'left', width: 70, index: 'surname' },
					{ name: "givenName", sortable: true, align: 'left', width: 90, index: 'givenName' },
					{ name: "winLogin", sortable: true, align: 'left', width: 70, index: 'winLogin' },
					{ name: "emailAddress", sortable: true, align: 'left', width: 80, index: 'emailAddress' },
					{ name: "compayName", sortable: true, align: 'left', width: 80, index: 'compayName' },
					{
						name: "btnAdd", classes: 'overflow-none', width: 25, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-account-plus-outline text-success js_add_user_table_record' href='#' attr-id='" + rowObject.winLogin + "' title='Создать'></a>";
						}
					}
				];
				_searchAutocomplete.enable = false;
				_selectParam = [];
				_actionBtn = [];
				break;
			}
			case "post": {
				crumb.push({ page: "Должности" });
				page._cruc.url = ["/Admin/CreatePost", "/Admin/UpdatePost"];
				page._cruc.title = ["Создание новой должности", "Редактирование параметров должности"];
				_searchParam.params = [
					{ text: 'Должность или код', placeholder: 'Введите часть наименования или код должности' },
					{ text: 'Код', placeholder: 'Введите код должности' },
					{ text: 'Должность', placeholder: 'Введите часть наименования должности' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];
				_table_stg.colNames = [
					'', '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', '', 'Код', 'Должность', 'Структурная единица', 'Дата изменения', 'Изменил', 'Пользователей', 'Ред.', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{ name: "filialId", hidedlg: true, hidden: true, index: 'filialId' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{
						name: "globalId", sortable: true, align: 'center', width: 15, index: 'globalId', hidden: this._edition === "SO UPS" ? false : true,
						formatter: function (cellvalue, options, rowObject) {
							if (cellvalue) {
								return "<span class='mdi mdi-sync text-success' style='cursor:pointer;' title='Синхронизовано с ЦС «ЗУП»'></span>";
							} else {
								return "<span class='mdi mdi-sync-alert text-danger' style='cursor:pointer;' title = 'Запись в ЦС «ЗУП» не найдена'></span>";
							}
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 35, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
					{ name: "filialName", sortable: true, align: 'left', width: 90, index: 'filialName' },
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 90, index: 'userHasChanged' },
					{
						name: "userCount", sortable: true, align: 'center', width: 30, index: 'userCount',
						formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.userCount <= 0) {
								color = "badge-danger";
							}
							return "<a title='Пользователей' class='js_goto_page' attr-id='" + rowObject.id + "'><span class='badge " + color + " badge-cell'>" + rowObject.userCount + "</span></a>";
						}
					},
					{
						name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				_actionBtn.push({
					id: "import",
					icon: "mdi mdi-database-import",
					style: "primary",
					text: "Импорт"
				});
				break;
			}
			case "department": {
				crumb.push({ page: "Подразделения" });
				page._cruc.url = ["/Admin/CreateDepartment", "/Admin/UpdateDepartment"];
				page._cruc.title = ["Создание нового подразделения", "Редактирование параметров подразделения"];
				_searchParam.params = [
					{ text: 'Подразделение или код', placeholder: 'Введите часть наименования или код подразделения' },
					{ text: 'Код', placeholder: 'Введите код подразделения' },
					{ text: 'Подразделение', placeholder: 'Введите часть наименования подразделения' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];
				_table_stg.colNames = [
					'', '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', '', 'Код', 'Подразделение', 'Структурная единица', 'Дата изменения', 'Изменил', 'Пользователей', 'Проверяющих', 'Ред.', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{ name: "filialId", hidedlg: true, hidden: true, index: 'filialId' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{
						name: "globalId", sortable: true, align: 'center', width: 15, index: 'globalId', hidden: this._edition === "SO UPS" ? false : true,
						formatter: function (cellvalue, options, rowObject) {
							if (cellvalue) {
								return "<span class='mdi mdi-sync text-success' style='cursor:pointer;' title='Синхронизовано с ЦС «ЗУП»'></span>";
							} else {
								return "<span class='mdi mdi-sync-alert text-danger' style='cursor:pointer;' title = 'Запись в ЦС «ЗУП» не найдена'></span>";
							}
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 35, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
					{ name: "filialName", sortable: true, align: 'left', width: 90, index: 'filialName' },
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 90, index: 'userHasChanged' },
					{
						name: "userCount", sortable: true, align: 'center', width: 30, index: 'userCount',
						formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.userCount <= 0) {
								color = "badge-danger";
							}
							return "<a title='Пользователей' class='js_goto_page' page-id='user' attr-id='" + rowObject.id + "'><span class='badge " + color + " badge-cell'>" + rowObject.userCount + "</span></a>";
						}
					},
					{
						name: "curatorCount", sortable: true, align: "center", width: 25, index: 'curatorCount',
						formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.curatorCount <= 0) {
								color = "badge-danger";
							}
							return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.curatorCount + "</span>";
						}
					},
					{
						name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				_actionBtn.push({
					id: "import",
					icon: "mdi mdi-database-import",
					style: "primary",
					text: "Импорт"
				});
				break;
			}
			case "alerttemplate": {
				$(document).on('focusin', function (e) {
					var target = $(e.target);
					if (target.closest(".mce-window").length || target.closest(".tox-dialog").length) {
						e.stopImmediatePropagation();
						target = null;
					}
				});
				tinymce.init({
					height: 300,
					selector: 'textarea#userTemplate',
					language: 'ru',
					menubar: false,
					trapFocus: false,
					plugins: [
						'advlist autolink lists link image charmap print preview anchor textcolor',
						'searchreplace visualblocks code fullscreen',
						'insertdatetime media table paste code help wordcount'
					],
					toolbar: "mailTags | bold italic underline strikethrough | forecolor | fontselect | fontsizeselect | alignleft aligncenter alignright | bullist numlist | outdent indent | undo redo | link | removeformat",
					setup: function (editor) {
						editor.ui.registry.addMenuButton('mailTags', {
							icon: 'bookmark',
							tooltip: 'Вставить теги в текст',
							fetch: function (callback) {
								var items = [{
									type: 'menuitem',
									text: 'ФИО',
									onAction: function () {
										editor.insertContent('&nbsp;«#fio»');
									}
								},
								{
									type: 'menuitem',
									text: 'Структурная единица',
									onAction: function () {
										editor.insertContent('&nbsp;«#filial»');
									}
								}];

								switch (page._data.category) {
									case 1: {
										items.push({
											type: 'menuitem',
											text: 'Портал',
											onAction: function () {
												editor.insertContent('&nbsp;«#software»');
											}
										});
										break;
									}
									case 2: {
										items.push({
											type: 'menuitem',
											text: 'Раздел библиотеки',
											onAction: function () {
												editor.insertContent('&nbsp;«#section»');
											}
										});
										break;
									}
									case 3: {
										items.push({
											type: 'menuitem',
											text: 'Документ',
											onAction: function () {
												editor.insertContent('&nbsp;«#document»');
											}
										});
										break;
									}
									case 4: {
										items.push({
											type: 'menuitem',
											text: 'Файл',
											onAction: function () {
												editor.insertContent('&nbsp;«#file»');
											}
										});
										break;
									}
									case 5: {
										items.push({
											type: 'menuitem',
											text: 'Тестовое задание',
											onAction: function () {
												editor.insertContent('&nbsp;«#testitem»');
											}
										});
										break;
									}
									case 6: {
										items.push({
											type: 'menuitem',
											text: 'Задания типа «Последовательность»',
											onAction: function () {
												editor.insertContent('&nbsp;«#sequencetask»');
											}
										});
										break;
									}
									case 7: {
										items.push({
											type: 'menuitem',
											text: 'Тренировка',
											onAction: function () {
												editor.insertContent('&nbsp;«#training»');
											}
										});
										break;
									}
									case 8: {
										items.push({
											type: 'menuitem',
											text: 'Программируемая задача',
											onAction: function () {
												editor.insertContent('&nbsp;«#calculationtask»');
											}
										});
										break;
									}
									case 9: {
										items.push({
											type: 'menuitem',
											text: 'Учебный модуль',
											onAction: function () {
												editor.insertContent('&nbsp;«#module»');
											}
										});
										break;
									}
									case 10: {
										items.push({
											type: 'menuitem',
											text: 'Учебный курс',
											onAction: function () {
												editor.insertContent('&nbsp;«#course»');
											}
										});
										break;
									}
									case 11: {
										items.push({
											type: 'menuitem',
											text: 'Регламент контроля',
											onAction: function () {
												editor.insertContent('&nbsp;«#controlregulation»');
											}
										});
										break;
									}
									case 12: {
										items.push({
											type: 'menuitem',
											text: 'Программа аттестации',
											onAction: function () {
												editor.insertContent('&nbsp;«#program»');
											}
										}, {
											type: 'menuitem',
											text: 'Портал',
											onAction: function () {
												editor.insertContent('&nbsp;«#software»');
											}
										}, {
											type: 'menuitem',
											text: 'Представители группы',
											onAction: function () {
												editor.insertContent('&nbsp;«#represents»');
											}
										}, {
											type: 'menuitem',
											text: 'Сроки обучения',
											onAction: function () {
												editor.insertContent('&nbsp;«#startdate» - «#enddate»');
											}
										});
										break;
									}
									default:
										break;
								}
								callback(items);
							}
						});
						page._tinymce = editor;
					},
				});

				crumb.push({ page: "Шаблоны оповещений" });
				page._cruc.url = ["", "/Admin/UpdateAlertTemplate"];
				page._cruc.title = ["", "Редактирование шаблона оповещения"];
				_selectParam = [];
				_searchParam.params = [
					{ text: 'Категория', placeholder: 'Введите часть наименования категории' },
					{ text: 'Событие', placeholder: 'Введите часть наименования события' },
					{ text: 'Роль', placeholder: 'Введите часть наименования роли' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];

				_table_stg.colNames = [
					'', 'Категория', 'Событие', 'Роли', 'Шаблон по умолчанию', 'Пользовательский шаблон', 'Дата изменения', 'Изменил', 'Ред.',
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{ name: "categoryName", sortable: true, align: 'left', width: 100, index: 'categoryName' },
					{ name: "eventName", sortable: true, align: 'left', width: 100, index: 'eventName' },
					{ name: "roleNames", sortable: false, align: 'left', width: 100, index: 'roleNames' },
					{ name: "defaultTemplate", sortable: false, align: 'left', width: 230, index: 'defaultTemplate' },
					{
						name: "userTemplate", sortable: false, align: 'left', width: 230, index: 'userTemplate',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.userTemplate) {
								return rowObject.userTemplate;
							}
							return "";
						}
					},
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 80, index: 'userHasChanged' },
					{
						name: "btnEdit", classes: 'overflow-none', width: 25, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
						}
					}
				];
				_actionBtn = [];
				break;
			}
			default: {
				window.open('/', '_self');
			}
		}
		we_helper.setBreadcrumb(crumb);

		page._search = page.$search_panel.searchPanel({
			uid: "admin_" + page._id,
			selectParam: _selectParam,
			actionBtn: _actionBtn,
			searchParam: _searchParam,
			autocomplete: _searchAutocomplete,
			defBtn: true,
			onSearch: function (data) {
				we_helper.reloadJqGrid(page.$table, data, 1);
			},
			onClear: function (data) {
				we_helper.reloadJqGrid(page.$table, data, 1);
			},
			onAction: function (keyBtn, data) {
				switch (keyBtn) {
					case "add": {
						page.showModal();
						break;
					}
					case "delete": {
						if (page._table_selected_rows.length === 0) {
							we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
							return;
						}
						page.deleteRecords(page._table_selected_rows, function () {
							page._table_selected_rows = [];
							we_helper.reloadJqGrid(page.$table);
						});
						break;
					}
					case "ad_search": {
						let cache_uid = "search_admin_adsearch";
						if (!!data.search_data) {
							let cache_data = {
								search_param: null,
								search_data: data.search_data,
								removeAfterInit: !we_helper.existInCache(cache_uid)
							};
							if (data.search_param === "0" || data.search_param === "2") {
								cache_data.search_param = "0"
							} else if (data.search_param === "3") {
								cache_data.search_param = "2"
							} else if (data.search_param === "4") {
								cache_data.search_param = "3"
							}
							if (!!cache_data.search_param) {
								we_helper.setCache(cache_uid, cache_data);
							}
						}
						window.open("/admin?pageid=adsearch", "_self");
						break;
					}
					case "export": {
						page.$dlgReportSettings.modal('show');
						break;
					}
					case "zup-sync": {
						let options = page._search.api().get_data();
						page.zupSync(options);
						break;
					}
					case "import": {
						let f_obj = page.getActionFilial();
						we_helper.setFormData(page.$dlgImport, {
							filialId: f_obj.id,
							filialName: f_obj.text,
						});
						page.$dlgImport.modal('show');
						break;
					}
					case "set_roles": {
						if (page._table_selected_rows.length === 0) {
							we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
							return;
						}
						$(".js_modal_set_roles").modal('show');
						break;
					}
					case "session_logon": {
						if (page._table_selected_rows.length === 0) {
							we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
							return;
						}
						page.logonSessions(page._table_selected_rows, function () {
							page._table_selected_rows = [];
							we_helper.reloadJqGrid(page.$table);
						});
						break;
					}
					default: {
						break;
					}
				}
			}
		});
		we_helper.initJqGrid(page.$table, _table_stg, page._search.api().get_data(), function () {
			$('.js-select-all-row').prop('checked',
				we_helper.isAllSelected($('.js-select-row', page.$table)));
		});
	},
	showModal: function (id) {
		if (!!id) {
			we_helper.getDataDB("/Admin/GetRecord", {
				pageid: page._id,
				id: id
			}, "query", false, function (entity) {
				page._data = entity;
				we_helper.setFormData(page._cruc.$modal, page._data);
				if (page._tinymce) {
					if (page._data.userTemplate === null) {
						page._data.userTemplate = "";
					}
					page._tinymce.setContent(page._data.userTemplate);
				}
				$('.modal-title', page._cruc.$modal).text(page._cruc.title[1]);
				page._cruc.$modal.modal('show');
				we_helper.hideLoader();
			});
		} else {
			let f_obj = page.getActionFilial();
			we_helper.getDataDB("/Admin/GetNextRecordNumber", {
				pageid: page._id,
				filialid: f_obj.id
			}, "query", false, function (entity) {
				we_helper.setFormData(page._cruc.$modal, {
					filialId: f_obj.id,
					filialName: f_obj.text,
					num: entity
				});
				$('.modal-title', page._cruc.$modal).text(page._cruc.title[0]);
				page._cruc.$modal.modal('show');
				we_helper.hideLoader();
			});
		}
	},
	deleteRecords: function (ids, callback) {
		we_helper.deleteDataDB("/Admin/DeleteRecords", {
			pageid: page._id,
			ids: ids
		}, function () {
			if (callback) {
				callback();
			}
		});
	},
	zupSync(options) {
		if (options.filialid === null || options.filialid === undefined) {
			we_helper.alert('Не выбрана структурная единица', notificatioType.danger);
			return;
		}
		we_helper.syncZupDataDB("/Admin/CorporateDataSync", { pageId: options.pageid, filialId: options.filialid }, function () {
			we_helper.reloadJqGrid(page.$table);
		});
	},
	updateRecord: function () {
		page._data = $.extend(page._data, we_helper.getFormData(page._cruc.$modal));
		if (page._tinymce) {
			let content = page._tinymce.getContent();
			if (content > 2048) {
				we_helper.alert("Превышена максимальная длина шаблона!", notificatioType.warning);
				return;
			}
			if (content === "" || content.length === 0) {
				content = null;
			}
			page._data.userTemplate = content;
		}
		let arcionUrl = !!page._data.id ? page._cruc.url[1] : page._cruc.url[0];
		we_helper.updateDataDB(arcionUrl, page._data, function () {
			we_helper.reloadJqGrid(page.$table);
			page._cruc.$modal.modal('hide');
		});
	},
	getActionFilial: function () {
		let srch_dt = page._search.api().get_data();
		if (!!srch_dt["filialid"]) {
			return {
				id: srch_dt["filialid"],
				text: srch_dt["filialname"]
			}
		} else if (!!page._cur_user_filial.id) {
			return page._cur_user_filial;
		} else if (!!page._sys_owner_filial.id) {
			return page._sys_owner_filial;
		} else {
			return {
				id: null,
				text: null
			};
		}
	},
	logonSessions: function (ids, callback) {
		we_helper.updateDataDB("/Admin/LogonUsersSessions", {
			ids: ids
		}, function () {
			if (callback) {
				callback();
			}
		});
	},
};