﻿$(function () {
    page.init();
    $(document).on('click', '.js_size_down', function () {
        page.sizeDown();
    });

    $(document).on('click', '.js_size_up', function () {
        page.sizeUp();
    });

    $(document).on('click', '.js_export', function () {
        page.$dlgReportSettings.modal('show'); 
    });

    $(document).on('click', '.js_save', function () {
        page.saveAlgorithm();
    });

    $(window).resize(function () {
        page.editorResize();
    });
});

var page = {
    _id: we_helper.getPageId(),
    _programmableid: we_helper.urlParam("programmableid"),
    _editor: CodeMirror.fromTextArea(document.getElementById("code"), {
        lineNumbers: true
    }),
    $codeMirror: $('.CodeMirror'),
    $dlgReportSettings: $(".js_modal_report_settings"),
    init: function () {
        we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" },
            { page: "Задания типа «Расчёт»", path: "/designer?pageid=programmable" },
            { page: "Алгоритм расчёта" }]);

        page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$dlgReportSettings);
        });
        $('.btn-success', page.$dlgReportSettings).on('click', function (e) {
            let data = {
                pageid: "programmablescript",
                programmableid: page._programmableid,
                format: $('input[name="fileformattype"]:checked').attr("id")
            }; 
            we_helper.getDataDB("/Designer/SaveReport", data, "body", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            }); 
        }); 
        we_helper.getDataDB("/Designer/GetProgrammableTaskWithAlgorithm", {
            id: page._programmableid
        }, "query", false, function (tsk) {
            $(".js_page_info").html("<strong>Номер и наименование задания:</strong> " + tsk.num + ". " + tsk.name).removeClass("d-none");
            if (!!tsk.algorithm) {
                page._editor.setValue(tsk.algorithm);
            }
            else {
                page._editor.setValue("");
            }
            page.setEditorFontSize();
            page.editorResize();
            page._editor.refresh();
            we_helper.hideLoader();
        });
    },
    getEditorFontSize: function () {
        let tmp = localStorage.getItem('font-size');
        if (!!tmp) {
            return parseInt(tmp);
        }
        return 14;
    },
    setEditorFontSize: function (font_size) {
        if (font_size === undefined || font_size === null) {
            font_size = page.getEditorFontSize();
        }
        page.$codeMirror.css('font-size', font_size + 'px');
        localStorage.setItem('font-size', font_size);
    },
    sizeUp: function () {
        let font_size = page.getEditorFontSize();
        page.setEditorFontSize(++font_size);
    },
    sizeDown: function () {
        let font_size = page.getEditorFontSize();
        page.setEditorFontSize(--font_size);
    },
    saveAlgorithm: function () {
        we_helper.updateDataDB("/Designer/UpdateProgrammableTaskAlgorithm", {
            id: page._programmableid,
            code: page._editor.getValue(),
        });
    }, 
    editorResize: function () {
        page.$codeMirror.height($(window).height() * 0.8);
    }
};

 