﻿$(function () {
    page.init();
});

var page = {
    _programid :we_helper.urlParam("programid"),
    _moduleid : we_helper.urlParam("moduleid"),
    _documentid :we_helper.urlParam("documentid"),
    _componentType: we_helper.urlParam("componentType"),
    _bookmarksHaveQuestion: [],
    _bookmarkLink: [], 
    _file_viewer: null, 
    $table: $(".js_table"),
    init: function () {
        if (page._moduleid == null || page._documentid == null) {
            window.open("/designer?pageid=program", "_self");
        }
        let crumb = [{ page: "Конструктор", path: "#" }];
        if (page._programid !== null) {
            crumb.push({ page: "Учебные курсы", path: "/designer?pageid=program" },
                { page: "Редактор содержания учебного курса", path: "/designer?pageid=programeditor&programid=" + page._programid + "&moduleid=" + page._moduleid + "&documentid=" + page._documentid });
        } else {
            crumb.push({ page: "Учебные модули", path: "/designer?pageid=module" },
                { page: "Компоненты модуля", path: "/designer?pageid=moduleunit&moduleid=" + page._moduleid + "&componentType=" + componentType });
        }
        crumb.push({ page: "Редактирование списка изучаемых закладок" });
        we_helper.setBreadcrumb(crumb);

        we_helper.getDataDB("/Designer/GetRecord", { pageid: "module", id: page._moduleid }, "query", false, function (info) {
            we_helper.getDataDB("/Designer/GetRecord", { pageid: "document", id: page._documentid }, "query", false, function (doc_info) {
                $(".js_page_info").html("<strong>Учебный модуль:</strong> " + info.num + ". " + info.name +
                    ";&nbsp<strong>Учебная единица:</strong> " + doc_info.num + ". " + doc_info.name).removeClass("d-none");
                we_helper.hideLoader();
            });
        });
        page.$table.on('click', '.js-select-row', function () {
            let id = $(this).attr("attr-id");
            let checked = $(this).prop("checked");
            let row = page.$table.jqGrid('getRowData', "g1_" + id);
            if (checked) {
                we_helper.updateDataDB("/Designer/IncludeQuestionsToModule", {
                    ids: [id],
                    moduleid: page._moduleid,
                    documentid: page._documentid
                }, function () {
                    if (!!row && !!row.bookMark) {
                        let curAnchorIndex = -1;
                        for (let i = 0; i < page._bookmarkLink.length; i++) {
                            if (page._bookmarkLink[i] == row.bookMark) {
                                curAnchorIndex = i;
                                break;
                            }
                        }
                        if (curAnchorIndex === -1) {
                            page._bookmarkLink.push(row.bookMark);
                            let $frame = page._file_viewer.api().getframe();
                            if ($frame) {
                                let src = $frame.attr("src");
                                if (!!src && src.indexOf("viewer.html") === -1 && row.bookMark.indexOf("#") !== -1) {
                                    $frame.contents().find("a[name=" + row.bookMark.split('#')[1] + "]").parent().addClass('checked');
                                }
                            }
                        }
                    }
                    we_helper.hideLoader();
                });
            } else {
                we_helper.updateDataDB("/Designer/ExcludeQuestionsFromModule", {
                    ids: [id],
                    moduleid: page._moduleid,
                    documentid: page._documentid
                }, function () {
                    if ($('.js-select-row:checked').length == 0 && !!row && !!row.bookMark) {
                        let $frame = page._file_viewer.api().getframe();
                        if ($frame) {
                            let src = $frame.attr("src");
                            if (!!src && src.indexOf("viewer.html") === -1 && row.bookMark.indexOf("#") !== -1) {
                                $frame.contents().find("a[name=" + row.bookMark.split('#')[1] + "]").parent().removeClass('checked');
                            }
                        }
                        page._bookmarkLink = jQuery.grep(page._bookmarkLink, function (value) {
                            return value != row.bookMark;
                        });
                    }
                    we_helper.hideLoader();
                }); 
            } 
        });
        page._file_viewer = $(".document-info").fileViewer({
            dialog: false,
            corheight: 0.8,
            onLoad: function ($frame) {
                if ($frame) {
                    let src = $frame.attr("src");
                    if (!!src) {
                        if (src.indexOf("viewer.html") !== -1) {
                            $frame.contents().find("a", $(".outlineItem")).on("click", function () {
                                let anchor = $(this).text();
                                we_helper.reloadJqGrid(page.$table, {
                                    bookmark: anchor
                                }, 1);
                            });
                        }
                        else {
                            let content = $frame.contents();
                            content.find('head').append('<style type="text/css"> .havequest {background: #d5e7ec;} .light {background: #cccccc;} .checked {background: #6699FF;}</style>')
                          
                            let pathToFile = content.get(0).location.pathname,
                                fileName = pathToFile.substring(pathToFile.lastIndexOf("/") + 1, pathToFile.length);

                            if (fileName.toLowerCase().indexOf('index.htm') === -1) {
                                for (var i = 0; i < page._bookmarkLink.length; i++) {
                                    let anchor = page._bookmarkLink[i];
                                    if (!!anchor && anchor.indexOf("#") !== -1) {
                                        content.find("a[name=" + anchor.split('#')[1] + "]").parent().addClass('checked');
                                    }
                                }

                                for (let i = 0; i < page._bookmarksHaveQuestion.length; i++) {
                                    let anchor = page._bookmarksHaveQuestion[i];
                                    if (!!anchor && anchor.indexOf("#") !== -1) {
                                        content.find("a[name='" + anchor.split('#')[1] + "']").parent().addClass('havequest');
                                    }
                                }

                                content.find('a').parent().mouseover(function (event) {
                                    $(this).addClass('light');
                                    $(this).css("cursor", "pointer");
                                }).mouseout(function () {
                                    $(this).removeClass('light')
                                }).click(function () {
                                    let anchor = $(this).find("a").attr("name");
                                    if (!!anchor) {
                                        anchor = fileName + "#" + anchor; 
                                        we_helper.reloadJqGrid(page.$table, {
                                            bookmark: anchor
                                        }, 1);
                                    }
                                });
                            }
                        }
                    }
                }
                we_helper.hideLoader();
            }
        });
        we_helper.getDataDB("/Designer/GetModuleUnit", { moduleid: page._moduleid, unitid: page._documentid, componentType: page._componentType }, "query", false, function (entity) {
            page._bookmarkLink = entity.bookMarks;
            we_helper.getDataDB("/Designer/GetDocumentBookmarksHaveQuestions", { documentid: page._documentid }, "query", false, function (bookmarksHaveQuestion) {
                page._bookmarksHaveQuestion = bookmarksHaveQuestion;
                page._file_viewer.api().view(entity.file);
            });
        });
        we_helper.initJqGrid(page.$table, {
            uid: "designer_modulebookmark",
            widthContainer: ".test-item-with-container",
            url: "/Designer/GetRecords",
            colNames: [
                '', '', '', 'Код', 'Тестовое задание', 'Тип', 'Закладка', 'Отв.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "questType", hidedlg: true, hidden: true, index: 'questType' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if (rowObject.include) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 170, index: 'name' },
                { name: "questTypeName", sortable: true, align: 'left', width: 50, index: 'questTypeName' },
                { name: "bookMark", sortable: true, align: 'left', width: 50, index: 'bookMark' },
                {
                    name: "answerCount", sortable: true, align: 'center', width: 15, index: 'answerCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.answerCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.answerCount + "</span>";
                    }
                }
            ],
            sortname: 'num',
            sortorder: 'asc',
            corr_height: -40,
            subGrid: true,
            subGridRowExpanded: function (subgrid_id, row_id) {
                we_helper.initAnswersJqGrid(page.$table, subgrid_id, row_id, "designer_modulebookmark_answers", 0.40);
            },
            beforeSelectRow: function (rowid, e) { return false; }
        }, {
            moduleid: page._moduleid,
            documentid: page._documentid,
            pageid: "modulebookmark",
            bookmark: null
        });
    } 
};
