﻿$(function () {
    page.init();
    $(window).resize(function () {
        page.resizeTree(); 
    });
});

var page = {
    _cur_user_filial: we_helper.getCurUserFilial(),
    _programId: we_helper.urlParam("programid"),
    _setSelectionNodeId: null,
    _data: {},
    _bookmarkLink: [],
    _curBookmark: 0,
    $tree: $(".js_program_tree"),
    _file_viewer: null, 
    $modal: $(".js_module_edit_modal"),  
    init: function () {
        if (page._programId == null) {
            window.open("/designer?pageid=program", "_self");
        }
        page._setSelectionNodeId = page._programId;
        if (we_helper.urlParam("moduleid") !== null) {
            page._setSelectionNodeId += ";" + we_helper.urlParam("moduleid");
        }
        if (we_helper.urlParam("documentid") !== null) {
            page._setSelectionNodeId += ";" + we_helper.urlParam("documentid");
        }

        we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" }, { page: "Учебные курсы", path: "/designer?pageid=program" }, { page: "Редактор содержания учебного курса" }]);
        we_helper.initSelect('/Designer/GetEnums?name=componentType', $('.select2.js-content-type', page.$modal), null, false, true);

        page.$modal.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$modal, page._data);
        });
        $("#btn-add-module-in-prog").on("click", function () {
            let ids = page.getTreeSelectRowId().split(";");
            page.showModalEditModule(ids[0]);
        });
        $("#btn-include-modules-in-prog").on("click", function () {
            window.open("/designer?pageid=includemodule&backpageid=programeditor&programid=" + page._programId, "_self");
        });
        $("#btn-include-unit-in-module").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                window.open("/designer?pageid=includeunit&programid=" + ids[0] + "&moduleid=" + ids[1] + "&componentType=" + row["componentType"], "_self");
            }
        });
        $("#btn-edit-module-in-prog").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";"); 
                page.showModalEditModule(ids[0], ids[1]);
            }
        });
        $("#btn-exclude-module-from-prog").on("click", function () {
            let ids = page.getTreeSelectRowId().split(";");
            we_helper.deleteDataDB("/Designer/DeleteModuleFromProgram", {
                programid: ids[0],
                ids: [ids[1]]
            }, function () {
                page._setSelectionNodeId = page._programId;
                page.reloadTree();
            }, true);
        });
        $("#btn-module-test-editor").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                window.open("/designer?pageid=testeditor&programid=" + ids[0] + "&moduleid=" + ids[1] + "&componentType=" + row["componentType"], "_self");
            }
        });
        $("#btn-include-module-in-progs").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null) {
                let ids = row["id"].split(";");
                window.open("/designer?pageid=modulecourses&programid=" + ids[0] + "&moduleid=" + ids[1], "_self");
            }
        });
       
        $('.js_modal_save_change', page.$modal).on('click', function (e) {
            if (we_helper.checkValidation(page.$modal) === true) {
                page.updateProgramModuleRecord();
            }
            e.preventDefault();
        });
        
        $("#btn-module-question").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                window.open("/designer?pageid=modulequestion&programid=" + ids[0] + "&moduleid=" + ids[1] + "&documentid=" + ids[2] + "&componentType=" + row["componentType"], "_self");
            } 
        });
        $("#btn-module-bookmark").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                window.open("/designer?pageid=modulebookmark&programid=" + ids[0] + "&moduleid=" + ids[1] + "&documentid=" + ids[2] + "&componentType=" + row["componentType"], "_self");
            }
        }); 
        $("#btn-delete-module-unit").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                we_helper.deleteDataDB("/Designer/DeleteUnitFromProgramModule", {
                    moduleid: ids[1],
                    ids: [ids[2]]
                }, function () {
                    page._setSelectionNodeId = ids[0] + ";" + ids[1];
                    page.reloadTree();
                }, false);
            }
        }); 
        $("#cb-allow-trial-question").on("change", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                we_helper.updateDataDB("/Designer/UpdateAllowTrialQuestionProperty", {
                    programid: ids[0],
                    moduleid: ids[1],
                    unitid: ids[2],
                    ischecked: $(this).prop("checked")
                });
            }
        });
        $("#cb-study-doc-parts").on("change", function () {
            let row = page.getTreeSelectRowData();
            if (row !== null && row["owner"] === "true") {
                let ids = row["id"].split(";");
                we_helper.updateDataDB("/Designer/UpdateStudyDocPartsProperty", {
                    programid: ids[0],
                    moduleid: ids[1],
                    unitid: ids[2],
                    ischecked: $(this).prop("checked")
                });
            }
        });

        we_helper.initJqTreeGrid(page.$tree, {
            url: "/Designer/GetProgramTree",
            colNames: ['id', '', '', 'Учебный курс'],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "componentType", hidedlg: true, hidden: true, index: 'componentType' },
                { name: "owner", hidedlg: true, hidden: true, index: 'owner' },
                {
                    name: "name", sortable: false, align: 'left', width: 150, index: 'name',
                    formatter: function (cellvalue, options, rowObject) {
                        let owner = "";
                        if (!rowObject.owner && (rowObject.level === 1 || rowObject.level === 2)) {
                            owner = '<span class="text-danger" title="Редактирование параметров компонента недоступно">*</span>';
                        }
                        return owner + "<span class='" + page.getTreeNodeIcon(rowObject.level, rowObject.componentType, rowObject.internal) + " pr-1 icon-size'></span>" + rowObject.name;
                    }
                } 
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) {
                if ($(e.target).hasClass("treeclick")) {
                    return false;
                }
                return $(this).getGridParam('selrow') != rowid;
            },
            onSelectRow: function (id) {
                page._curBookmark = 0;
                page._bookmarkLink = [];
                $("#cb-allow-trial-question, #cb-study-doc-parts").attr('disabled', true);
                $(".program-info, .module-info, .unit-info, .document-info, .content-type-0, #btn-module-question, #btn-module-bookmark, #btn-delete-module-unit, #btn-include-unit-in-module, #btn-edit-module-in-prog, #btn-module-test-editor").addClass("d-none");
                let ids = id.split(";");
                page._setSelectionNodeId = id;
                let row = page.getTreeSelectRowData(id);
                if (row !== null) {
                    if (ids.length == 1) {
                        page.getProgramInfo(ids[0]);
                    } else if (ids.length == 2) {
                        page.getModuleInfo(ids[0], ids[1], row["owner"] );
                    } else if (ids.length == 3) {
                        page.getUnitInfo(ids[1], ids[2], row["componentType"], row["owner"]);
                    } 
                }
            }
        }, function () {
            $(".tree-leaf").addClass("d-none");
            page.$tree.jqGrid('setSelection', page._setSelectionNodeId);
            we_helper.jqGridTreeExpandToNode(page.$tree, page.$tree.jqGrid('getLocalRow', page._setSelectionNodeId));
            $(".jqgrow", page.$tree).addClass("cursor-pointer");
        });
        page._file_viewer = $(".document-info").fileViewer({
            dialog: false,
            corheight: 0.25,
            onLoad: function ($frame) {
                if ($frame) {
                    let src = $frame.attr("src");
                    page._file_viewer.api().disabledActionBtn([0, 3]);
                    if (!!src && page._bookmarkLink.length > 0) {
                        if (page._bookmarkLink.length > 1) {
                            page._file_viewer.api().enabledActionBtn([3]);
                        }
                        if (src.indexOf("viewer.html") !== -1) {
                            page._file_viewer.api().showActionMenu(); 
                        }
                        else {
                            let content = $frame.contents();
                            content.find('head').append('<style type="text/css"> .light {background: #cccccc;} </style>')

                            for (var i = 0; i < page._bookmarkLink.length; i++) {
                                let anchor = page._bookmarkLink[i];
                                if (!!anchor && anchor.indexOf("#")!==-1) {
                                    content.find("a[name=" + anchor.split('#')[1] + "]").parent().addClass('light'); 
                                }
                            } 
                        }
                    }
                }
                we_helper.hideLoader();
            },
            onPrev: function () {
                if (page._curBookmark > 0) {
                    page._curBookmark--;
                    page._file_viewer.api().gotoAnchor(page._bookmarkLink[page._curBookmark]);
                    if (page._curBookmark == 0) {
                        page._file_viewer.api().disabledActionBtn([0]);
                    }
                }
                page._file_viewer.api().enabledActionBtn([3]);
            },
            onNext: function () {
                if (page._curBookmark < page._bookmarkLink.length - 1) {
                    page._curBookmark++;
                    page._file_viewer.api().gotoAnchor(page._bookmarkLink[page._curBookmark]);
                    if (page._curBookmark == page._bookmarkLink.length - 1) {
                        page._file_viewer.api().disabledActionBtn([3]);
                    }
                }
                page._file_viewer.api().enabledActionBtn([0]);
            }
        });
        page.resizeTree();
        page.reloadTree();
    },
    reloadTree: function () {
        page.getProgramTestingInfo(page._programId);
        page.$tree.setGridParam({
            page: 1, datatype: 'json', postData: {
                programId: page._programId
            }
        }).trigger("reloadGrid");
        page.$tree.jqGrid('resetSelection');
    },
    resizeTree: function () {
        $('#split-0 .ui-jqgrid-bdiv').css({ 'height': ($(window).height() - 90) + 'px' });
    },
    getTreeSelectRowId: function () {
        return page.$tree.jqGrid('getGridParam', 'selrow');
    },
    getTreeSelectRowData: function (rowId) {
        if (!rowId) {
            rowId = page.getTreeSelectRowId();
        }
        if (rowId == null) { return null; }
        return page.$tree.jqGrid('getRowData', rowId);
    },
    getTreeNodeIcon: function (level, componentType, internal) {
        let result = "text-primary ";
        if (internal) {
            result = "text-secondary ";
        }
        if (level == 0) {
            result += "mdi mdi-school";
        } else if (level == 1) {
            switch (componentType) {
                case 1: {
                    result += "mdi mdi-bike";
                    break;
                }
                case 2: {
                    result += "mdi mdi-tournament";
                    break;
                }
                case 3: {
                    result += "mdi mdi-code-braces";
                    break;
                }
                default: {
                    result += "mdi mdi-folder-outline";
                    break;
                }
            }
        } else if (level == 2) {
            result += "mdi mdi-file-outline";
        }
        return result;
    },
    getProgramTestingInfo: function (programid) {
        we_helper.getDataDB("/Designer/ProgramTestItemCountInfo", {
            programid: programid
        }, "query", false, function (entity) {
            if (entity.theoryTestItemCount[0] != 0) {
                $("[name=theoryTotalItemCount]").text(entity.theoryTestItemCount[0]);
                $("[name=theoryItemsInTest]").text(entity.theoryTestItemCount[1]);
            }
            if (entity.trainingTestItemCount[0] != 0) {
                $("[name=trainingTotalItemCount]").text(entity.trainingTestItemCount[0]);
                $("[name=trainingItemsInTest]").text(entity.trainingTestItemCount[1]);
            }
            if (entity.sequenceTaskTestItemCount[0] != 0) {
                $("[name=sequenceTaskTotalItemCount]").text(entity.sequenceTaskTestItemCount[0]);
                $("[name=sequenceTaskItemsInTest]").text(entity.sequenceTaskTestItemCount[1]);
            }
            if (entity.programmableTaskTestItemCount[0] != 0) {
                $("[name=programmableTaskTotalItemCount]").text(entity.programmableTaskTestItemCount[0]);
                $("[name=programmableTaskItemsInTest]").text(entity.programmableTaskTestItemCount[1]);
            }
           
            we_helper.hideLoader();
        });
    },
    getProgramInfo: function (programid) {
        $(".program-info").removeClass("d-none");
        we_helper.getDataDB("/Designer/GetRecord?pageid=program", {
            id: programid  
        }, "query", false, function (entity) {
            let programContainer = $(".program-info");
            entity.dateOfChange = we_helper.convertDateFull(entity.dateOfChange);
            we_helper.setFormData(programContainer, entity);
            programContainer.removeClass("d-none");
            we_helper.hideLoader();
        });

    },
    getModuleInfo: function (programid, moduleid, owner) {
        we_helper.getDataDB("/Designer/GetProgramModule", { programid: programid, moduleid: moduleid }, "query", false, function (entity) {
            if (owner === "true") {
                $("#btn-include-unit-in-module, #btn-edit-module-in-prog, #btn-module-test-editor").removeClass("d-none");
            }
            let moduleContainer = $(".module-info");
            entity.dateOfChange = we_helper.convertDateFull(entity.dateOfChange);
            we_helper.setFormData(moduleContainer, entity);
            moduleContainer.removeClass("d-none");
            we_helper.hideLoader();
        });
    },
    getUnitInfo: function (moduleid, unitid, componentType, owner) {
        we_helper.getDataDB("/Designer/GetModuleUnit", {
            moduleid: moduleid,
            unitid: unitid,
            componentType: componentType
        }, "query", false, function (entity) {
            let unitContainer = $(".unit-info");
            entity.dateOfChange = we_helper.convertDateFull(entity.dateOfChange);

            let $totalQuestionCount = $("[name=totalQuestionCount]", unitContainer);
            if (entity.questionsOnUpdating) {
                $totalQuestionCount.attr("title", "Тестовые задания на проверке с " + we_helper.convertDate(entity.questionsOnUpdating))
                    .removeClass("badge-primary").addClass("badge-warning");
            } else {
                $totalQuestionCount.attr("title", "").removeClass("badge-warning").addClass("badge-primary");
            }
            we_helper.setFormData(unitContainer, entity);
            $(".total-item-count").text("Всего вариантов:");
            $(".total-item-control-count").text("Выбрано вариантов для контроля:");
            if (componentType === "0") {
                $(".total-item-count").text("Выбрано заданий:");
                $(".total-item-control-count").text("Выбрано заданий для контроля:");
                let link = null;
                page._bookmarkLink = entity.bookMarks;
                $("[name=totalBookmarkCount]").text(page._bookmarkLink.length);
                if (page._bookmarkLink.length != 0) {
                    link = page._bookmarkLink[0];
                }
                page._file_viewer.api().view(entity.file, link);
                if (owner === "true") {
                    $("#btn-module-question, #btn-module-bookmark").removeClass("d-none");
                    $("#cb-allow-trial-question, #cb-study-doc-parts").attr('disabled', false);
                }
                $(".content-type-0, .document-info").removeClass("d-none");
            }
            if (owner === "true") {
                $("#btn-delete-module-unit").removeClass("d-none");
            }
            unitContainer.removeClass("d-none");
            we_helper.hideLoader();
        });
    }, 
    showModalEditModule: function (programid, moduleid) {
        if (!!moduleid) {
            we_helper.getDataDB("/Designer/GetProgramModule", {
                programid: programid,
                moduleid: moduleid
            }, "query", false, function (entity) {
                page._data = entity;
                we_helper.setFormData(page.$modal, page._data);
                 
                $('.modal-title', page.$modal).text('Редактирование параметров учебного модуля');
                page.$modal.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.getDataDB("/Designer/GetProgramModuleNextRecordNumber", { programid: programid }, "query", false, function (entity) {
                we_helper.setFormData(page.$modal, { num: entity[0], numInCourse: entity[1] });
                $('.modal-title', page.$modal).text('Создание нового модуля в составе учебного курса');
                page.$modal.modal('show');
                we_helper.hideLoader();
            });
        }
    },
    updateProgramModuleRecord: function () {
        let url = "/Designer/CreateModuleAndIncludeToProgramm";
        page._data = $.extend(page._data, we_helper.getFormData(page.$modal));
        if (!!page._data.id) {
            url = "/Designer/UpdateProgrammModule";
        }
        page._data["programid"] = page._programId;
        we_helper.updateDataDB(url, page._data, function () {
            page.reloadTree();
            page.$modal.modal('hide');
        });
    }
};