﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _documentId: we_helper.urlParam("documentid"), 
    _data: {},
    _table_selected_rows: [],
    _search: null,
    _file_viewer: null, 
    $table: $(".js_table"),
    $modal: $(".js_detail_modal"),
    $dlgReportSettings: $(".js_modal_report_settings"),
    $answer_editor_modal: $(".js_answer_edit_modal"), 
    $dlgImport: $(".js_modal_import"),
    $btn_download_import_template: $('.js_modal_download_template'),
    init: function (_pageInfo) {
        if (page._id !== "question") {
            window.open('/', '_self');
        } 
        if (page._documentId == null) {
            window.open("/designer?pageid=theoretical", "_self");
        }
        we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" }, { path:"/designer?pageid=theoretical", page: "Теоретические материалы" }, { page: "Тестовые задания" }]);     
        we_helper.getDataDB("/Designer/GetRecord", { pageid: "document", id: page._documentId }, "query", false, function (info) {
            $(".js_page_info").html("<strong>Номер и наименование документа:</strong> " + info.num + ". " + info.name).removeClass("d-none");
            we_helper.hideLoader();
        }); 
        $(document).on('click', '#export-tis-tab, #export-tis-for-edit-tab', function () {
            let tab = $(this).attr("id"); 
            if (tab === "export-tis-for-edit-tab") {
                $('input[name="fileformattype"]').prop('checked', false).prop('disabled', true);
            } else {
                $('input[name="fileformattype"]').prop('disabled', false);
                $('input[name="fileformattype"][id=".pdf"]').trigger('click');
            }
        });
        page.$modal.on('hidden.bs.modal', function (e) { 
            $('label[name=fileName]', page.$modal).text('');
            we_helper.clearModal(page.$modal, page._data);
        });
        page.$answer_editor_modal.on('hidden.bs.modal', function (e) {
            $("[name=questionId]", page.$answer_editor_modal).val("");
            $(".qt-0, .qt-1, .qt-2, .qt-3", page.$answer_editor_modal).addClass("d-none");
            we_helper.clearModal(page.$answer_editor_modal, page._data);
        });

        page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$dlgReportSettings);
        });
        $('.btn-success', page.$dlgReportSettings).on('click', function (e) {
            let data = page._search.api().get_data();
            let gridParam = page.$table.jqGrid('getGridParam', 'postData');
            data["sidx"] = gridParam.sidx;
            data["sord"] = gridParam.sord;
            data["format"] = $('input[name="fileformattype"]:checked').attr("id");
            let tabid = $("a.active", page.$dlgReportSettings).attr("id");
            if (tabid === "export-tis-for-edit-tab") {
                data["format"] = ".csv";
            }
            if (!!tabid) {
                tabid = tabid.substring(0, tabid.lastIndexOf("-"));
                data["tabid"] = tabid;
                data = $.extend(data, we_helper.getFormData($("#" + tabid)));
            }
            data["documentid"] = page._documentId;
            we_helper.getDataDB("/Designer/SaveReport", data, "body", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            });
        }); 
         
        $('.js_modal_save_change', page.$modal).on('click', function (e) {
            if (we_helper.checkValidation(page.$modal) === true) {
                page.onSaveQuestion();
            }
            e.preventDefault();
        });
        $('.js_answer_modal_save_change', page.$answer_editor_modal).on("click", function (e) {
            if (we_helper.checkValidation(page.$answer_editor_modal) === true) {
                page.onSaveAnswer();
            }
            e.preventDefault();
        });
        $('.js_modal_import_start', page.$dlgImport).on('click', function (e) {
            let $upload = $("#importDataFileUploader");
            if ($upload.length <= 0 || $upload.get(0).files.length != 1) {
                we_helper.alert("Выберите файл!", notificatioType.warning);
                return;
            }

            let files = $upload.get(0).files;
            var formData = new FormData();
            formData.append(files[0].name, files[0]);
            formData.append("documentid", page._documentId);
            formData.append("pageid", page._id);

            we_helper.uploadFile("/Designer/ImportData", formData, function () {
                page.$dlgImport.modal('hide');
                we_helper.reloadJqGrid(page.$table);
            });
        });
        page.$btn_download_import_template.on('click', function (e) {
            we_helper.getDataDB("/Designer/DownloadImportTemplate", { pageid: page._id, rowid: page._documentId }, "query", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            });
        });
        page.$table.on('click', 'a.js_edit_table_record', function () {
            let parid = $(this).attr("par-id");
            if (!!parid) {
                page.onShowCucModalAnswer(parid, $(this).attr("attr-id"));
            } else {
                page.onShowCucModalQuestion("edit", $(this).attr("attr-id"));
            }
        });
        page.$table.on('click', 'a.js_copy_table_record', function () {
            page.onShowCucModalQuestion("copy", $(this).attr("attr-id"));
        });

        page.$table.on('click', 'a.js_download_file_table_record', function () {
            we_helper.getDataDB("/Designer/DownloadFile", { pageid: "question", id: $(this).attr("attr-id") }, "query", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            });  
        });

        page.$table.on('click', 'a.js_del_table_record', function () {
            let id = $(this).attr("attr-id");
            let parid = $(this).attr("par-id");
            if (!!parid) {
                page.deleteRecords([id], "answer", function () {
                    page.reloadAnswersGrid(parid);
                });
            } else {
                page.deleteRecords([id], "question", function () {
                    let index = $.inArray(id, page._table_selected_rows);
                    if (index !== -1) {
                        page._table_selected_rows.splice(index, 1);
                    }
                    we_helper.reloadJqGrid(page.$table);
                });
            }
        });
        page.$table.on('click', 'a.js_del_file_table_record', function () {
            let id = $(this).attr("attr-id");
            page.deleteFiles([id], function () {
                let index = $.inArray(id, page._table_selected_rows);
                if (index !== -1) {
                    page._table_selected_rows.splice(index, 1);
                }
                we_helper.reloadJqGrid(page.$table);
            });
        });
        page.$table.on('click', '.js-select-row', function () {
            we_helper.multipleSelection($(this), page._table_selected_rows);
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
        page.$table.parent().on('click', '.js-select-all-row', function () {
            we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
        });
        page.$table.on('click', 'a.js_add_table_record', function () {
            page.onShowCucModalAnswer($(this).attr("attr-id"));
        });
        page.$table.on('click', 'a.js_view_question_link', function () {
            page.cacheDocumentBeforeOpen(page._documentId, $(this).attr("link-id"));
        });
        we_helper.initSelect('/Admin/GetRecordsKeyText', $(".select2.js-export-ti-publisher, .select2.js-export-ti-for-edit-publisher", page.$dlgReportSettings), {
            pageid: "filial"
        }, true, false);
        we_helper.initSelect('/Designer/GetEnums?name=questType', $('.select2.js-quest-type', page.$modal), null, false, true);
        $(".js-select-bookmark", page.$modal).on("click", function () {
            let link = $(".js-book-mark", page.$modal).val();
            page.cacheDocumentBeforeOpen(page._documentId, link);
        });
        page._file_viewer = $(".js_file_viewer_dialog").fileViewer({
            dialog: true,
            onLoad: function ($frame) {
                if ($frame) {
                    let src = $frame.attr("src");
                    if (!!src) {
                        if (src.indexOf("viewer.html") !== -1) {
                            $frame.contents().find("a", $(".outlineItem")).on("click", function () {
                                $("input[name=bookMark]").val($(this).text());
                            });
                        }
                        else {
                            let content = $frame.contents();
                            content.find('head').append('<style type="text/css"> .light {background: #cccccc;} .checked {background: #6699FF;}</style>')

                            let anchor = content.get(0).location.hash;
                            if (!!anchor) {
                                if (anchor.indexOf("#") === 0) {
                                    anchor = anchor.substring(1, anchor.length);
                                }
                                content.find("a[name=" + anchor + "]").parent().addClass('checked');
                            }

                            let pathToFile = content.get(0).location.pathname,
                                fileName = pathToFile.substring(pathToFile.lastIndexOf("/") + 1, pathToFile.length);

                            if (fileName.toLowerCase().indexOf('index.htm') === -1) {
                                content.find('a').parent().mouseover(function (event) {
                                    $(this).addClass('light');
                                    $(this).css("cursor", "pointer");
                                }).mouseout(function () {
                                    $(this).removeClass('light')
                                }).click(function () {
                                    content.find("a").parent().removeClass('checked');
                                    let anchor = $(this).find("a").attr("name");
                                    if (anchor != null) {
                                        $(".js-book-mark", page.$modal).val(fileName + "#" + anchor);
                                        $(this).addClass('checked');
                                    }
                                });
                            }
                        }
                    }
                }
                we_helper.hideLoader();
            }
        });
        page._search = $('.js_search_panel').searchPanel({
            uid: "designer_" + page._id,
            selectParam: [],
            actionBtn: [{
                id: "add",
                icon: "mdi mdi-plus",
                style: "success",
                text: "Создать"
            }, {
                id: "delete",
                icon: "mdi mdi-delete",
                style: "danger",
                text: "Удалить"
            },
            {
                id: "export",
                icon: "mdi mdi-database-export",
                style: "info",
                text: "Отчёт"
            },
            {
                id: "import",
                icon: "mdi mdi-database-import",
                style: "primary",
                text: "Импорт"
            }, 
            //{
            //    id: "send_to_curator",
            //    icon: "mdi mdi-send",
            //    style: "info",
            //    text: "Отправить проверяющим"
            //}, 
            {
                id: "include_in_modules",
                icon: "mdi mdi-skew-more",
                style: "info",
                text: "Включить в учебные модули"
            }
            ],
            searchParam: {
                params: [
                    { text: 'Тестовое задание или код', placeholder: 'Введите часть наименования или код тестового задания' },
                    { text: 'Код', placeholder: 'Введите код тестового задания' },
                    { text: 'Тестовое задание', placeholder: 'Введите часть наименования тестового задания' },
                    { text: 'Закладка', placeholder: 'Введите часть текста закладки' },
                    { text: 'Составитель', placeholder: 'Введите часть наименования области данных составителя' },
                    { text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            autocomplete: {
                enable: true,
                url: "/Designer/GetAutocompleteRecords",
            },
            defBtn: true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onAction: function (keyBtn, data) {
                switch (keyBtn) {
                    case "add": {
                        page.onShowCucModalQuestion("add");
                        break;
                    } 
                    case "delete": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.deleteRecords(page._table_selected_rows, "question", function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    case "export": { 
                        page.$dlgReportSettings.modal('show');
                        break;
                    } 
                    case "include_in_modules": { 
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }

                        page.includeQuestsInModulesUseDocument(page._table_selected_rows, page._documentId, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    case "send_to_curator": { 
                        page.sendQuestionsToCurator(page._documentId);
                        break;
                    }
                    case "import": { 
                        page.$dlgImport.modal('show');
                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        we_helper.initJqGrid(page.$table, {
            uid: "designer_" + page._id,
            url: "/Designer/GetRecords",
            colNames: [
                '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код', 'Тестовое задание', 'Тип', 'Закладка', 'Составитель',
                'Дата изменения', 'Изменил', 'Мод.', 'Бил.', 'Отв.', 'Доб.', 'Файл', 'Уд.файл', 'Ред.',  'Коп.',  'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 25, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
                { name: "questTypeName", sortable: true, align: 'left', width: 50, index: 'questTypeName' },
                {
                    name: "bookMark", sortable: true, align: 'left', width: 55, index: 'bookMark', formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.bookMark !== null && rowObject.bookMark !== "") {
                            return "<a class='text-info js_view_question_link' href='#' link-id='" + rowObject.bookMark + "'>" + rowObject.bookMark + "</a>";
                        }
                        return "";
                    }
                }, 
                { name: "publisherName", sortable: true, align: 'left', width: 50, index: 'publisherName' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 45, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 50, index: 'userHasChanged' },
                {
                    name: "moduleCount", sortable: true, align: 'center', width: 15, index: 'moduleCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.moduleCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.moduleCount + "</span>";
                    }
                },
                {
                    name: "ticketCount", sortable: true, align: 'center', width: 15, index: 'ticketCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.ticketCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.ticketCount + "</span>";
                    }
                },
                {
                    name: "answerCount", sortable: true, align: 'center', width: 15, index: 'answerCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.answerCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.answerCount + "</span>";
                    }
                }, 
                {
                    name: "btnAnswerAdd", sortable: true, align: 'center', width: 15, index: 'btnAnswerAdd', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-plus text-success js_add_table_record' href='#' quest-type-id='" + rowObject.questType + "' attr-id='" + rowObject.id + "' title='Добавить ответ'></a>";
                    }
                },
                {
                    name: "isHaveFile", sortable: true, align: 'center', width: 15, index: 'isHaveFile', formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.isHaveFile) {
                            return "<a class='mdi mdi-file-download-outline text-info js_download_file_table_record' attr-id='" + rowObject.id + "' target='_blank' title='Скачать файл'></a>";
                        }
                        return "";
                    }
                },
                {
                    name: "btnDeleteFile", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.isHaveFile) {
                            return "<a class='mdi mdi-file-remove text-danger js_del_file_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить файл'></a>";
                        }
                        return "";
                    }
                },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnCopy", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-content-copy text-info js_copy_table_record' href='#' attr-id='" + rowObject.id + "' title='Копировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                }
            ],
            sortname: 'num',
            sortorder: 'asc',
            corr_height: -40,
            subGrid: true,
            subGridRowExpanded: function (subgrid_id, row_id) {
                page.initAnswersGrid(subgrid_id, row_id);
            },
            beforeSelectRow: function (rowid, e) { return false; }
        }, page._search.api().get_data(), function () {
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
    }, 
    onShowCucModalQuestion: function (act, id) {
        if (act === "edit" || act === "copy") {
            we_helper.getDataDB("/Designer/GetRecord?pageid=" + page._id, {  id: id  }, "query", false,  function (entity) {
                page._data = entity;
                page._data["actionid"] = act;
                if (!!entity.extension) {
                    page._data["fileName"] = entity.id + entity.extension;
                }
                we_helper.setFormData(page.$modal, page._data);
                let modaltitle = 'Редактирование параметров тестового задания';
                if (act === "copy") {
                    modaltitle = 'Создание копии тестового задания'; 
                }
                $('.modal-title', page.$modal).text(modaltitle);
                $(".quest-type-container").addClass("d-none"); 
                page.$modal.modal('show');
                we_helper.hideLoader();
            });
        } else if (act === "add") {
            we_helper.getDataDB("/Designer/GetNextRecordNumber", {
                pageid: "question",
                documentid: page._documentId
            }, "query", false, function (entity) {
                we_helper.setFormData(page.$modal, { 
                    documentId: page._documentId,
                    num: entity
                });
                $('.modal-title', page.$modal).text('Создание нового тестового задания');
                $(".quest-type-container").removeClass("d-none"); 
                page.$modal.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.alert("Некорректно задан код действия: " + act, notificatioType.warning);
        }
    },
    deleteRecords: function (ids, pageid, callback) {
        we_helper.deleteDataDB("/Designer/DeleteRecords", {
            pageid: pageid,
            ids: ids
        }, function () {
            if (callback) {
                callback();
            }
        }, true);
    },
    deleteFiles: function (ids, callback) {
        we_helper.deleteDataDB("/Designer/DeleteFiles", {
            pageid: page._id,
            ids: ids
        }, function () {
            if (callback) {
                callback();
            }
        }, true);
    },
    onSaveQuestion: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$modal));
        let actionUrl = "/Designer/CreateQuestion";
        if (!!page._data.id) {
            if (page._data["actionid"] === "edit") {
                actionUrl = "/Designer/UpdateQuestion"
            } else if (page._data["actionid"] === "copy") {
                actionUrl = "/Designer/CopyQuestion"
            }
        }

        let $upload = $("#fileUploader");
        if ($upload.length > 0 && $upload.get(0).files.length > 0) {
            let files = $upload.get(0).files;
            var formData = new FormData();
            formData.append(files[0].name, files[0]);
            if (page._data) {
                $.each(page._data, function (key) {
                    if ($.isArray(page._data[key])) {
                        for (var i = 0; i < page._data[key].length; i++) {
                            formData.append(key + "[]", page._data[key][i]);
                        }
                    } else {
                        formData.append(key, page._data[key]);
                    }
                });
            }
            we_helper.uploadFile(actionUrl, formData, function () {
                page._table_selected_rows = [];
                we_helper.reloadJqGrid(page.$table);
                page.$modal.modal('hide');
            });
        }
        else {
            we_helper.updateDataDB(actionUrl, page._data, function () {
                page._table_selected_rows = [];
                we_helper.reloadJqGrid(page.$table);
                page.$modal.modal('hide');
            });
        }
    },
    cacheDocumentBeforeOpen: function (id, link) {
        we_helper.getDataDB("/Designer/CacheDocumentBeforeOpen", { documentid: id }, "query", false, function (entity) {
            page._file_viewer.api().view(entity, link);
        });
    },
    includeQuestsInModulesUseDocument: function (ids, documentid, callback) {
        bootbox.confirm({
            message: "Вы уверены, что хотите включить выбранные тестовые задания (" + ids.length + ") в учебные модули своей области данных, в которых используется документ?",
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    $.ajax({
                        url: "/Designer/IncludeQuestsInModulesUseDocument",  
                        type: 'POST',
                        cache: false,
                        data: {
                            ids: ids,
                            documentid: documentid
                        },
                        success: function (response) {
                            if (response.result == 1) {
                                we_helper.alert("Данные успешно сохранены.", notificatioType.success);

                            } else {
                                we_helper.alert(response.message, notificatioType.danger);
                            }

                            if (callback) {
                                callback();
                            } else {
                                we_helper.hideLoader();
                            }
                        },
                        error: function (err) {
                            we_helper.hideLoader();
                            we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                        }
                    });
                }
            }
        });
    },
    sendQuestionsToCurator: function (documentid) {
        bootbox.confirm({
            message: "Вы уверены, что хотите отправить проверяющим, ответственным за актуальность документа, тестовые задания на проверку?",
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    $.ajax({
                        url: "/Designer/SendQuestionsToCurator",
                        type: 'POST',
                        cache: false,
                        data: {
                            documentId: documentid
                        },
                        success: function (response) {
                            if (response.result == 1) {
                                we_helper.alert("Данные успешно отправлены.", notificatioType.success);

                            } else {
                                we_helper.alert(response.message, notificatioType.danger);
                            }
                            we_helper.hideLoader();
                        },
                        error: function (err) {
                            we_helper.hideLoader();
                            we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
                        }
                    });
                }
            }
        });
    },
    initAnswersGrid: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let questionid = row_id.split('_')[1];
        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            uid: "designer_" + page._id + "_answers",
            postData: {
                questionid: questionid,
                pageid: "answer"
            },
            url: "/Designer/GetRecords",
            colNames: [
                '', 'Код', 'Ответ', 'Ассоциация', 'Верно', 'Эталон', 'Точность', 'Дата изменения', 'Изменил', 'Ред.', 'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num', hidden: true },
                { name: "name", sortable: true, align: 'left', width: 200, index: 'name', hidden: true },
                { name: "conformity", sortable: true, align: 'left', width: 200, index: 'conformity', hidden: true },
                {
                    name: "correct", sortable: true, align: 'center', width: 30, index: 'correct', hidden: true,
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.correct) {
                            return 'ДА';
                        }
                        return 'НЕТ';
                    }
                },
                { name: "numeric", sortable: true, align: 'left', width: 100, index: 'numeric', hidden: true },
                { name: "prec", sortable: true, align: 'left', width: 100, index: 'prec', hidden: true },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 55, index: 'userHasChanged' },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' par-id='" + questionid + "' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' par-id='" + questionid + "' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                }
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        }, null, function () {
            let questType = $(".js_add_table_record[attr-id='" + questionid + "']").attr("quest-type-id");
            if (questType === "0") {
                $("#" + subgrid_table_id).showCol(["num", "name", "correct"]);
            } else if (questType === "1") {
                $("#" + subgrid_table_id).showCol(["num", "name"]);
            } else if (questType === "2") {
                $("#" + subgrid_table_id).showCol(["name", "conformity"]);
            } else if (questType === "3") {
                $("#" + subgrid_table_id).showCol(["numeric", "prec"]);
            }
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.80);
        }).trigger('resize');
    },
    reloadAnswersGrid: function (questionid) {
        let files_grid = $("#jqg1_g1_" + questionid + "_t");
        if (!!files_grid) {
            files_grid.setGridParam({ page: 1, datatype: 'json' }).trigger("reloadGrid");
        }
        we_helper.hideLoader();
    },
    onSaveAnswer: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$answer_editor_modal));
        let actionUrl = "/Designer/CreateAnswer";
        if (!!page._data.id) {
            actionUrl = "/Designer/UpdateAnswer"
        }
        we_helper.updateDataDB(actionUrl, page._data, function () {
            page.reloadAnswersGrid(page._data["questionId"]);
            page.$answer_editor_modal.modal('hide');
        });
    },
    onShowCucModalAnswer: function (questionid, id) { 
        let questType = $(".js_add_table_record[attr-id='" + questionid + "']").attr("quest-type-id");
        $(".qt-" + questType, page.$answer_editor_modal).removeClass("d-none");
        if (!!id) {
            we_helper.getDataDB("/Designer/GetRecord?pageid=answer", {  id: id  }, "query", false, function (entity) {
                page._data = entity;
                we_helper.setFormData(page.$answer_editor_modal, page._data);
                $('.modal-title', page.$answer_editor_modal).text('Редактирование параметров ответа');
                page.$answer_editor_modal.modal('show');
                we_helper.hideLoader();
            });
        } else if (!!questionid) {
            we_helper.getDataDB("/Designer/GetNextRecordNumber", {  pageid: "answer", questionid: questionid }, "query", false, function (entity) {
                 we_helper.setFormData(page.$answer_editor_modal, {
                    questionId: questionid,
                    num: entity
                });
                $('.modal-title', page.$answer_editor_modal).text('Добавление ответа');
                page.$answer_editor_modal.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.alert("Некорректно задан код действия", notificatioType.warning);
        }
    },
};

