﻿$(function () {
    $(document).on('click', 'button.js_include_answ', function () {
        if (page._selectTestItemRow == null) {
            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
            return;
        }
        we_helper.reloadJqGrid(page.$tableAnswersNotGraph, {
            sequenceOptionId: page._sequenceoptionid,
            sequenceTestItemId: page._selectTestItemRow["id"]
        }, 1);
        page.$modalAnswerNotGraph.modal('show');
        page.$tableAnswersNotGraph.setGridWidth($('.not-include-answer-with-container').width());
    });
    $(document).on('click', 'button.js_exclude_answ', function () {
        if (page._selectTestItemRow == null || page._answer_in_graph_selected_rows.length === 0) {
            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
            return;
        }

        we_helper.deleteDataDB("/Designer/DeleteAnswerFromGraph", {
            ids: page._answer_in_graph_selected_rows,
            sequenceOptionId: page._sequenceoptionid,
            sequenceTestItemId: page._selectTestItemRow["id"]
        }, function () {
            page._answer_in_graph_selected_rows = [];
            we_helper.reloadJqGrid(page.$tableTestItems);
        });
    });
    page.init();
});

var page = {
    _answer_in_graph_selected_rows: [],
    _answer_not_graph_selected_rows:[],
    _id: we_helper.getPageId(),
    _sequenceoptionid: we_helper.urlParam("sequenceoptionid"),
    _sequenceid: we_helper.urlParam("sequenceid"),
    $tableTestItems: $(".js_table_test_items"),
    $tableAnswersInGraph: $(".js_table_include_answers"),
    $tableAnswersNotGraph: $(".js_table_not_include_answers"),
    $modalAnswerNotGraph: $(".js_not_include_answer_modal"),
    $modalEditAnswerGraph: $(".js_edit_answer_modal"),
    _data: null,
    _selectTestItemRow: null,
    init: function () {
        page.$tableAnswersNotGraph.on('click', 'a.js_add_table_record', function () {
            let id = $(this).attr("attr-id");
            we_helper.updateDataDB("/Designer/AddAnswerInGraph", {
                ids: [id],
                sequenceOptionId: page._sequenceoptionid,
                sequenceTestItemId: page._selectTestItemRow["id"]
            }, function () {
                let index = $.inArray(id, page._answer_not_graph_selected_rows);
                if (index !== -1) {
                    page._answer_not_graph_selected_rows.splice(index, 1);
                }
                we_helper.reloadJqGrid(page.$tableAnswersNotGraph);
            });
        });
        page.$tableAnswersNotGraph.on('click', '.js-answer-not-graph-select-row', function () {
            we_helper.multipleSelection($(this), page._answer_not_graph_selected_rows);

            $('.js-answer-not-graph-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-answer-not-graph-select-row', page.$tableAnswersNotGraph)));
        });
        page.$tableAnswersNotGraph.parent().on('click', '.js-answer-not-graph-select-all-row', function () {
            we_helper.selectAllRows($('.js-answer-not-graph-select-row', page.$tableAnswersNotGraph), $(this).is(":checked"), page._answer_not_graph_selected_rows);
        });

        page.$tableAnswersInGraph.on('click', 'a.js_del_table_record', function () {
            let id = $(this).attr("attr-id");
            we_helper.deleteDataDB("/Designer/DeleteAnswerFromGraph", {
                ids: [id],
                sequenceOptionId: page._sequenceoptionid,
                sequenceTestItemId: page._selectTestItemRow["id"]
            }, function () {
                let index = $.inArray(id, page._answer_in_graph_selected_rows);
                if (index !== -1) {
                    page._answer_in_graph_selected_rows.splice(index, 1);
                }
                we_helper.reloadJqGrid(page.$tableTestItems);
            });
        });
        page.$tableAnswersInGraph.on('click', '.js-answer-in-graph-select-row', function () {
            we_helper.multipleSelection($(this), page._answer_in_graph_selected_rows);

            $('.js-answer-in-graph-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-answer-in-graph-select-row', page.$tableAnswersInGraph)));
        });
        page.$tableAnswersInGraph.parent().on('click', '.js-answer-in-graph-select-all-row', function () {
            we_helper.selectAllRows($('.js-answer-in-graph-select-row', page.$tableAnswersInGraph), $(this).is(":checked"), page._answer_in_graph_selected_rows);
        });
        page.$tableAnswersInGraph.on('click', 'a.js_edit_table_record', function () {
            let row = page.$tableAnswersInGraph.jqGrid('getRowData', "g1_" + $(this).attr("attr-id"));
            if (!!row) {
                page._data = {
                    id: row["id"],
                    message: row["message"],
                    nextTestItemNum: row["nextTestItemNum"],
                    ball: row["ball"]
                };
                we_helper.setFormData(page.$modalEditAnswerGraph, page._data);
                page.$modalEditAnswerGraph.modal('show');
            }
        });

        page.$modalEditAnswerGraph.on('click', '.js_modal_save_change', function (e) {
            if (we_helper.checkValidation(page.$modalEditAnswerGraph) === true) {
                page.updateGraphRecord();
            }
            e.preventDefault();
        });
        page.$modalAnswerNotGraph.on('hidden.bs.modal', function (e) {
            page._answer_not_graph_selected_rows = [];
            we_helper.reloadJqGrid(page.$tableTestItems);
        });
        page.$modalEditAnswerGraph.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$modalEditAnswerGraph, page._data);
        });

        we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" },
            { page: "Задания типа «Последовательность»", path: "/designer?pageid=sequence" },
            { page: "Варианты задания", path: "/designer?pageid=sequenceoption&sequenceid=" + page._sequenceid },
            { page: "Граф выполнения варианта" }]);
        we_helper.getDataDB("/Designer/GetRecord", {  pageid: "sequence", id: page._sequenceid }, "query", false, function (info) {
                $(".js_page_info").html("<strong>Номер и наименование задания:</strong> " + info.num + ". " + info.name + "; <strong>Вариант:</strong> " + we_helper.urlParam("num"))
                .removeClass("d-none");
            we_helper.hideLoader();
        });
         ///Инициализация таблицы тестовых заданий 
        we_helper.initJqGrid(page.$tableTestItems, {
            uid: "designer_" + page._id,
            url: "/Designer/GetSequenceTestItemsWithCheckGraph",
            colNames: [
                '', '', '№ шага', 'Вопрос', 'Тип', ''
            ],  
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "status", sortable: false, align: 'center', width: 10, index: 'status',
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.first) {
                            let _color = "text-success";
                            if (rowObject.outCount === 0) {
                                _color = "text-warning";
                            }
                            return '<span class="mdi mdi-arrow-right ' + _color + '" title="Входная «назначенная» вершина"></span>';
                        }

                        if (rowObject.isolated) {
                            return '<span class="mdi mdi-circle text-muted" title="Изолированная вершина"></span>';
                        }

                        if (rowObject.out) {
                            if (rowObject.num !== 0) {
                                return '<span class="mdi mdi-arrow-left text-danger" title="Выходная вершина"></span>';
                            } else {
                                return '<span class="mdi mdi-arrow-left text-success" title="Выходная «фиктивная» вершина"></span>';
                            }
                        }

                        if (rowObject.in) {
                            return '<span class="mdi mdi-arrow-right text-danger" title="Входная вершина"></span>';
                        }
                        return '<span class="mdi mdi-circle text-success"></span>';
                    }
                },
                { name: "num", sortable: false, align: 'center', width: 20, index: 'num' },
                { name: "name", sortable: false, align: 'left', width: 150, index: 'name' },
                { name: "testItemTypeName", sortable: false, align: 'left', width: 35, index: 'testItemTypeName' },
                { name: "testItemType", hidedlg: true, hidden: true, index: 'testItemType' },
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) {
                return $(this).getGridParam('selrow') != rowid;
            },
            onSelectRow: function (id) {
                page._answer_in_graph_selected_rows = [];
                page._selectTestItemRow = page.getTestItemRowData(id);
                we_helper.reloadJqGrid(page.$tableAnswersInGraph, {
                    sequenceOptionId: page._sequenceoptionid,
                    sequenceTestItemId: page._selectTestItemRow["id"]
                }, 1);
            },
            widthContainer:".test-item-with-container"
        },{
            sequenceid: page._sequenceid,
            sequenceOptionId: page._sequenceoptionid,
        }, function () {
            if (page._selectTestItemRow !== null) {
                page.$tableTestItems.jqGrid('setSelection', "g1_" + page._selectTestItemRow["id"]);
            }
            $(".jqgrow", $(".js_table_test_items")).addClass("cursor-pointer");
        });
        ///Инициализация таблицы ответов включенных в граф
        we_helper.initJqGrid(page.$tableAnswersInGraph, {
            uid: "designer_" + page._id+"_answ_in_graph",
            url: "/Designer/GetAnswerInGraphRecords",
            datatype: "local",
            colNames: [
                '', '<input type="checkbox" class="js-answer-in-graph-select-all-row" title = "Выбрать все строки" />', 'Код', 'Ответ', 'Эталон', 'Точность', 'Операнд', 'След.', 'Балл', 'Сообщение', 'Ред.', 'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-answer-in-graph-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._answer_in_graph_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num', hidden: true },
                { name: "name", sortable: true, align: 'left', width: 120, index: 'name', hidden: true },
                {
                    name: "numeric", sortable: false, align: 'center', width: 20, index: 'numeric', hidden: true,
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject["operand"] === 0) {
                            return rowObject["numeric"];
                        } else if (rowObject["operand"] === 2) { //меньше
                            return +(rowObject["numeric"] - rowObject["prec"]).toFixed(4);
                        } else if (rowObject["operand"] === 3) {//больше
                            return +(rowObject["numeric"] + rowObject["prec"]).toFixed(4);
                        } 
                    }
                },
                {
                    name: "prec", sortable: false, align: 'center', width: 20, index: 'prec', hidden: true,
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject["operand"]===0) {
                            return rowObject["prec"];
                        }
                        return "";
                    }
                },
                { name: "operandName", sortable: true, align: 'center', width: 25, index: 'operandName', hidden: true },
                {
                    name: "nextTestItemNum", sortable: false, align: 'center', width: 20, index: 'nextTestItemNum',
                    formatter: function (cellvalue, options, rowObject) {
                        if (!!rowObject["nextTestItemNum"]) {
                            return rowObject["nextTestItemNum"];
                        }
                        return 0;
                    }
                },
                { name: "ball", sortable: true, align: 'center', width: 20, index: 'ball' },
                { name: "message", sortable: true, align: 'left', width: 80, index: 'message' },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                }
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
            widthContainer: ".answer-with-container"
        }, {}, function () {
            $('.js-answer-in-graph-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-answer-in-graph-select-row', page.$tableAnswersInGraph)));

                page.$tableAnswersInGraph.hideCol(["num", "name", "numeric", "prec", "operandName"]);
            if (page._selectTestItemRow !== null) {
                if (page._selectTestItemRow["testItemType"] === "0") {
                    page.$tableAnswersInGraph.showCol(["num", "name"]);
                } else if (page._selectTestItemRow["testItemType"] === "1") {
                    page.$tableAnswersInGraph.showCol(["numeric", "prec", "operandName"]);
                }
            }
        });
        let _notGraphSearch = $('.js_search_not_include_answers_panel').searchPanel({
            selectParam: [],
            actionBtn: [
                {
                    id: "add",
                    icon: "mdi mdi-plus",
                    style: "success",
                    text: "Добавить"
                }],
            searchParam: {
                params: [
                    { text: 'Ответ или код', placeholder: 'Введите часть текста или код ответа' },
                    { text: 'Код', placeholder: 'Введите код ответа' },
                    { text: 'Ответ', placeholder: 'Введите часть текста ответа' },
                    { text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            defBtn: true,
            dateBlock: {
                show: false
            },
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$tableAnswersNotGraph, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$tableAnswersNotGraph, data, 1);
            },
            onAction: function (keyBtn, search_data) {
                switch (keyBtn) {
                    case "add": {
                        if (page._answer_not_graph_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        we_helper.updateDataDB("/Designer/AddAnswerInGraph", {
                            ids: page._answer_not_graph_selected_rows,
                            sequenceOptionId: page._sequenceoptionid,
                            sequenceTestItemId: page._selectTestItemRow["id"]
                        }, function () {
                            page._answer_not_graph_selected_rows = [];
                            we_helper.reloadJqGrid(page.$tableAnswersNotGraph);
                        });
                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        ///Инициализация таблицы ответов не включенных в граф
        we_helper.initJqGrid(page.$tableAnswersNotGraph, {
            uid: "designer_" + page._id + "_answ_not_graph",
            url: "/Designer/GetAnswerNotGraphRecords",
            datatype: "local",
            colNames: [
                '', '<input type="checkbox" class="js-answer-not-graph-select-all-row" title = "Выбрать все строки" />', 'Код', 'Ответ', 'Эталон', 'Точность', 'Дата изменения', 'Изменил', 'Доб.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-answer-not-graph-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._answer_not_graph_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num', hidden: true },
                { name: "name", sortable: true, align: 'left', width: 180, index: 'name', hidden: true },
                { name: "numeric", sortable: true, align: 'center', width: 60, index: 'numeric', hidden: true },
                { name: "prec", sortable: true, align: 'center', width: 60, index: 'prec', hidden: true },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 55, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 65, index: 'userHasChanged' },
                {
                    name: "btnAdd", classes: 'overflow-none', width: 25, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-plus text-success js_add_table_record' href='#' attr-id='" + rowObject.id + "' title='Добавить'></a>";
                    }
                } 
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
            widthContainer: ".not-include-answer-with-container",
            corr_height: -100,
        }, _notGraphSearch.api().get_data(), function () {
            $('.js-answer-not-graph-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-answer-not-graph-select-row', page.$tableAnswersNotGraph)));

                page.$tableAnswersNotGraph.hideCol(["num", "name", "numeric", "prec"]);
                if (page._selectTestItemRow !== null) {
                    if (page._selectTestItemRow["testItemType"] === "0") {
                        page.$tableAnswersNotGraph.showCol(["num", "name"]);
                    } else if (page._selectTestItemRow["testItemType"] === "1") {
                        page.$tableAnswersNotGraph.showCol(["numeric", "prec"]);
                    }
                }
            });
        we_helper.hideLoader();
    },
    getTestItemSelectRowId: function () {
        return page.$tableTestItems.jqGrid('getGridParam', 'selrow');
    },
    getTestItemRowData: function (rowId) {
        if (!rowId) {
            rowId = page.getTestItemSelectRowId();
        }
        if (rowId == null) { return null; }
        return page.$tableTestItems.jqGrid('getRowData', rowId);
    },  
    updateGraphRecord: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$modalEditAnswerGraph));
        page._data["sequenceid"] = page._sequenceid;
        we_helper.updateDataDB("/Designer/UpdateGraphRecord", page._data, function () {
            we_helper.reloadJqGrid(page.$tableTestItems);
            page.$modalEditAnswerGraph.modal('hide');
        });
    }
};
