﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(), 
    _sequenceid: we_helper.urlParam("sequenceid"),
    _data: {},
    _table_selected_rows: [],
    _search: null, 
    $table: $(".js_table"),
    $modal: $(".js_detail_modal"),
    $answer_editor_modal: $(".js_answer_edit_modal"),
    $dlgReportSettings: $(".js_modal_report_settings"),
    init: function (_pageInfo) {
        if (!page._sequenceid || page._id !== "sequencetestitem") {
            window.open('/', '_self');
        }

        $("input[name=sequenceTaskId]", page.$modal).val(page._sequenceid);
        we_helper.getDataDB("/Designer/GetRecord", { pageid: "sequence", id: page._sequenceid }, "query", false, function (info) {
            $(".js_page_info").html("<strong>Номер и наименование задания:</strong> " + info.num + ". " + info.name).removeClass("d-none");
            we_helper.hideLoader();
        });

        we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" },
            { page: "Задания типа «Последовательность»", path: "/designer?pageid=sequence" }, { page: "Вопросы к заданию" }]);

        page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$dlgReportSettings);
        });
        $('.btn-success', page.$dlgReportSettings).on('click', function (e) {
            let data = page._search.api().get_data();
            let gridParam = page.$table.jqGrid('getGridParam', 'postData');
            data["sidx"] = gridParam.sidx;
            data["sord"] = gridParam.sord;
            data["format"] = $('input[name="fileformattype"]:checked').attr("id");
            we_helper.getDataDB("/Designer/SaveReport", data, "body", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            }); 
        });
         
        page.$modal.on('hidden.bs.modal', function (e) { 
            we_helper.clearModal(page.$modal, page._data);
        });
        page.$answer_editor_modal.on('hidden.bs.modal', function (e) {
            $("[name=sequenceTestItemId]", page.$answer_editor_modal).val("");
            $(".qt-0, .qt-1", page.$answer_editor_modal).addClass("d-none");
            we_helper.clearModal(page.$answer_editor_modal, page._data);
        });

        $('.js_modal_save_change', page.$modal).on('click', function (e) {
            if (we_helper.checkValidation(page.$modal) === true) {
                page.updateRecord();
            }
            e.preventDefault();
        });
        $('.js_answer_modal_save_change', page.$answer_editor_modal).on("click", function (e) {
            if (we_helper.checkValidation(page.$answer_editor_modal) === true) {
                page.updateAnswerRecord();
            }
            e.preventDefault();
        });

        page.$table.on('click', 'a.js_edit_table_record', function () {
            let parid = $(this).attr("par-id");
            if (!!parid) {
                page.showModalAnswer(parid, $(this).attr("attr-id"));
            } else {
                page.showModal("edit", $(this).attr("attr-id"));
            }
        });
        page.$table.on('click', 'a.js_copy_table_record', function () {
            page.showModal("copy", $(this).attr("attr-id"));
        });
        page.$table.on('click', 'a.js_del_table_record', function () {
            let id = $(this).attr("attr-id");
            let parid = $(this).attr("par-id");
            if (!!parid) {
                page.deleteRecords([id], "sequenceanswer", function () {
                    page.reloadAnswersGrid(parid);
                });
            } else {
                page.deleteRecords([id], "sequencetestitem", function () {
                    let index = $.inArray(id, page._table_selected_rows);
                    if (index !== -1) {
                        page._table_selected_rows.splice(index, 1);
                    }
                    we_helper.reloadJqGrid(page.$table);
                });
            }
        });
        page.$table.on('click', '.js-select-row', function () {
            we_helper.multipleSelection($(this), page._table_selected_rows);
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
        page.$table.parent().on('click', '.js-select-all-row', function () {
            we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
        });
        page.$table.on('click', 'a.js_add_table_record', function () {
            page.showModalAnswer($(this).attr("attr-id"));
        });
      
        we_helper.initSelect('/Designer/GetEnums?name=sequenceTestItem', $('.select2.js-quest-type', page.$modal), null, false, true);

        page._search = $('.js_search_panel').searchPanel({
            uid: "designer_" + page._id,
            selectParam: [],
            actionBtn: [{
                id: "add",
                icon: "mdi mdi-plus",
                style: "success",
                text: "Создать"
            }, {
                id: "delete",
                icon: "mdi mdi-delete",
                style: "danger",
                text: "Удалить"
            }, {
                id: "export",
                icon: "mdi mdi-database-export",
                style: "info",
                text: "Отчёт"
            }],
            searchParam: {
                params: [
                    { text: 'Вопрос или код', placeholder: 'Введите часть наименования или код вопроса' },
                    { text: 'Код', placeholder: 'Введите код вопроса' },
                    { text: 'Вопрос', placeholder: 'Введите часть наименования вопроса' },
                    { text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            autocomplete: {
                enable: true,
                url: "/Designer/GetAutocompleteRecords",
            },
            defBtn: true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onAction: function (keyBtn, data) {
                switch (keyBtn) {
                    case "add": {
                        page.showModal("add");
                        break;
                    } 
                    case "delete": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.deleteRecords(page._table_selected_rows, "sequencetestitem", function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    case "export": {
                        page.$dlgReportSettings.modal('show'); 
                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        we_helper.initJqGrid(page.$table, {
            uid: "designer_" + page._id,
            url: "/Designer/GetRecords",
            colNames: [
                '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код', 'Вопрос', 'Тип', 'Дата изменения', 'Изменил', 'Отв.', 'Доб.', 'Ред.', 'Коп.', 'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 280, index: 'name' },
                { name: "testItemTypeName", sortable: true, align: 'left', width: 55, index: 'testItemTypeName' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 60, index: 'userHasChanged' },
                {
                    name: "answerCount", sortable: true, align: 'center', width: 20, index: 'answerCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.answerCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.answerCount + "</span>";
                    }

                },
                {
                    name: "btnAnswerAdd", sortable: true, align: 'center', width: 20, index: 'btnAnswerAdd', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-plus text-success js_add_table_record' href='#' quest-type-id='" + rowObject.testItemType + "' attr-id='" + rowObject.id + "' title='Добавить ответ'></a>";
                    }
                },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnCopy", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-content-copy text-info js_copy_table_record' href='#' attr-id='" + rowObject.id + "' title='Копировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                }
            ],
            sortname: 'num',
            sortorder: 'asc',
            corr_height: -40,
            subGrid: true,
            subGridRowExpanded: function (subgrid_id, row_id) {
                page.initAnswersGrid(subgrid_id, row_id);
            },
            beforeSelectRow: function (rowid, e) { return false; }
        }, page._search.api().get_data(), function () {
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
    }, 
    showModal: function (act, id) {
        if (act === "edit" || act === "copy") {
            we_helper.getDataDB("/Designer/GetRecord", {
                pageid: page._id,
                id: id
            }, "query", false, function (entity) {
                page._data = entity;
                page._data["actionid"] = act;
                we_helper.setFormData(page.$modal, page._data);
                let modaltitle = 'Редактирование параметров вопроса';
                if (act === "copy") {
                    modaltitle = 'Создание копии вопроса';
                }
                $('.modal-title', page.$modal).text(modaltitle);
                $(".quest-type-container").addClass("d-none");
                page.$modal.modal('show');
                we_helper.hideLoader();
            });
        } else if (act === "add") {
            we_helper.getDataDB("/Designer/GetNextRecordNumber", {
                pageid: page._id,
                sequenceid: page._sequenceid
            }, "query", false, function (entity) {
                we_helper.setFormData(page.$modal, {
                    num: entity,
                    sequenceTaskId: page._sequenceid
                });
                $('.modal-title', page.$modal).text('Создание нового вопроса');
                $(".quest-type-container").removeClass("d-none");
                page.$modal.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.alert("Некорректно задан код действия: " + act, notificatioType.warning);
        }
    },
    deleteRecords: function (ids, pageid, callback) {
        we_helper.deleteDataDB("/Designer/DeleteRecords", {
            pageid: pageid,
            ids: ids
        }, function () {
            if (callback) {
                callback();
            }
        }, true);
    },
    updateRecord: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$modal));
        let actionUrl = "/Designer/CreateSequenceTestItem";
        if (!!page._data.id) {
            if (page._data["actionid"] === "edit") {
                actionUrl = "/Designer/UpdateSequenceTestItem"
            } else if (page._data["actionid"] === "copy") {
                actionUrl = "/Designer/CopySequenceTestItem"
            }
        }
        we_helper.updateDataDB(actionUrl, page._data, function () {
            page._table_selected_rows = [];
            we_helper.reloadJqGrid(page.$table);
            page.$modal.modal('hide');
        });
    },
    initAnswersGrid: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let sequencetestitemid = row_id.split('_')[1];
        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            uid: "designer_" + page._id + "_ans",
            postData: {
                sequencetestitemid: sequencetestitemid,
                pageid: "sequenceanswer"
            },
            url: "/Designer/GetRecords",
            colNames: [
                '', 'Код', 'Ответ', 'Эталон', 'Точность', 'Дата изменения', 'Изменил', 'Ред.', 'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 30, index: 'num', hidden: true },
                { name: "name", sortable: true, align: 'left', width: 200, index: 'name', hidden: true },
                { name: "numeric", sortable: true, align: 'left', width: 100, index: 'numeric', hidden: true },
                { name: "prec", sortable: true, align: 'left', width: 100, index: 'prec', hidden: true },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 55, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 65, index: 'userHasChanged' },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' par-id='" + sequencetestitemid + "' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' par-id='" + sequencetestitemid + "' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                }
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        }, null, function () {
            let testItemType = $(".js_add_table_record[attr-id='" + sequencetestitemid + "']").attr("quest-type-id");
            if (testItemType === "0") {
                $("#" + subgrid_table_id).showCol(["num", "name"]);
            } else if (testItemType === "1") {
                $("#" + subgrid_table_id).showCol(["numeric", "prec"]);
            }  
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.80);
        }).trigger('resize');
    },
    reloadAnswersGrid: function (sequencetestitemid) {
        let files_grid = $("#jqg1_g1_" + sequencetestitemid + "_t");
        if (!!files_grid) {
            files_grid.setGridParam({ page: 1, datatype: 'json' }).trigger("reloadGrid");
        }
        we_helper.hideLoader();
    },
    updateAnswerRecord: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$answer_editor_modal));
        let actionUrl = "/Designer/CreateSequenceAnswer";
        if (!!page._data.id) {
            actionUrl = "/Designer/UpdateSequenceAnswer"
        }
        we_helper.updateDataDB(actionUrl, page._data, function () {
            page.reloadAnswersGrid(page._data["sequenceTestItemId"]);
            page.$answer_editor_modal.modal('hide');
        });
    },
    showModalAnswer: function (sequencetestitemid, id) {
        let testItemType = $(".js_add_table_record[attr-id='" + sequencetestitemid + "']").attr("quest-type-id");
        $(".qt-" + testItemType, page.$answer_editor_modal).removeClass("d-none");
        if (!!id) {
            we_helper.getDataDB("/Designer/GetRecord?pageid=sequenceanswer", {  id: id  }, "query", false, function (entity) {
                page._data = entity;
                we_helper.setFormData(page.$answer_editor_modal, page._data);
                $('.modal-title', page.$answer_editor_modal).text('Редактирование параметров ответа');
                page.$answer_editor_modal.modal('show');
                we_helper.hideLoader();
            });
        } else if (!!sequencetestitemid) {
            we_helper.getDataDB("/Designer/GetNextRecordNumber", {
                pageid: "sequenceanswer",
                sequencetestitemid: sequencetestitemid
            }, "query", false, function (entity) { 
                we_helper.setFormData(page.$answer_editor_modal, {
                    num: entity,
                    sequenceTestItemId: sequencetestitemid
                });
                $('.modal-title', page.$answer_editor_modal).text('Добавление ответа');
                page.$answer_editor_modal.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.alert("Некорректно задан код действия", notificatioType.warning);
        }
    },
};

