﻿$(function () {
    page.init();
});

var page = {
    _moduleid: we_helper.urlParam("moduleid"),
    _programid: we_helper.urlParam("programid"),
    _componentType: we_helper.urlParam("componentType"),
    _table_selected_rows: [],
    _search: null,
    $search_panel: $('.js_search_panel'),
    $table: $(".js_table"),
    _sumItemCount: 0,
    _sumItemInTestCount: 0,
    init: function () {
        page.$table.on('click', '.js-select-row', function () {
            we_helper.multipleSelection($(this), page._table_selected_rows);

            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
        page.$table.parent().on('click', '.js-select-all-row', function () {
            we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
        });
        page.$table.on('change', 'input.itemsInTestCount', function () {

            let count = parseInt($(this).val());
            if (count === undefined || count < 0) {
                count = 0;
            }

            let max = parseInt($(this).attr("max"));
            if (count > max) {
                count = max;
            }

            $(this).val(count);

            let row = page.$table.jqGrid('getRowData', "g1_" + $(this).attr("attr-id"));
            if (jQuery.isEmptyObject(row)) {
                we_helper.alert("Запись не найдена!", notificatioType.danger);
                return;
            }
            we_helper.updateDataDB("/Designer/UpdateItemsInTest", {
                id: row["id"],
                grpName: row["grp"],
                moduleid: page._moduleid,
                count: count
            }, function () {
                we_helper.reloadJqGrid(page.$table);
            });
        });

        let crumb = [{ page: "Конструктор", path: "#" }];
        if (page._programid !== null) {
            crumb.push({ page: "Учебные курсы", path: "/designer?pageid=program" },
                { page: "Редактор содержания учебного курса", path: "/designer?pageid=programeditor&programid=" + page._programid + "&moduleid=" + page._moduleid  });
        } else {
            crumb.push({ page: "Учебные модули", path: "/designer?pageid=module" });
        }
        crumb.push({ page: "Объём контроля для компонентов модуля" });
        we_helper.setBreadcrumb(crumb);
  
        we_helper.getDataDB("/Designer/GetRecord", {  pageid: "module", id: page._moduleid  }, "query", false, function (info) {
            $(".js_page_info").html("<strong>Учебный модуль:</strong> " + info.num + ". " + info.name + "; <strong>Тип компонентов модуля:</strong> " + info.componentName).removeClass("d-none");
            $(".js_test_info").removeClass("d-none");
            we_helper.hideLoader();
        });

        page._search = page.$search_panel.searchPanel({
            uid: "designer_testeditor",
            selectParam: [],
            actionBtn: [
                {
                    id: "group",
                    icon: "mdi mdi-group",
                    style: "success",
                    text: "Группировать"
                },
                {
                    id: "ungroup",
                    icon: "mdi mdi-ungroup",
                    style: "danger",
                    text: "Разгруппировать"
                }],
            searchParam: {
                params: [
                    { text: 'Компонент или код', placeholder: 'Введите часть наименования или код компонента' },
                    { text: 'Код', placeholder: 'Введите код компонента' },
                    { text: 'Компонент', placeholder: 'Введите часть наименования компонента' },
                    { text: 'Структурная единица', placeholder: 'Введите часть наименования структурной единицы компонента' },
                    { text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            defBtn: true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onAction: function (keyBtn, search_data) {
                switch (keyBtn) {
                    case "group": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }

                        let grps = [],
                            ids = [];
                        for (var i = 0; i < page._table_selected_rows.length; i++) {
                            let row = page.$table.jqGrid('getRowData', "g1_" + page._table_selected_rows[i]);
                            if (!jQuery.isEmptyObject(row) && !!row["grp"]) {
                                grps.push(row["grp"]);
                            } else {
                                ids.push(page._table_selected_rows[i]);
                            }
                        }

                        let grpName = prompt("Введите уникальное наименование группы", grps);
                        if (!grpName || grpName.length > 128) {
                            return;
                        }
                        
                        we_helper.updateDataDB("/Designer/GroupModuleUnits", {
                            ids: ids,
                            grps: grps,
                            moduleid: page._moduleid,
                            grpName: grpName
                        }, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });

                        break;
                    }
                    case "ungroup": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }

                        let grps = [],
                            ids = [];
                        for (var i = 0; i < page._table_selected_rows.length; i++) {
                            let row = page.$table.jqGrid('getRowData', "g1_" + page._table_selected_rows[i]);
                            if (!jQuery.isEmptyObject(row) && !!row["grp"]) {
                                grps.push(row["grp"]);
                            } else {
                                ids.push(page._table_selected_rows[i]);
                            }
                        }

                        we_helper.updateDataDB("/Designer/UngroupModuleUnits", {
                            ids: ids,
                            grps: grps,
                            moduleid: page._moduleid 
                        }, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });

                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        we_helper.initJqGrid(page.$table, {
            uid: "designer_testeditor",
            url: "/Designer/GetModuleGroupedUnits",
            colNames: [
                '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код', 'Компонент',
                'Раздел', 'Структурная единица', 'Внутренняя', '', 'Дата изменения', 'Изменил', (page._componentType === "0" ? 'ТЗ' : 'Вар.'), 'Выбр.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
                {
                    name: "name", sortable: true, align: 'left', width: 220, index: 'name', formatter: function (cellvalue, options, rowObject) {
                        if (!!rowObject.grp) {
                            return "Группа «" + rowObject.name + "»";
                        }
                        return rowObject.name;
                    }
                }, 
                { name: "sectionName", sortable: true, align: 'left', width: 90, index: 'sectionName', hidden: true },
                { name: "filialName", sortable: true, align: 'left', width: 50, index: 'filialName' },
                {
                    name: "internal", sortable: true, align: 'center', width: 20, index: 'internal',
                    formatter: function (cellvalue, options, rowObject) {
                        if (cellvalue) {
                            return "<span class='mdi mdi-checkbox-marked-outline' title='Доступна только внутри области данных'></span>";
                        } else {
                            return "<span class='mdi mdi-checkbox-blank-outline' title='Общедоступная информация'></span>";
                        }
                    }
                }, 
                { name: "grp", sortable: true, align: 'left', hidedlg: true, hidden: true, width: 0, index: 'grp' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 55, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 65, index: 'userHasChanged' },
                {
                    name: "totalItemCount", sortable: true, align: 'center', width: 20, index: 'totalItemCount',
                    formatter: function (cellvalue, options, rowObject) {
                        page._sumItemCount += rowObject.totalItemCount; 
                        let color = "badge-success",
                            title = "";
                        if (rowObject.totalItemCount <= 0) {
                            color = "badge-danger";
                        }

                        if (rowObject.questionsOnUpdating) {
                            color = "badge-warning";
                            title = "Тестовые задания на проверке с " + we_helper.convertDate(rowObject.questionsOnUpdating);
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell' title='" + title + "'>" + rowObject.totalItemCount + "</span>";
                    }
                },
                {
                    name: "itemsInTest", sortable: true, align: 'center', width: 60, index: 'itemsInTest',
                    formatter: function (cellvalue, options, rowObject) {
                        page._sumItemInTestCount += rowObject.itemsInTest;
                        return '<input type="number" min="0" class="itemsInTestCount" max="' + rowObject.totalItemCount + '" attr-id="' + rowObject.id + '" value="' + rowObject.itemsInTest + '" style="width:80px"/>';
                    }
                },
            ],
            sortname: 'num',
            sortorder: 'asc',
            corr_height: -40,
            subGrid: true,
            subGridOptions: {
                hasSubgrid: function (options) {
                    return !!options.data.grp;
                }
            },
            subGridRowExpanded: function (subgrid_id, row_id) {
                 page.initSubTable(subgrid_id, row_id);
            },
            beforeSelectRow: function (rowid, e) { return false; }
        }, page._search.api().get_data(), function () {
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
                if (page._componentType === "0") {
                    page.$table.showCol(["sectionName"]);
                }

                $("#lblItemCount").text(page._sumItemCount)
                    .addClass("badge-success").removeClass("badge-danger"); 
                if (page._sumItemCount === 0 || page._sumItemCount < page._sumItemInTestCount) {
                    $("#lblItemCount").addClass("badge-danger").removeClass("badge-success");
                }

                $("#lblItemInIestCount").text(page._sumItemInTestCount)
                    .addClass("badge-success").removeClass("badge-danger");
                if (page._sumItemInTestCount === 0 || page._sumItemCount < page._sumItemInTestCount) {
                    $("#lblItemInIestCount").addClass("badge-danger").removeClass("badge-success");
                }

                page._sumItemCount = 0;
                page._sumItemInTestCount = 0;
        });

        we_helper.hideLoader();
    }, 
    initSubTable: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;

        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            postData: {
                grpName: function () {
                    let row = page.$table.jqGrid('getRowData', row_id);
                    if (jQuery.isEmptyObject(row)) {
                        return null;
                    }
                    return row["grp"];
                },
                moduleid: page._moduleid
            },
            url: "/Designer/GetModuleUnitsInGroup",
            colNames: [
                '', 'Код', 'Компонент', 'Раздел', 'Структурная единица', 'Внутренняя', '', 'Дата изменения', 'Изменил', (page._componentType === "0" ? 'ТЗ' : 'Вар.')
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 200, index: 'name' },
                { name: "sectionName", sortable: true, align: 'left', width: 90, index: 'sectionName', hidden: true },
                { name: "filialName", sortable: true, align: 'left', width: 60, index: 'filialName' },
                {
                    name: "internal", sortable: true, align: 'center', width: 20, index: 'internal',
                    formatter: function (cellvalue, options, rowObject) {
                        if (cellvalue) {
                            return "<span class='mdi mdi-checkbox-marked-outline' title='Доступна только внутри области данных'></span>";
                        } else {
                            return "<span class='mdi mdi-checkbox-blank-outline' title='Общедоступная информация'></span>";
                        }
                    }
                }, 
                { name: "grp", sortable: true, align: 'left', hidedlg: true, hidden: true, width: 0, index: 'grp' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 55, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 65, index: 'userHasChanged' },
                {
                    name: "totalItemCount", sortable: true, align: 'center', width: 20, index: 'totalItemCount', 
                    formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success",
                            title = "";
                        if (rowObject.totalItemCount <= 0) {
                            color = "badge-danger";
                        }

                        if (rowObject.questionsOnUpdating) {
                            color = "badge-warning";
                            title = "Тестовые задания на проверке с " + we_helper.convertDate(rowObject.questionsOnUpdating);
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell' title= '" + title + "'>" + rowObject.totalItemCount + "</span>";
                    }
                } 
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        }, null, function () {
            if (page._componentType === "0") {
                $("#" + subgrid_table_id).showCol(["sectionName"]);
            }
        });

        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.80);
        }).trigger('resize');
    }
};

 