﻿$(function () {
    page.init();
    $(window).resize(function () {
        page.onResizeSectionTree(); 
    });
});

var page = {
    _id: we_helper.getPageId(),
    _cur_user_filial: we_helper.getCurUserFilial(),
    _data: {},
    _table_selected_rows: [],
    _search: null,
    _file_viewer: null,
    $table: $(".js_table"),
    $tree: $(".js_section_tree"),
    $filial: $('.select2.js-filial'),
    $modal_cuc_document: $(".js_modal_cuc_document"),
    $modal_markup_document: $(".js_modal_markup_document"),
    $modal_cuc_docfile: $(".js_modal_cuc_doc_file"),
    $modal_cuc_section: $(".js_modal_cuc_section"),
    $dlgReportSettings: $(".js_modal_report_settings"),
    init: function () {
        we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" }, { page: "Теоретические материалы" }]);
        let $departments = $('.select2.js-responsible-departments, .select2.js-export-section-docs-departs, .select2.js-export-section-progs-departs');
        let $sections = $('.select2.js-section', page.$modal_cuc_document);
        we_helper.initSelect('/Designer/GetEnums?name=markupType', $('.select2.js-auto-markup-type', page.$modal_markup_document), null, false, true);
        we_helper.initSelect('/Designer/GetRecordsKeyText', page.$filial, { pageid: "filial" }, true, true, function () {
            let def_selected = page.getDefFilial();
            page.$filial.append(new Option(def_selected.text, def_selected.id)).val(def_selected.id).trigger('change');
        }, function (dt) {
            page.setSideBarCache(dt.id, dt.text, null);
            $departments.val([0]).trigger('change');
            page.onReloadSectionTree();
            $sections.val([0]).trigger('change');
        });
        we_helper.initSelect('/Admin/GetRecordsKeyText', $departments, {
            pageid: "department",
            filialid: function () {
                return page.$filial.val();
            }
        }, true, false);
        we_helper.initSelect('/Designer/GetRecordsKeyText', $sections, {
            pageid: "section",
            filialid: function () {
                return page.$filial.val();
            }
        }, true, true, null, function (_data) {
            we_helper.getDataDB("/Designer/GetNextRecordNumber", {
                pageid: "document",
                filialid: function () {
                    return page.$filial.val();
                },
                sectionid: _data.id
            }, "query", false, function (entity) {
                $("input[name=num]", page.$modal_cuc_document).val(entity);
                we_helper.hideLoader();
            });
        });
        we_helper.initSelect('/Admin/GetRecordsKeyText', $('.select2.js-export-section-docs-check-knowledge-filial, .select2.js-export-document-mods-filial'), {
            pageid: "filial"
        }, true, false);
        let $export_section_progs_filials = $('.select2.js-export-section-progs-check-knowledge-filial'),
            $export_section_progs = $('.select2.js-export-section-progs');
        we_helper.initSelect('/Admin/GetRecordsKeyText', $export_section_progs_filials, {
            pageid: "filial"
        }, true, false, null, function () {
            $export_section_progs.val([0]).trigger('change');
        });
        we_helper.initSelect('/Designer/GetRecordsKeyText', $export_section_progs, {
            pageid: "program",
            filialid: function () {
                return $export_section_progs_filials.val();
            }
        }, true, false);
        $("#js-btn-add-section, #js-btn-def-add-section").on("click", function () {
            page.onShowCucModalSection();
        });
        $("#js-btn-edit-section").on("click", function () {
            let section = page.getTreeSelectRowData();
            if (!section) {
                we_helper.alert("Выберите раздел!", notificatioType.danger);
                return;
            }
            page.onShowCucModalSection(section.id);
        });
        $("#js-btn-remove-section").on("click", function () {
            let row = page.getTreeSelectRowData();
            if (!row) {
                we_helper.alert("Выберите раздел!", notificatioType.danger);
                return;
            }
            we_helper.deleteDataDB("/Designer/DeleteSection", {
                ids: [row.id]
            }, function () {
                let filial = page.$filial.select2('data')[0];
                page.setSideBarCache(filial.id, filial.text, row.parent);
                page.onReloadSectionTree();
            }, true);
        });
        page.$modal_cuc_section.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$modal_cuc_section, page._data);
        });
        $('.btn-success', page.$modal_cuc_section).on('click', function (e) {
            if (we_helper.checkValidation(page.$modal_cuc_section) === true) {
                page.onSaveSection();
            }
            e.preventDefault();
        });
        page.$modal_cuc_document.on('hidden.bs.modal', function (e) {
            $('label[name=mainFileName]', page.$modal_cuc_document).text('');
            we_helper.clearModal(page.$modal_cuc_document, page._data);
        });
        $('.btn-success', page.$modal_cuc_document).on('click', function (e) {
            if (we_helper.checkValidation(page.$modal_cuc_document) === true) {
                page.onSaveDocument();
            }
            e.preventDefault();
        });

        page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
            we_helper.clearModal(page.$dlgReportSettings);
        });
        $('.btn-success', page.$dlgReportSettings).on('click', function (e) {
            let data = page._search.api().get_data();
            let gridParam = page.$table.jqGrid('getGridParam', 'postData');
            data["sidx"] = gridParam.sidx;
            data["sord"] = gridParam.sord;
            data["format"] = $('input[name="fileformattype"]:checked').attr("id");
            data["filialid"] = page.$filial.val();
            data["sectionid"] = page.getTreeSelectRowId();
            let tabid = $("a.active", page.$dlgReportSettings).attr("id");
            if (!!tabid) {
                tabid = tabid.substring(0, tabid.lastIndexOf("-"));
                data["tabid"] = tabid;
                data = $.extend(data, we_helper.getFormData($("#" + tabid)));
                if (tabid === "export-documents") {
                    data["tabid"] += "-" + $('input[name="printDocList"]:checked').attr("id");
                } else if (tabid === "export-sections") {
                    data["tabid"] += "-" + $('input[name="printSectionList"]:checked').attr("id");
                }
            }
            we_helper.getDataDB("/Designer/SaveReport", data, "body", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            });
        });
        page.$modal_markup_document.on('hidden.bs.modal', function (e) {
            $("[name=fileId],[name=documentId]", page.$modal_markup_document).val("");
            we_helper.clearModal(page.$modal_markup_document);
        });
        $('.btn-success', page.$modal_markup_document).on("click", function () {
            let data = we_helper.getFormData(page.$modal_markup_document);
            we_helper.updateDataDB("/Designer/MarkupDocumentFile", data, function () {
                page.onReloadDocFileGrid(data.documentId);
                page.$modal_markup_document.modal('hide');
            });
        });
        page.$modal_cuc_docfile.on('hidden.bs.modal', function (e) {
            $("[name=documentId]", page.$modal_cuc_docfile).val("");
            $('label[name=fileName]', page.$modal_cuc_docfile).text('');
            we_helper.clearModal(page.$modal_cuc_docfile, page._data);
        });
        $('.btn-success', page.$modal_cuc_docfile).on("click", function (e) {
            if (we_helper.checkValidation(page.$modal_cuc_docfile) === true) {
                page.onSaveDocFile();
            }
            e.preventDefault();
        });
        page.$table.on('click', 'a.js_edit_table_record', function () {
            let parid = $(this).attr("par-id");
            if (!!parid) {
                page.onShowCucModalDocFile(parid, $(this).attr("attr-id"));
            } else {
                page.onShowCucModalDocument("edit", $(this).attr("attr-id"));
            }
        });
        page.$table.on('click', 'a.js_copy_table_record', function () {
            page.onShowCucModalDocument("copy", $(this).attr("attr-id"));
        });
        page.$table.on('click', 'a.js_del_table_record', function () {
            let id = $(this).attr("attr-id");
            let parid = $(this).attr("par-id");
            if (!!parid) {
                page.deleteRecords([id], "documentfiles", function () {
                    page.onReloadDocFileGrid(parid);
                });
            } else {
                page.deleteRecords([id], "document", function () {
                    let index = $.inArray(id, page._table_selected_rows);
                    if (index !== -1) {
                        page._table_selected_rows.splice(index, 1);
                    }
                    page.onReloadSectionTree();
                });
            }
        });
        page.$table.on('click', '.js-select-row', function () {
            we_helper.multipleSelection($(this), page._table_selected_rows);
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
        page.$table.parent().on('click', '.js-select-all-row', function () {
            we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
        });
        page.$table.on('click', 'a.js_add_table_record', function () {
            page.onShowCucModalDocFile($(this).attr("attr-id"));
        });
        page.$table.on('click', 'a.js_view_file_table_record', function () {
            page.cacheDocumentBeforeOpen($(this).attr("attr-id"));
        });
        page.$table.on('click', 'a.js_download_file_table_record', function () {
            page.onDownloadDocFile($(this).attr("attr-id"));
        });
        page.$table.on('click', 'a.js_mark_file_table_record', function () {
            $("[name=fileId]", page.$modal_markup_document).val($(this).attr("attr-id"));
            $("[name=documentId]", page.$modal_markup_document).val($(this).attr("par-id"));
            page.$modal_markup_document.modal('show');
        });
        page._file_viewer = $(".js_file_viewer_dialog").fileViewer({
            dialog: true,
            onLoad: function () {
                we_helper.hideLoader();
            } 
        });
        we_helper.initJqTreeGrid(page.$tree, {
            url: "/Designer/GetSectionTree",
            colNames: ['id', 'Каталог', 'Док.', 'ТЗ'],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "name", sortable: false, align: 'left', width: 150, index: 'name',
                    formatter: function (cellvalue, options, rowObject) {
                        let color = "text-primary ";
                        if (rowObject.internal) {
                            color = "text-secondary ";
                        }
                        let icon = "mdi mdi-folder-multiple-outline";
                        if (rowObject.isLeaf) {
                            icon = "mdi mdi-folder-outline";
                        }
                        return "<span class='" + color + icon + " pr-1 icon-size'></span>" + rowObject.fullNum + ". " + rowObject.name;
                    }
                },
                {
                    name: "docCount", sortable: false, align: 'center', width: 20, index: 'docCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.docCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.docCount + "</span>";
                    }
                },
                {
                    name: "questCount", sortable: false, align: 'center', width: 25, index: 'questCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.questCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.questCount + "</span>";
                    }
                },
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) {
                if ($(e.target).hasClass("treeclick")) {
                    return false;
                }
                var selrow = $(this).getGridParam('selrow');
                if (selrow == rowid && e.ctrlKey) {
                    $(this).jqGrid('resetSelection');
                    page._search.api().search();
                    return false;
                }
                return selrow != rowid;
            },
            onSelectRow: function (id) {
                let filial = page.$filial.select2('data')[0];
                page.setSideBarCache(filial.id, filial.text, id);
                page._search.api().search();
            }
        }, function () {
            $(".tree-leaf").addClass("d-none");
            let section = page.getCacheSection();
            if (!!section) {
                page.$tree.jqGrid('setSelection', section);
                we_helper.jqGridTreeExpandToNode(page.$tree, page.getTreeSelectRowData(section));
            } else {
                page._search.api().search();
            }
            $(".jqgrow", page.$tree).addClass("cursor-pointer");
        });
        page._search = $('.js_search_panel').searchPanel({
            uid: "designer_" + page._id,
            selectParam: [],
            actionBtn: [{
                id: "add",
                icon: "mdi mdi-plus",
                style: "success",
                text: "Создать"
            }, {
                id: "delete",
                icon: "mdi mdi-delete",
                style: "danger",
                text: "Удалить"
            }, {
                id: "export",
                icon: "mdi mdi-database-export",
                style: "info",
                text: "Отчёт"
            },
                //{
                //id: "question_on_updating",
                //icon: "mdi mdi-update",
                //style: "info",
                //text: "ТЗ на проверке"
                //}
            ],
            searchParam: {
                params: [
                    { text: 'Документ или код', placeholder: 'Введите часть наименования или код документа' },
                    { text: 'Код', placeholder: 'Введите код документа' },
                    { text: 'Документ', placeholder: 'Введите часть наименования документа' },
                    { text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            autocomplete: {
                enable: true,
                url: "/Designer/GetAutocompleteRecords",
                data: {
                    filialid: page.$filial.val(),
                    sectionid: function () {
                        return page.getTreeSelectRowId();
                    }
                }
            },
            defBtn: true,
            onSearch: function (data) {
                page.onReloadJqGrid(data);
            },
            onClear: function (data) {
                page.onReloadJqGrid(data);
            },
            onAction: function (keyBtn, data) {
                switch (keyBtn) {
                    case "add": {
                        page.onShowCucModalDocument("add");
                        break;
                    }
                    case "delete": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }

                        page.deleteRecords(page._table_selected_rows, "document", function () {
                            page._table_selected_rows = [];
                            page.onReloadSectionTree();
                        });
                        break;
                    }
                    case "export": {
                        we_helper.setFormData(page.$dlgReportSettings, {
                            exportFilialId: page._cur_user_filial.id,
                            filialName: page._cur_user_filial.text
                        });
                        page.$dlgReportSettings.modal('show');
                        break;
                    }
                    //case "question_on_updating": {
                    //    if (page._table_selected_rows.length === 0) {
                    //        we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                    //        return;
                    //    }
                    //    page.questionsOnUpdating(page._table_selected_rows, function () {
                    //        page._table_selected_rows = [];
                    //        we_helper.reloadJqGrid(page.$table);
                    //    });
                    //    break;
                    //}
                    case "accepted_deb": {
                        if (page._table_selected_rows.length === 0) {
                            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                            return;
                        }
                        page.acceptDebLink(page._table_selected_rows, function () {
                            page._table_selected_rows = [];
                            we_helper.reloadJqGrid(page.$table);
                        });
                        break;
                    }
                    default: {
                        break;
                    }
                }
            }
        });
        we_helper.initJqGrid(page.$table, {
            uid: "designer_" + page._id,
            datatype: "local",
            url: "/Designer/GetRecords",
            colNames: [
                '', '', '', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код',
                'Документ', 'Раздел', 'Ответственные', 'Действителен по', 'Внутренний', 'Дата изменения', 'Изменил', 'Мод.', 'ТЗ план', 'ТЗ', 'Доб.', 'Ред.', 'Коп.', 'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "filialId", hidedlg: true, hidden: true, index: 'filialId' },
                { name: "sectionId", hidedlg: true, hidden: true, index: 'sectionId' },
                {
                    name: "selected", width: 15, align: "center", sortable: false, title: false,
                    formatter: function (cellvalue, options, rowObject) {
                        var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
                        if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
                            res += ' checked="checked"';
                        }
                        return res + '/>';
                    }
                },
                { name: "num", sortable: true, align: 'center', width: 25, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
                { name: "sectionName", sortable: true, align: 'left', width: 50, index: 'sectionName' },
                {
                    name: "departmentNames", sortable: false, align: 'left', width: 90, index: 'departmentNames'
                },
                {
                    name: "validByDate", sortable: true, align: 'center', width: 35, index: 'validByDate',
                    formatter: function (cellvalue, options, rowObject) {
                        if (!!rowObject.validByDate) {
                            if (rowObject.isValid) {
                                return we_helper.convertDate(rowObject.validByDate);
                            }
                            return '<span class="badge badge-danger" style="font-size: 85%;">' + we_helper.convertDate(rowObject.validByDate) + '</span>';
                        }
                        return "";
                    }
                },
                {
                    name: "internal", sortable: true, align: 'center', width: 20, index: 'internal',
                    formatter: function (cellvalue, options, rowObject) {
                        if (cellvalue) {
                            return "<span class='mdi mdi-checkbox-marked-outline' title='Доступен только внутри области данных'></span>";
                        } else {
                            return "<span class='mdi mdi-checkbox-blank-outline' title='Общедоступная информация'></span>";
                        }
                    }
                },

                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 45, index: 'userHasChanged' },
                {
                    name: "moduleCount", sortable: true, align: 'center', width: 20, index: 'moduleCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.moduleCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.moduleCount + "</span>";
                    }
                },
                {
                    name: "questionsPlan", sortable: true, align: 'center', width: 20, index: 'questionsPlan', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (!rowObject.questionsPlan || rowObject.questionsPlan <= 0 || rowObject.questCount < rowObject.questionsPlan) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.questionsPlan + "</span>";
                    }
                },
                {
                    name: "questCount", sortable: true, align: 'center', width: 20, index: 'questCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success",
                            title = "";
                        if (rowObject.questCount <= 0) {
                            color = "badge-danger";
                        }

                        if (rowObject.questionsOnUpdating) {
                            color = "badge-warning";
                            title = "Тестовые задания на проверке с " + we_helper.convertDate(rowObject.questionsOnUpdating);
                        }
                        return "<a href='designer?pageid=question&documentid=" + rowObject.id + "' title='Тестовых заданий' class='js_goto_page' attr-id='" + rowObject.id + "'><span class='badge " + color + " badge-cell' title= '" + title + "'>" + rowObject.questCount + "</span></a>";
                    }
                },
                {
                    name: "btnAdd", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-plus text-success js_add_table_record' href='#' attr-id='" + rowObject.id + "' title='Добавить файл'></a>";
                    }
                },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnCopy", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-content-copy text-info js_copy_table_record' href='#' attr-id='" + rowObject.id + "' title='Копировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                },
            ],
            sortname: 'num',
            sortorder: 'asc',
            corr_height: -15,
            subGrid: true,
            subGridRowExpanded: function (subgrid_id, row_id) {
                page.initDocumentFilesGrid(subgrid_id, row_id);
            },
            beforeSelectRow: function (rowid, e) { return false; }
        }, page._search.api().get_data(), function () {
            $('.js-select-all-row').prop('checked',
                we_helper.isAllSelected($('.js-select-row', page.$table)));
        });
        we_helper.initDatePicker($(".date", page.$modal_cuc_document));
        $(".select-filial-container").removeClass("d-none");
        page.onResizeSectionTree();
        page.onReloadSectionTree();
    },
    onReloadSectionTree: function () {
        page.$tree.setGridParam({
            page: 1, datatype: 'json', postData: {
                filialId: page.$filial.val()
            }
        }).trigger("reloadGrid");
        page.$tree.jqGrid('resetSelection');
    },
    onResizeSectionTree: function () {
        $('#split-0 .ui-jqgrid-bdiv').css({ 'height': ($(window).height() - 165) + 'px' });
    },
    getTreeSelectRowId: function () {
        return page.$tree.jqGrid('getGridParam', 'selrow');
    },
    getTreeSelectRowData: function (rowId) {
        if (!rowId) {
            rowId = page.getTreeSelectRowId();
        }
        if (rowId == null) { return null; }
        return page.$tree.jqGrid('getLocalRow', rowId);
    },
    initDocumentFilesGrid: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let documentid = row_id.split('_')[1];

        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            uid: "designer_" + page._id + "_files",
            postData: {
                documentid: documentid,
                pageid: "documentfiles"
            },
            url: "/Designer/GetRecords",
            colNames: [
                '', 'Код', 'Файл', 'Расширение', 'Дата изменения', 'Изменил', 'Просм.', 'Скач.', 'Разм.', 'Ред.', 'Уд.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 200, index: 'name' },
                { name: "extension", sortable: true, align: 'center', width: 30, index: 'extension' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 55, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                { name: "userHasChanged", sortable: true, align: 'left', width: 65, index: 'userHasChanged' },
                {
                    name: "btnViewFile", sortable: true, align: 'center', width: 15, index: 'btnViewFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-eye-outline text-info js_view_file_table_record' href='#' par-id='" + documentid + "' attr-id='" + rowObject.id + "' title='Просмотреть файл'></a>";
                    }
                },
                {
                    name: "btnDownloadFile", sortable: true, align: 'center', width: 15, index: 'btnDownloadFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-download-outline text-info js_download_file_table_record' href='#' par-id='" + documentid + "' attr-id='" + rowObject.id + "' title='Скачать файл'></a>";
                    }
                },
                {
                    name: "btnMarkFile", sortable: true, align: 'center', width: 15, index: 'btnMarkFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-anchor text-info js_mark_file_table_record' href='#' par-id='" + documentid + "' attr-id='" + rowObject.id + "' title='Разметить файл'></a>";
                    }
                },
                {
                    name: "btnEdit", classes: 'overflow-none', width: 15, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' par-id='" + documentid + "'  attr-id='" + rowObject.id + "' title='Редактировать'></a>";
                    }
                },
                {
                    name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                    formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' par-id='" + documentid + "'  attr-id='" + rowObject.id + "' title='Удалить'></a>";
                    }
                }
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.60);
        }).trigger('resize');
    },
    onReloadDocFileGrid: function (documentid) {
        let files_grid = $("#jqg2_g1_" + documentid + "_t");
        if (!!files_grid) {
            files_grid.setGridParam({ page: 1, datatype: 'json' }).trigger("reloadGrid");
        }
        we_helper.hideLoader();
    },
    getDefFilial: function () {
        let cache = we_helper.getCache("library_" + page._id + "_tree");
        if (!!cache && !!cache.filial) {
            return cache.filial;
        }
        return we_helper.getCurUserFilial();
    },
    getCacheSection: function () {
        let cache = we_helper.getCache("library_" + page._id + "_tree");
        if (!!cache && !!cache.sectionid) {
            return cache.sectionid;
        }
        return null;
    },
    setSideBarCache: function (filialid, filialname, sectionid) {
        we_helper.setCache("library_" + page._id + "_tree", {
            filial: {
                id: filialid,
                text: filialname,
            },
            sectionid: sectionid
        });
    },
    onReloadJqGrid: function (data) {
        let filialid = page.$filial.val(),
            sectionid = page.getTreeSelectRowId();
        we_helper.reloadJqGrid(page.$table, $.extend(data, { filialid: filialid, sectionid: sectionid }), 1);
    },
    onShowCucModalSection: function (id) {
        if (!!id) {
            we_helper.getDataDB("/Designer/GetRecord", {
                id: id, pageid: "section"
            }, "query", false, function (entity) {
                page._data = entity;
                we_helper.setFormData(page.$modal_cuc_section, page._data);
                $('.modal-title', page.$modal_cuc_section).text("Редактирование параметров раздела");
                page.$modal_cuc_section.modal('show');
                we_helper.hideLoader();
            });
        } else {
            let filialid = page.$filial.val(),
                sectionid = page.getTreeSelectRowId();
            if (!filialid) {
                we_helper.alert("Выберите структурную единицу!", notificatioType.danger);
                return;
            }
            we_helper.getDataDB("/Designer/GetNextRecordNumber", {
                filialid: filialid, sectionid: sectionid, pageid: "section"
            }, "query", false, function (entity) {
                we_helper.setFormData(page.$modal_cuc_section, {
                    num: entity
                });
                $('.modal-title', page.$modal_cuc_section).text("Создание нового раздела");
                page.$modal_cuc_section.modal('show');
                we_helper.hideLoader();
            });
        }
    },
    onSaveSection: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$modal_cuc_section));
        page._data['filialId'] = page.$filial.val();
        page._data['parentId'] = page.getTreeSelectRowId();
        let actionUrl = "/Designer/CreateSection";
        if (!!page._data.id) {
            actionUrl = "/Designer/UpdateSection";
        }
        we_helper.updateDataDB(actionUrl, page._data, function () {
            page.onReloadSectionTree();
            page.$modal_cuc_section.modal('hide');
        });
    },
    onShowCucModalDocument: function (act, id) {
        $("#is-quest-on-updating").parent().removeClass("d-none");
        $("#fileUploader").parent().removeClass("d-none");
        if (act === "edit" || act === "copy") {
            we_helper.getDataDB("/Designer/GetRecord?pageid=document", {
                id: id
            }, "query", false, function (entity) {
                page._data = entity;
                page._data["actionid"] = act;
                page._data["isQuestionsOnUpdating"] = false;
                if (page._data.questionsOnUpdating) {
                    page._data.isQuestionsOnUpdating = true;
                }
                if (page._data.dateOfPublication) {
                    page._data.dateOfPublication = we_helper.convertDate(page._data.dateOfPublication);
                }
                if (page._data.validByDate) {
                    page._data.validByDate = we_helper.convertDate(page._data.validByDate);
                }
                if (!!page._data.mainFile) {
                    page._data["mainFileName"] = page._data.mainFile.name + page._data.mainFile.extension;
                    delete page._data["mainFile"];
                }
                we_helper.setFormData(page.$modal_cuc_document, page._data);
                let modaltitle = 'Редактирование метаданных документа';
                if (act === "copy") {
                    modaltitle = 'Создание копии документа';
                    $("#is-quest-on-updating").parent().addClass("d-none");
                    $("#fileUploader").parent().addClass("d-none");
                }
                $(".section-container").removeClass("d-none");
                $('.modal-title', page.$modal_cuc_document).text(modaltitle);
                page.$modal_cuc_document.modal('show');
                we_helper.hideLoader();
            });
        } else if (act === "add") {
            let section = page.getTreeSelectRowData();
            if (!section) {
                we_helper.alert("Выберите раздел!", notificatioType.danger);
                return;
            }
            let dt = {
                pageid: "document",
                filialid: page.$filial.val(),
                sectionid: section.id,
                sectionname: section.name,
            };
            we_helper.getDataDB("/Designer/GetNextRecordNumber", dt, "query", false, function (entity) {
                we_helper.setFormData(page.$modal_cuc_document, {
                    sectionId: dt.sectionid,
                    sectionName: dt.sectionname,
                    num: entity
                });
                $(".section-container").addClass("d-none");
                $("#is-quest-on-updating").parent().addClass("d-none");
                $('.modal-title', page.$modal_cuc_document).text('Создание нового документа');
                page.$modal_cuc_document.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.alert("Некорректно задан код действия: " + act, notificatioType.warning);
        }
    },
    onSaveDocument: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$modal_cuc_document));
        page._data["debName"] = null;
        page._data["debId"] = null;
        page._data['filialId'] = page.$filial.val();
        if (page._data.isQuestionsOnUpdating) {
            page._data.questionsOnUpdating = moment().format("DD.MM.YYYY");
        } else {
            page._data.questionsOnUpdating = null;
        }
        let actionUrl = "/Designer/CreateDocument";
        if (!!page._data.id) {
            if (page._data["actionid"] === "edit") {
                actionUrl = "/Designer/UpdateDocument"
            } else if (page._data["actionid"] === "copy") {
                actionUrl = "/Designer/CopyDocument"
            }
        }
        let $upload = $("#fileUploader", page.$modal_cuc_document);
        if ($upload.length > 0 && $upload.get(0).files.length > 0) {
            let files = $upload.get(0).files;
            var formData = new FormData();
            formData.append(files[0].name, files[0]);
            if (page._data) {
                $.each(page._data, function (key) {
                    if ($.isArray(page._data[key])) {
                        for (var i = 0; i < page._data[key].length; i++) {
                            formData.append(key + "[]", page._data[key][i]);
                        }
                    } else {
                        formData.append(key, page._data[key]);
                    }
                });
            }
            we_helper.uploadFile(actionUrl, formData, function () {
                page._table_selected_rows = [];
                page.onReloadSectionTree();
                page.$modal_cuc_document.modal('hide');
            });
        }
        else {
            we_helper.updateDataDB(actionUrl, page._data, function () {
                page._table_selected_rows = [];
                page.onReloadSectionTree();
                page.$modal_cuc_document.modal('hide');
            });
        }
    },
    deleteRecords: function (ids, pageid, callback) {
        we_helper.deleteDataDB("/Designer/DeleteRecords", {
            pageid: pageid,
            ids: ids
        }, function () {
            if (callback) {
                callback();
            }
        }, true);
    },
    cacheDocumentBeforeOpen: function (id) {
        we_helper.getDataDB("/Designer/CacheDocumentBeforeOpen", { fileid: id }, "query", false, function (entity) {
            page._file_viewer.api().view(entity);
        });
    },
    //questionsOnUpdating: function (ids, callback) {
    //    bootbox.confirm({
    //        message: "Вы уверены, что хотите изменить признак «Тестовые задания на проверке» для выбранных документов (" + ids.length + ")?" +
    //            '<div class="col-12 form-group pt-4">' +
    //            '<input type="checkbox" id="is-quest-on-updating" class="questions-on-updating" />' +
    //            '<label for="is-quest-on-updating" title="Тестовые задания на проверке"></label> - Тестовые задания на проверке' +
    //            '</div>',
    //        swapButtonOrder: true,
    //        buttons: {
    //            cancel: {
    //                label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
    //                className: 'btn-sm btn-danger'
    //            },
    //            confirm: {
    //                label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
    //                className: 'btn-sm btn-success'
    //            }
    //        },
    //        callback: function (result) {
    //            if (result) {
    //                we_helper.showLoader();
    //                let onUpdating = $(".questions-on-updating").prop("checked");
    //                $.ajax({
    //                    url: "/Designer/SetPropertyQuestionsOnUpdating",
    //                    type: 'POST',
    //                    cache: false,
    //                    data: {
    //                        ids: ids,
    //                        onUpdating: onUpdating
    //                    },
    //                    success: function (response) {
    //                        if (response.result == 1) {
    //                            we_helper.alert("Данные успешно отправлены.", notificatioType.success);

    //                        } else {
    //                            we_helper.alert(response.message, notificatioType.danger);
    //                        }

    //                        if (callback) {
    //                            callback();
    //                        } else {
    //                            we_helper.hideLoader();
    //                        }
    //                    },
    //                    error: function (err) {
    //                        we_helper.hideLoader();
    //                        we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
    //                    }
    //                });
    //            }
    //        }
    //    });
    //},
    onShowCucModalDocFile: function (documentid, id) {
        if (!!id) {
            we_helper.getDataDB("/Designer/GetRecord?pageid=documentfiles", { id: id }, "query", false, function (entity) {
                page._data = entity;
                page._data["fileName"] = entity.name + entity.extension;
                we_helper.setFormData(page.$modal_cuc_docfile, page._data);
                $('.modal-title', page.$modal_cuc_docfile).text('Редактирование метаданных файла');
                page.$modal_cuc_docfile.modal('show');
                we_helper.hideLoader();
            });
        } else if (!!documentid) {
            we_helper.getDataDB("/Designer/GetNextRecordNumber", { pageid: "documentfiles", documentid: documentid }, "query", false, function (entity) {
                we_helper.setFormData(page.$modal_cuc_docfile, {
                    num: entity,
                    documentId: documentid
                });
                $('.modal-title', page.$modal_cuc_docfile).text('Добавление файла документа');
                page.$modal_cuc_docfile.modal('show');
                we_helper.hideLoader();
            });
        } else {
            we_helper.alert("Некорректно задан код действия", notificatioType.warning);
        }
    },
    onSaveDocFile: function () {
        page._data = $.extend(page._data, we_helper.getFormData(page.$modal_cuc_docfile));
        let actionUrl = "/Designer/CreateDocumentFile";
        if (!!page._data.id) {
            actionUrl = "/Designer/UpdateDocumentFile"
        }
        let $upload = $("#fileUploader", page.$modal_cuc_docfile);
        if ($upload.length > 0 && $upload.get(0).files.length > 0) {
            let files = $upload.get(0).files;
            var formData = new FormData();
            formData.append(files[0].name, files[0]);
            if (page._data) {
                $.each(page._data, function (key) {
                    if ($.isArray(page._data[key])) {
                        for (var i = 0; i < page._data[key].length; i++) {
                            formData.append(key + "[]", page._data[key][i]);
                        }
                    } else {
                        formData.append(key, page._data[key]);
                    }
                });
            }
            we_helper.uploadFile(actionUrl, formData, function () {
                page.onReloadDocFileGrid(page._data["documentId"]);
                page.$modal_cuc_docfile.modal('hide');
            });
        }
        else {
            we_helper.updateDataDB(actionUrl, page._data, function () {
                page.onReloadDocFileGrid(page._data["documentId"]);
                page.$modal_cuc_docfile.modal('hide');
            });
        }
    },
    onDownloadDocFile: function (fileid) {
        bootbox.confirm({
            message: "Вы уверены, что хотите сохранить выбранный файл на локальный диск компьютера?" +
                '<div class="col-12 form-group pt-4">' +
                '<input type="checkbox" id="file-save-option" class="file-save-option" />' +
                '<label for="file-save-option" title="Включить в загрузку тестовые задания по документу"></label> - Включить в загрузку тестовые задания по документу' +
                '</div>',
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.getDataDB("/Designer/DownloadFile", { pageid: "documentfile", id: fileid, includeti: $(".file-save-option").prop("checked") }, "query", false, function (entity) {
                        window.open('../temp/' + entity, "_blank");
                        we_helper.hideLoader();
                    });
                }
            }
        });
    }
};