﻿var models = {
	coords: {
		client: [],
		svg: [],
		container: []
	},
	act: []
};

var margin = { top: -5, right: -5, bottom: -5, left: -5 },
	width = $(window).width() * 2.5 - margin.left - margin.right,
	height = $(window).height() * 3 - margin.top - margin.bottom;

var zoom = d3.behavior.zoom()
	.scaleExtent([1, 10])
	.on("zoom", function () {
		container.attr("transform", "translate(" + d3.event.translate + ")scale(" + d3.event.scale + ")");
	});

var svg = d3.select("svg")
	.attr("width", width + margin.left + margin.right)
	.attr("height", height + margin.top + margin.bottom)
	.append("g")
	.attr("transform", "translate(" + margin.left + "," + margin.right + ")")
	.call(zoom);

var rect = svg.append("rect")
	.attr("width", width)
	.attr("height", height)
	.style("fill", "none")
	.style("pointer-events", "all");

var defs = svg.append('svg:defs');
for (var i = 0; i < arrvoltage.length; i++) {
	defs.append('svg:marker')
		.attr('id', "marker_path_end_" + arrvoltage[i])
		.attr('viewBox', '0 -5 10 10')
		.attr('refX', 0)
		.attr('markerWidth', 3)
		.attr('markerHeight', 3)
		.attr('orient', 'auto')
		.append('svg:path')
		.attr('d', 'M0, -5L10, 0L0, 5').style("stroke", function () {
			return "#" + arrvoltage[i];
		}).style("fill", function () {
			return "#" + arrvoltage[i];
		});
}

var container = svg.append("g").attr("id", "container");
svg.on("mousemove", function () {
	models.coords.svg = d3.mouse(this);
});
 
$(document).bind("mousedown", function (e) {
	if (!$(e.target).parents(".custom-menu").length > 0) {
		$(".custom-menu").hide(100);
	}
});

$(function () {
	$(document).on('click', '.js_export', function () {
		page.$dlgReportSettings.modal('show');
	});

	$(document).on('click', '.js_view_file', function () {
		we_helper.getDataDB("/Designer/DownloadFile", { pageid: "trainingoption", id: page._trainingoptionid }, "query", false, function (entity) {
			window.open('../temp/' + entity, "_blank");
			we_helper.hideLoader();
		}); 
	});

	$(document).on('click', '.js_save', function () {
		page.saveSchemaState();
	});

	$(document).on('click', '.js_add_in_graph', function (e) {
		if (models.act[0] === undefined || models.act.length == 0 || models.act[0] == "" || models.act[1] == "") {
			we_helper.alert("Не указана операция!", notificatioType.warning);
			return;
		}
		if (we_helper.checkValidation(page.$addActionForm) === true) {
			page.addActionInGraph();
		}
		e.preventDefault();
	});

    page.init();
    $(window).resize(function () {
        page.resize();
	});
	document.oncontextmenu = function () { return false; };
});

$(".js_show_addition_menu").on("click", function () {
	page.$modalSelectAdditionMenuItems.modal('show');
	page.$tableAdditionMenu.setGridWidth($('.addition-menu-container').width());
});

var page = {
	_trainingid: we_helper.urlParam("trainingid"),
	_trainingoptionid: we_helper.urlParam("trainingoptionid"),
	$tableGraph: $(".js_table_graph"),
	$modalSelectAdditionMenuItems: $(".js_select_addition_menu_items"),
	$tableAdditionMenu: $(".js_table_addition_menu_items"),
	$addActionForm: $(".add-action-container"),
	$dlgReportSettings: $(".js_modal_report_settings"),
	init: function () {
		we_helper.setBreadcrumb([{ page: "Конструктор", path: "#" },
		{ page: "Задания типа «Тренировка»", path: "/designer?pageid=training" },
		{ page: "Варианты тренировки", path: "/designer?pageid=trainingoption&trainingid=" + page._trainingid },
		{ page: "Схема и граф выполнения варианта " }]);

		page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page.$dlgReportSettings);
		});
		$('.btn-success', page.$dlgReportSettings).on('click', function (e) {
			let data = {
				pageid: "traininggraph",
				optionid: page._trainingoptionid,
				trainingid: page._trainingid,
				format: $('input[name="fileformattype"]:checked').attr("id")
			}; 
			we_helper.getDataDB("/Designer/SaveReport", data, "body", false, function (entity) {
				window.open('../temp/' + entity, "_blank");
				we_helper.hideLoader();
			});
		}); 

		page.setNextActionNumber();

		page.$tableGraph.on('click', 'a.js_del_table_record', function () {
			let id = $(this).attr("attr-id");
			we_helper.deleteDataDB("/Designer/DeleteElementsFromGraph", {
				ids: [id]
			}, function () {
				page.setNextActionNumber();
				we_helper.reloadJqGrid(page.$tableGraph);
			});
		});

		page.$tableGraph.on('click', 'a.js_edit_table_record', function () {
			let id = $(this).attr("attr-id");
			var row = page.getGraphRowData("g1_" + id);
			var message = prompt("Введите комментарий при неправильной операции", row["comment"]);
			if (message !== null) {
				page.updateGraphElementParam(id, message, "comment");
			}
		});

		page.$tableGraph.on('change', 'input.edit_num', function () {
			page.updateGraphElementParam($(this).attr("attr-id"), $(this).val(), "num");
		});

		page.$tableGraph.on('change', 'input.edit_parnum', function () {
			page.updateGraphElementParam($(this).attr("attr-id"), $(this).val(), "parnum");
		});

		page.$tableGraph.on('change', 'input.edit_penalty', function () {
			page.updateGraphElementParam($(this).attr("attr-id"), $(this).val().replace('.', ','), "penalty");
		});

		we_helper.getDataDB("/Designer/GetOptionSchema", {
			trainingid: page._trainingid,
			trainingoptionid: page._trainingoptionid
		}, "query", false, function (schema) {
				$(".js_page_info").html("<strong>Тренировка:</strong> " + schema.num + ". " + schema.name + "; <strong>Вариант:</strong> " + we_helper.urlParam("num")).removeClass("d-none");

				if (schema.elems.length != 0) {
				$.each(schema.elems, function (key) {
					var translate = [schema.elems[key].translateX, schema.elems[key].translateY];
					var txtranslate = [schema.elems[key].txtTranslateX, schema.elems[key].txtTranslateY];
					var showname = schema.elems[key].txt != null ? schema.elems[key].txt : "";
					switch (schema.elems[key].elementType) {
						case SchemaElementType.Text:
							{
								$.addtext(container, schema.elems[key].id, schema.elems[key].txt, translate, schema.elems[key].rotate, null, 2);
								break;
							}
						case SchemaElementType.Connpoint:
							{
								$.addconnpoint(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Blinker:
							{
								$.addblinker(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, 2, showname);
								break;
							}
						case SchemaElementType.Line:
							{
								$.addline(container, schema.elems[key].id, schema.elems[key].name, schema.elems[key].data, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].moveground, schema.elems[key].dasharray, 2, showname);
								break;
							}
						case SchemaElementType.Breakline:
							{
								$.addbreakline(container, schema.elems[key].id, schema.elems[key].name, schema.elems[key].data, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].moveground, schema.elems[key].dasharray, 2, showname);
								break;
							}
						case SchemaElementType.Bus:
							{
								$.addbus(container, schema.elems[key].id, schema.elems[key].name, schema.elems[key].width, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].moveground, 2, showname);
								break;
							}
						case SchemaElementType.Fuse:
							{
								$.addfuse(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].install, 2, showname);
								break;
							}
						case SchemaElementType.Switch:
							{
								$.addswitch(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].opertok, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Disconnector:
							{
								$.adddisconnector(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Shortcircuit:
							{
								$.addshortcircuit(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Separator:
							{
								$.addseparator(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Circuitbreaker:
							{
								$.addcircuitbreaker(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Cutout:
							{
								$.addcutout(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Selector:
							{
								$.addselector(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Testunit:
							{
								$.addtestunit(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, 2, showname);
								break;
							}
						case SchemaElementType.Switchplugin:
							{
								$.addswitchplugin(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, schema.elems[key].onoff, schema.elems[key].opertok, schema.elems[key].state, schema.elems[key].poster, 2, showname);
								break;
							}
						case SchemaElementType.Surge:
							{
								$.addsurge(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Grounding:
							{
								$.addgrounding(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Movegrounding90:
							{
								$.addmovegrounding90(d3.select("[id='" + schema.elems[key].parentId + "']"), schema.elems[key].id, translate);
								break;
							}
						case SchemaElementType.Movegrounding:
							{
								$.addmovegrounding(d3.select("[id='" + schema.elems[key].parentId + "']"), schema.elems[key].id, translate);
								break;
							}
						case SchemaElementType.Twowindingautotransformer:
							{
								$.addtwowindingautotransformer(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Threewindingautotransformer:
							{
								$.addthreewindingautotransformer(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Twowindingtransformer:
							{
								$.addtwowindingtransformer(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Threewindingtransformer:
							{
								$.addthreewindingtransformer(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Generator:
							{
								$.addgenerator(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Reactor:
							{
								$.addreactor(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Unittransformer:
							{
								$.addunittransformer(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						case SchemaElementType.Userimg:
							{
								$.addimg(container, schema.elems[key].id, schema.elems[key].data, schema.elems[key].width, schema.elems[key].height, translate, schema.elems[key].rotate, null, 2);
								break;
							}
						case SchemaElementType.Currenttransformer:
							{
								$.addcurrenttransformer(container, schema.elems[key].id, schema.elems[key].name, translate, schema.elems[key].rotate, txtranslate, null, 2, showname);
								break;
							}
						default:
							break;
					}

					if (schema.elems[key].elementType != SchemaElementType.Movegrounding90 && schema.elems[key].elementType != SchemaElementType.Movegrounding) {
						if (schema.elems[key].voltage == null) {
							schema.elems[key].voltage = "rgb(0, 0, 0)";
						}
						setColor(schema.elems[key].id, schema.elems[key].voltage);
					}
				});
			}
			we_helper.hideLoader();
		});
		///Инициализация таблицы графа сценария тренировки
		we_helper.initJqGrid(page.$tableGraph, {
			uid: "designer_traininggraph",
			url: "/Designer/GetSchemaElementInGraphRecords",
			colNames: [
				'', '№ операции', '№ пред', 'Элемент', 'Операция', 'Штраф', '', 'Комм.', 'Уд.'
			],
			colModel: [
				{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
				{
					name: "num", sortable: true, align: 'center', width: 25, index: 'num',
					formatter: function (cellvalue, options, rowObject) {
						return '<input type="number" min="0" max="1000" class="edit_num" attr-id="' + rowObject.id + '" value="' + rowObject.num + '" style="width:45px"/>';
					}
				},
				{
					name: "parentNum", sortable: true, align: 'center', width: 25, index: 'parentNum',
					formatter: function (cellvalue, options, rowObject) {
						return '<input type="number" min="0" max="1000" class="edit_parnum" attr-id="' + rowObject.id + '" value="' + rowObject.parentNum + '" style="width:45px"/>';
					}
				},
				{ name: "elementName", sortable: true, align: 'left', width: 60, index: 'elementName' },
				{ name: "actionName", sortable: true, align: 'left', width: 90, index: 'actionName' },  
				{
					name: "penalty", sortable: true, align: 'center', width: 25, index: 'penalty',
					formatter: function (cellvalue, options, rowObject) {
						return '<input type="number" min="0" max="1000"  step="0.1" class="edit_penalty" attr-id="' + rowObject.id + '" value="' + rowObject.penalty + '" style="width:45px"/>'
					}
				},
				{ name: "comment", align: 'left', width: 0, index: 'comment', hidden: true },  
				{
					name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
					formatter: function (cellvalue, options, rowObject) {
						return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
					}
				},
				{
					name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
					formatter: function (cellvalue, options, rowObject) {
						return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
					}
				}
			],
			sortname: 'num',
			sortorder: 'asc',
			beforeSelectRow: function (rowid, e) { return false; },
			widthContainer: ".graph-with-container",
			corr_height : -165
		}, {
			 trainingoptionid: page._trainingoptionid
		});
		///Инициализация таблицы дополнительного меню
		we_helper.initJqGrid(page.$tableAdditionMenu, {
			uid: "designer_traininggraph_additionmenu",
			url: "/Designer/GetRecords",
			colNames: [
				'', 'Обобщённая операция', 'Дата изменения', 'Изменил', 
			],
			colModel: [
				{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
				{ name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
				{
					name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
					formatter: "date",
					formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
				},
				{ name: "userHasChanged", sortable: true, align: 'left', width: 80, index: 'userHasChanged' },
			],
			sortname: 'name',
			sortorder: 'asc',
			beforeSelectRow: function (rowid, e) {
				return $(this).getGridParam('selrow') != rowid;
			},
			onSelectRow: function (id) {
				var row = page.$tableAdditionMenu.jqGrid('getRowData', id);
				if (!!row) {
					let txt = "Обобщённая операция: ";
					if (!models.act[0] && models.act[1]) {
						txt = models.act[1] + ": ";
					}
					models.act[0] = row["id"];
					models.act[1] = row["name"];
					$("#inpActionName").val(txt + models.act[1]);
				} else {
					models.act = [];
					$("#inpActionName").val("");
				}
				page.$tableAdditionMenu.jqGrid('resetSelection');
				page.$modalSelectAdditionMenuItems.modal('hide');
			},
			widthContainer: ".addition-menu-container" 
		}, {
			pageid: "trainingadditionmenu",
			trainingid: page._trainingid
		});

		page.resize();
	},
	resize: function () {
		$(".editor-container").height($(window).height() * 0.85);
	}, 
	updateGraphElementParam: function (id, value, param) {
		we_helper.updateDataDB("/Designer/UpdateGraphElementParam", {
			id: id,
			value: value,
			param: param
		}, function () {
			we_helper.reloadJqGrid(page.$tableGraph);
		});
	},
	getGraphRowData: function (rowId) {
		if (rowId == null) { return null; }
		return page.$tableGraph.jqGrid('getRowData', rowId);
	},
	saveSchemaState: function () {
		var jsonObj = [];
		container.selectAll(".group").each(function () {
			var g = d3.select(this);
			let i = parseInt(g.attr("type"));
			if (i == SchemaElementType.Switch
				|| i == SchemaElementType.Disconnector
				|| i == SchemaElementType.Shortcircuit
				|| i == SchemaElementType.Circuitbreaker
				|| i == SchemaElementType.Cutout
				|| i == SchemaElementType.Selector
				|| i == SchemaElementType.Testunit
				|| i == SchemaElementType.Switchplugin
				|| i == SchemaElementType.Fuse
				|| i == SchemaElementType.Blinker
				|| i == SchemaElementType.Separator) {

				var item = {};
				item["trainingSchemaId"] = g.attr("id");
				item["elementType"] = g.attr("type");

				let tmp = g.attr("install");
				if (tmp !== null && tmp !== "") {
					item["install"] = tmp;
				}

				tmp = g.attr("onoff");
				if (tmp !== null && tmp !== "") {
					item["onoff"] = tmp;
				}

				tmp = g.attr("opertok");
				if (tmp !== null && tmp !== "") {
					item["opertok"] = tmp;
				}

				tmp = g.attr("poster");
				if (tmp !== null && tmp !== "") {
					item["poster"] = tmp;
				}

				tmp = g.attr("state");
				if (tmp !== null && tmp !== "") {
					item["state"] = tmp;
				}

				jsonObj.push(item);
			} else if ((i == SchemaElementType.Line || i == SchemaElementType.Breakline || i == SchemaElementType.Bus) && g.attr("moveground") == "off") {
				var item = {};
				item["trainingSchemaId"] = g.attr("id");
				item["elementType"] = g.attr("type");
				jsonObj.push(item);
			}
		});

		we_helper.updateDataDB("/Designer/UpdateSchemaState", {
			trainingid: page._trainingid,
			trainingoptionid: page._trainingoptionid,
			schemaData: jsonObj
		}, function () {
			jsonObj = [];
			we_helper.hideLoader();
		});
	}, 
	addActionInGraph: function () {
		let o_data = we_helper.getFormData(page.$addActionForm);
		o_data = $.extend(o_data, {
			trainingOptionId: page._trainingoptionid,
			trainingSchemaId: models.act[0],
			actionName: models.act[1],
		});

		we_helper.updateDataDB("/Designer/AddActionInGraph", o_data, function () {
			models.act = [];
			we_helper.clearModal(page.$addActionForm);
			page.setNextActionNumber();
			we_helper.reloadJqGrid(page.$tableGraph);
		});
	},
	setNextActionNumber: function () {
		we_helper.getDataDB("/Designer/GetNextActionNumber", {
			trainingOptionId: page._trainingoptionid,
		}, "query", false, function (entity) {
			$("input[name=num]", page.$addActionForm).val(entity);
			we_helper.hideLoader();
		});
    }
};
