﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _cur_user_filial: we_helper.getCurUserFilial(),
    _search: null,
    $search_panel: $('.js_search_panel'),
    $page_content: $(".js_page_content"),
    init: function () {
        we_helper.setBreadcrumb([{ page: "Главная", path: "#" }, { page: "Лента новостей" }]);
        page._search = page.$search_panel.searchPanel({
            selectParam: [{
                id: "filial",
                title: "Структурная единица",
                url: "/Admin/GetRecordsKeyText",
                def_selected: page._cur_user_filial
            }],
            actionBtn: [],
            searchParam: {
                params: [
                    { text: 'Новость', placeholder: 'Введите часть текста новости' },
                    { text: 'Структурная единица', placeholder: 'Введите часть наименования структурной единицы подразделения' },
                    { text: 'Публикатор', placeholder: 'Введите часть фамилии (логина) пользователя' },
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            defBtn: true,
            dateBlock: {
                show: false
            },
            onSearch: function (data) {
                page.reloadNews(data);
            },
            onClear: function (data) {
                page.reloadNews(data);
            }
        });
        page.reloadNews(page._search.api().get_data()); 
    },
    reloadNews: function (data) {
        page.$page_content.html("");
        we_helper.getDataDB("/Home/GetNews", data, "body", false,  function (rss) {
            if (rss.length > 0) {
                $.each(rss, function (index, item) {
                    if (item.alerts.length > 0) {
                        page.createRssCard(item.date, item.alerts);
                    }
                });
            } else {
                page.$page_content.html("<p class='h5 text-center text-muted mt-3'>Новостей нет</p>");
            }
            we_helper.hideLoader();
        });
    },
    createRssCard: function (date, news) {
        let rows = "";
        for (var i = 0; i < news.length; i++) {
            rows += page.createNewsRow(news[i]);
        }
        page.$page_content.append('<div class="card mb-3">' +
            '<div class="card-body">' +
            '<h5 class="card-title">' + we_helper.convertDate(date) + '</h5>' +
            '<div class="card-text">' + rows + '</div>'+
        '</div></div>');
    },
    createNewsRow: function (news) {
        return '<div class="row no-gutters">' +
            '<div class="col-2 col-lg-1 pl-sm-2 pl-md-4">' +
            '<p class="text-muted">' + we_helper.convertDateToTime(news.dateOfChange) + '</p>' +
            '</div>' +
            '<div class="col-10 col-lg-11">' +
            '<p>' + news.message + '</p>' +
            '</div>' +
            '</div>';
    }
};