﻿$(function () {
    page.init();
    $(window).resize(function () {
        page.resizeTree(); 
    });
});

var page = {
    _id: we_helper.getPageId(), 
    _search: null, 
    _file_viewer: null, 
    $table: $(".js_table"),
    $tree: $(".js_section_tree"),
    $filial: $('.select2.js-filial'), 
    init: function () {
        page.$table.on('click', 'a.js_view_file_table_record', function () {
            page.cacheDocumentBeforeOpen($(this).attr("doc-id"), $(this).attr("file-id"));
        });

        page.$table.on('click', 'a.js_download_file_table_record', function () {
            we_helper.getDataDB("/Designer/DownloadFile", { pageid: "documentfile", id: $(this).attr("attr-id") }, "query", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            });  
        });

        we_helper.setBreadcrumb([{ page: "Библиотека", path: "#" }, { page: "Электронный каталог" }]);
        we_helper.initSelect('/Designer/GetRecordsKeyText', page.$filial, { pageid: "filial" }, true, true, function () {
            let def_selected = page.getDefFilial();
            page.$filial.append(new Option(def_selected.text, def_selected.id)).val(def_selected.id).trigger('change');

        }, function (dt) {
            page.setSideBarCache(dt.id, dt.text, null);
            page.reloadTree();
        });
        we_helper.initJqTreeGrid(page.$tree, {
            url: "/Library/GetPublicSectionTree",
            colNames: ['id', 'Раздел', 'Док.'],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                {
                    name: "name", sortable: false, align: 'left', width: 150, index: 'name',
                    formatter: function (cellvalue, options, rowObject) {
                        let icon = "mdi-folder-multiple-outline";
                        if (rowObject.isLeaf) {
                            icon = "mdi-folder-outline";
                        }
                        return "<span class='text-primary mdi " + icon + " pr-1 icon-size'></span>" + rowObject.fullNum + ". " + rowObject.name;
                    }
                },
                {
                    name: "docCount", sortable: false, align: 'center', width: 20, index: 'docCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.docCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.docCount + "</span>";
                    }
                },
            ],
            sortname: 'num',
            sortorder: 'asc', 
            beforeSelectRow: function (rowid, e) {
                if ($(e.target).hasClass("treeclick")) {
                    return false;
                }
                var selrow = $(this).getGridParam('selrow');
                if (selrow == rowid && e.ctrlKey) {
                    $(this).jqGrid('resetSelection');
                    page._search.api().search();
                    return false;
                }
                return selrow != rowid;
            },
            onSelectRow: function (id) {        
                let filial = page.$filial.select2('data')[0];
                page.setSideBarCache(filial.id, filial.text, id);
                page._search.api().search();
            }
        },  function () {
            $(".tree-leaf").addClass("d-none");
            let section = page.getCacheSection();
            if (!!section) {
                page.$tree.jqGrid('setSelection', section);
                we_helper.jqGridTreeExpandToNode(page.$tree, page.getTreeSelectRowData(page._setSelectionNodeId));
            } else {
                page._search.api().search();
            }
            $(".jqgrow", page.$tree).addClass("cursor-pointer");
        });

        page._file_viewer = $(".js_file_viewer_dialog").fileViewer({
            dialog: true,
            onLoad: function () {
                we_helper.hideLoader();
            }
        });
        page._search = $('.js_search_panel').searchPanel({
            uid: "library_" + page._id,
            selectParam: [],
            actionBtn: [],
            searchParam: {
                params: [
                    { text: 'Документ или код', placeholder: 'Введите часть наименования или код документа' },
                    { text: 'Код', placeholder: 'Введите код документа' },
                    { text: 'Документ', placeholder: 'Введите часть наименования документа' }
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            autocomplete: {
                enable: true,
                url: "/Library/GetAutocompleteRecords",
                data: {
                    filialid: page.$filial.val(),
                    sectionid: function () {
                        return page.getTreeSelectRowId(); 
                    }
                }
            },
            defBtn: true,
            dateBlock: {
                show: false
            },
            onSearch: function (data) {
                page.onReloadJqGrid( data);
            },
            onClear: function (data) {
                page.onReloadJqGrid(data);
            }
        });
        we_helper.initJqGrid(page.$table, {
            uid: "library_" + page._id, 
            datatype: "local",
            url: "/Library/GetPublicDocuments", 
            colNames: ['', 'Код', 'Документ', 'Раздел', 'Ответственные', 'Действителен по', 'Дата изменения', 'Просм.'],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 25, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
                { name: "sectionName", sortable: true, align: 'left', width: 60, index: 'sectionName' },
                {
                    name: "departmentNames", sortable: false, align: 'left', width: 90, index: 'departmentNames'
                },
                {
                    name: "validByDate", sortable: true, align: 'center', width: 30, index: 'validByDate',
                    formatter: function (cellvalue, options, rowObject) {
                        if (!!rowObject.validByDate) {
                            if (rowObject.isValid) {
                                return we_helper.convertDate(rowObject.validByDate);
                            }
                            return '<span class="badge badge-danger" style="font-size: 85%;">' + we_helper.convertDate(rowObject.validByDate) + '</span>';
                        }
                        return "";
                    }
                },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                {
                    name: "btnViewFile", sortable: true, align: 'center', width: 15, index: 'btnViewFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-eye-outline text-info js_view_file_table_record' href='#' doc-id='" + rowObject.id + "' title='Просмотреть основной файл документа'></a>";
                    }
                }],
            corr_height: -15,
            sortname: 'num',
            sortorder: 'asc',
            subGrid: true,
            subGridRowExpanded: function (subgrid_id, row_id) {
                page.initDocumentFilesGrid(subgrid_id, row_id);
            },
            beforeSelectRow: function (rowid, e) { return false; } 
        });   

        $(".select-filial-container").removeClass("d-none");
        page.resizeTree();
        page.reloadTree();
    },
    reloadTree: function () {
        page.$tree.setGridParam({
            page: 1, datatype: 'json', postData: {
                filialId: page.$filial.val()
            }
        }).trigger("reloadGrid");
        page.$tree.jqGrid('resetSelection');
    },
    resizeTree: function () {
        $('#split-0 .ui-jqgrid-bdiv').css({ 'height': ($(window).height() - 165) + 'px' });
    },
    getTreeSelectRowId: function () {
        return page.$tree.jqGrid('getGridParam', 'selrow');
    }, 
    getTreeSelectRowData: function (rowId) {
        if (!rowId) {
            rowId = page.getTreeSelectRowId();
        }
        if (rowId == null) { return null; }
        return page.$tree.jqGrid('getLocalRow', rowId);
    },
    cacheDocumentBeforeOpen: function (documentid, fileid) {
        we_helper.getDataDB("/Designer/CacheDocumentBeforeOpen", { fileid: fileid, documentid: documentid }, "query", false, function (entity) {
            page._file_viewer.api().view(entity);
        }); 
    },
    initDocumentFilesGrid: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let documentid = row_id.split('_')[1];

        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            postData: {
                documentid: documentid,
                pageid: "documentfiles"
            },
            url: "/Designer/GetRecords",
            colNames: [
                '', 'Код', 'Файл', 'Расширение', 'Дата изменения', 'Просм.', 'Скач.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 100, index: 'name' },
                { name: "extension", sortable: true, align: 'center', width: 30, index: 'extension' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                }, 
                {
                    name: "btnViewFile", sortable: true, align: 'center', width: 15, index: 'btnViewFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-eye-outline text-info js_view_file_table_record' href='#' doc-id='" + documentid + "' file-id='" + rowObject.id + "' title='Просмотреть файл'></a>";
                    }
                },
                {
                    name: "btnDownloadFile", sortable: true, align: 'center', width: 15, index: 'btnDownloadFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-download-outline text-info js_download_file_table_record' href='#' par-id='" + documentid + "' attr-id='" + rowObject.id + "' title='Скачать файл'></a>";
                    }
                }
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.55);
        }).trigger('resize');
    },
    getDefFilial: function () {
        let cache = we_helper.getCache("library_" + page._id + "_tree");
        if (!!cache && !!cache.filial) {
            return cache.filial; 
        }
        return we_helper.getCurUserFilial(); 
    },
    getCacheSection: function () {
        let cache = we_helper.getCache("library_" + page._id + "_tree");
        if (!!cache && !!cache.sectionid) {
            return cache.sectionid;
        }
        return null;
    },
    setSideBarCache: function (filialid, filialname, sectionid) {
        we_helper.setCache("library_" + page._id + "_tree", {
            filial: {
                id: filialid,
                text: filialname,
            },
            sectionid: sectionid
        });
    },
    onReloadJqGrid: function (data) {
        let filialid = page.$filial.val(),
            sectionid = page.getTreeSelectRowId();
        we_helper.reloadJqGrid(page.$table, $.extend(data, { filialid: filialid, sectionid: sectionid }), 1);
    } 
};