﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _search: null,
    _file_viewer: null,
    $table: $(".js_table"),
    init: function (_pageInfo) {
        we_helper.setBreadcrumb([{ page: "Библиотека", path: "#" }, { page: "Глобальный поиск" }]);

        page.$table.on('click', 'a.js_view_file_table_record', function () {
            page.cacheDocumentBeforeOpen($(this).attr("doc-id"), $(this).attr("file-id"));
        });

        page.$table.on('click', 'a.js_download_file_table_record', function () {
            we_helper.getDataDB("/Designer/DownloadFile", { pageid: "documentfile", id: $(this).attr("attr-id") }, "query", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            });  
        });

        page._file_viewer = $(".js_file_viewer_dialog").fileViewer({
            dialog: true,
            onLoad: function () {
                we_helper.hideLoader();
            }
        });
        page._search = $('.js_search_panel').searchPanel({
            uid: "library_" + page._id,
            selectParam: [],
            actionBtn: [],
            searchParam: {
                params: [
                    { text: 'Документ или код', placeholder: 'Введите часть наименования или код документа' },
                    { text: 'Код', placeholder: 'Введите код документа' },
                    { text: 'Документ', placeholder: 'Введите часть наименования документа' } 
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            autocomplete: {
                enable: true,
                url: "/Library/GetAutocompleteRecords",
            },
            defBtn: true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            } 
        });
        we_helper.initJqGrid(page.$table, {
            uid: "library_" + page._id, 
            url: "/Library/GetPublicDocuments",
            colNames: ['', 'Код', 'Документ', 'Раздел', 'Структурная единица', 'Ответственные', 'Действителен по', 'Дата изменения', 'Просм.'],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 25, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
                { name: "sectionName", sortable: true, align: 'left', width: 70, index: 'sectionName' },
                { name: "filialName", sortable: true, align: 'left', width: 50, index: 'filialName' },
                {
                    name: "departmentNames", sortable: false, align: 'left', width: 90, index: 'departmentNames'
                },
                {
                    name: "validByDate", sortable: true, align: 'center', width: 30, index: 'validByDate',
                    formatter: function (cellvalue, options, rowObject) {
                        if (!!rowObject.validByDate) {
                            if (rowObject.isValid) {
                                return we_helper.convertDate(rowObject.validByDate);
                            }
                            return '<span class="badge badge-danger" style="font-size: 85%;">' + we_helper.convertDate(rowObject.validByDate) + '</span>';
                        }
                        return "";
                    }
                },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                {
                    name: "btnViewFile", sortable: true, align: 'center', width: 15, index: 'btnViewFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-eye-outline text-info js_view_file_table_record' href='#' doc-id='" + rowObject.id + "' title='Просмотреть основной файл документа'></a>";
                    }
                }],
            sortname: 'name',
            sortorder: 'asc',
            subGrid: true,
            subGridRowExpanded: function (subgrid_id, row_id) {
                page.initDocumentFilesGrid(subgrid_id, row_id);
            },
            beforeSelectRow: function (rowid, e) { return false; }
        }, page._search.api().get_data());   
    },
    cacheDocumentBeforeOpen: function (documentid, fileid) {
        we_helper.getDataDB("/Designer/CacheDocumentBeforeOpen", { fileid: fileid, documentid: documentid }, "query", false, function (entity) {
            page._file_viewer.api().view(entity);
        });
    },
    initDocumentFilesGrid: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let documentid = row_id.split('_')[1];

        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            postData: {
                documentid: documentid,
                pageid: "documentfiles"
            },
            url: "/Designer/GetRecords",
            colNames: [
                '', 'Код', 'Файл', 'Расширение', 'Дата изменения', 'Просм.', 'Скач.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: true, align: 'center', width: 20, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 100, index: 'name' },
                { name: "extension", sortable: true, align: 'center', width: 30, index: 'extension' },
                {
                    name: "dateOfChange", sortable: true, align: 'left', width: 50, index: 'dateOfChange',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
                },
                {
                    name: "btnViewFile", sortable: true, align: 'center', width: 15, index: 'btnViewFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-eye-outline text-info js_view_file_table_record' href='#' doc-id='" + documentid + "' file-id='" + rowObject.id + "' title='Просмотреть файл'></a>";
                    }
                },
                {
                    name: "btnDownloadFile", sortable: true, align: 'center', width: 15, index: 'btnDownloadFile', formatter: function (cellvalue, options, rowObject) {
                        return "<a class='mdi mdi-file-download-outline text-info js_download_file_table_record' href='#' par-id='" + documentid + "' attr-id='" + rowObject.id + "' title='Скачать файл'></a>";
                    }
                }
            ],
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.60);
        }).trigger('resize');
    }
};

