﻿$(function () {
    page.init();
    $(window).resize(function () {
        page.resizeTree(); 
    });

    $(document).on('click', 'button.btn-start-module-testing', function () {
        let row = page.getTreeSelectRowData();
        if (row == null) {
            we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
            return;
        }
        let ids = row["id"].split(';');
        if (ids.length !== 2 || row["rating"] === "") {
            we_helper.alert("Выбранные записи не удовлетворяют условиям контроля!", notificatioType.danger);
            return;
        }

        bootbox.confirm({
            message: "Вы уверены, что хотите начать контроль?",
            swapButtonOrder: true,
            buttons: {
                cancel: {
                    label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
                    className: 'btn-sm btn-danger'
                },
                confirm: {
                    label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
                    className: 'btn-sm btn-success'
                }
            },
            callback: function (result) {
                if (result) {
                    we_helper.showLoader();
                    we_helper.updateDataDB("/Training/StartTest", { programid: ids[0], moduleid: ids[1] }, function (response) {
                        let addUrl = we_testing.buildTestingAdditionalUrl({
                            programid: page._programId,
                            groupid: page._groupId,
                            filialid: page._filialId,
                            controltype: 6
                        });
                        we_testing.gotoTestingByTheme(response, addUrl);
                    });
                }
            }
        });
    }); 
});

var page = {
    _cur_user_filial: we_helper.getCurUserFilial(),
    _programId: we_helper.urlParam("programid"),
    _groupId: we_helper.urlParam("groupid"),
    _filialId : we_helper.urlParam("filialid"),
    _bookmarkLink :[],
    _curBookmark: 0,
    _randomQuestion: null,
    _file_viewer: null, 
    $tree: $(".js_program_tree"), 
    $dlgRandomQuestion: $(".js_modal_random_question"),
    $btn_check_question: $('.js_modal_random_question_ok'),
    $questionText: $(".question-text"),
    $questionPrompt: $(".question-prompt"),
    $listAnswers: $(".list-answers"),
    $btnShowFile: $(".btn-show-file"),
    init: function () {
        if (page._programId == null) {
            window.open("/training?pageid=learning", "_self");
        }
        let crumb = [{ page: "Обучение", path: "#" }];
        if (page._groupId !== null) {
            crumb.push({ page: "Программы аттестации", path: "/training?pageid=attestable" });
        } else {
            crumb.push({ page: "Индивидуальное обучение", path: "/training?pageid=learning" });
        }
        crumb.push({ page: "Обучение в рамках учебного курса" });
        we_helper.setBreadcrumb(crumb);

        page.$dlgRandomQuestion.on('hidden.bs.modal', function (e) {
            page._randomQuestion = null;
            $(".result-info").text("").removeClass("text-danger").removeClass("text-success");
        });
        page.$btn_check_question.on('click', function (e) {
            let result = ["", ""];
            let $result_info = $(".result-info");
            $result_info.removeClass("text-danger").removeClass("text-success");
            if (page._randomQuestion) {
                switch (page._randomQuestion.questType) {
                    case 0: { //MultipleChoice
                        let i = 0, ts = 0, sok = 0, ok = 0;
                        for (; i < page._randomQuestion.answers.length; i++) {
                            let cur = page._randomQuestion.answers[i];
                            let $cb = $("#" + cur.id);
                            let checked = $cb.prop("checked");
                            if (cur.correct) {
                                ok++;
                                if (checked) {
                                    sok++;
                                    ts++;
                                }
                            } else if (checked) {
                                ts++;
                            } 
                        }
                        result = ["Всего ответов - " + i + "; Выбрано - " + ts + "; Из них правильных - " + sok,
                            ok == sok && ok == ts ? "text-success" : "text-danger"];
                        break;
                    }
                    case 1: { //SequenceDefinition
                        result = ["Последовательность установлена верно", "text-success"];
                        for (var i = 0; i < page._randomQuestion.answers.length; i++) {
                            let answer = $("#" + page._randomQuestion.answers[i].id).val();
                            if (page._randomQuestion.answers[i].num != answer) {
                                result = ["Последовательность установлена неверно", "text-danger"];
                                break;
                            }
                        }
                        break;
                    }
                    case 2: { //EstablishmentConformity
                        result = ["Соответствие установлена верно", "text-success"];
                        for (var i = 0; i < page._randomQuestion.answers.length; i++) {
                            let answer = $("#" + page._randomQuestion.answers[i].id).val();
                            if (page._randomQuestion.answers[i].num != answer) {
                                result = ["Соответствие установлено неверно", "text-danger"];
                                break;
                            }
                        }
                        break;
                    }
                    case 3: { //NumericalAnswer
                        result = ["Введенный ответ верен", "text-success"];
                        if (page._randomQuestion.answers.length == 1) {
                            let numeric = parseFloat(page._randomQuestion.answers[0].numeric.toString().replace(",", "."));
                            let prec = parseFloat(page._randomQuestion.answers[0].prec.toString().replace(",", "."));
                            let answer = parseFloat($("#" + page._randomQuestion.answers[0].id).val().replace(",", "."));
                            if (Math.abs(parseFloat(answer - numeric).toFixed(4)) > prec) {
                                result = ["Введенный ответ неверен", "text-danger"];
                            }
                        }
                        break;
                    }
                    default:
                        break;
                }
            }
            $result_info.text(result[0]).addClass(result[1]);
        });
        page.$btnShowFile.on("click", function () {
            let questionId = $(this).attr("question-id");
            we_helper.getDataDB("/Training/CacheQuestImageFileBeforeOpen", {  questionId: questionId }, "query", false, function (entity) {
                window.open('../temp/' + entity, '_blank', "resizable=yes,scrollbars=yes,status=no, width=800px, height=600px");
                we_helper.hideLoader();
            });
            return false;
        });
        we_helper.initJqTreeGrid(page.$tree, {
            url: "/Training/GetStudyProgramTree",
            colNames: ['id', '', 'Учебный курс', 'Балл'],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "componentType", hidedlg: true, hidden: true, index: 'componentType' },
                {
                    name: "name", sortable: false, align: 'left', width: 150, index: 'name',
                    formatter: function (cellvalue, options, rowObject) {
                        return "<span class='text-primary " + page.getTreeNodeIcon(rowObject.level, rowObject.componentType) + " pr-1 icon-size'></span>" + rowObject.name;
                    }
                },
                {
                    name: "rating", sortable: false, align: 'center', width: 20, index: 'rating',
                    formatter: function (cellvalue, options, rowObject) {
                        if (cellvalue === null) {
                            return "";
                        }
                        return cellvalue;
                    },
                    cellattr: function (rowId, cellvalue, rowObject) {
                        if (cellvalue === null) {
                            return "";
                        }
                        if (rowObject.rating === 0 || rowObject.rating < rowObject.intermediateAttestationBall) {
                            return " class='bg-danger'";
                        }
                        let revisedBall = rowObject.intermediateAttestationBall + ((100 - rowObject.intermediateAttestationBall) / 2);
                        if (rowObject.rating >= rowObject.intermediateAttestationBall && rowObject.rating < revisedBall) {
                            return " class='bg-warning'";
                        }
                        if (rowObject.rating >= revisedBall) {
                            return " class='bg-success'";
                        } 
                    }
                },
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) {
                if ($(e.target).hasClass("treeclick")) {
                    return false;
                }
                return $(this).getGridParam('selrow') != rowid;
            },
            onSelectRow: function (id) {
                page._curBookmark = 0;
                page._bookmarkLink = [];
                $(".module-info, .document-info").addClass("d-none");
                $(".questions-on-verification").addClass("d-none").children("span").text("");
                let ids = id.split(";");
                let row = page.getTreeSelectRowData(id);
                if (ids.length == 1) {
                    let rating = 0.0;
                    if (row !== null && row["rating"] !== "") {
                        rating = parseFloat(row["rating"]);
                    }
                    page.getProgramInfo(page._programId, page._groupId, rating);
                } else if (ids.length == 2) {
                    if (row !== null && row["rating"] !== "") {
                        $(".module-info").removeClass("d-none");
                    }
                } else if (ids.length == 3 && row !== null && row["componentType"] === "0") {
                    page.getDocumentInfo(ids[1], ids[2]);
                }
            }
        }, function () {
            $(".tree-leaf").addClass("d-none");
            page.$tree.jqGrid('setSelection', page._programId);
            $(".jqgrow", page.$tree).addClass("cursor-pointer");
        });
        page._file_viewer = $(".file-info").fileViewer({
            dialog: false,
            corheight: 0.75,
            actionBtn: [
                {
                    icon: "mdi mdi-help pr-lg-1",
                    className: "btn btn-sm btn-info",
                    title: "Показать тестовое задание к текущей закладке",
                } 
            ],
            onLoad: function ($frame) {
                if ($frame) {
                    let src = $frame.attr("src");
                    page._file_viewer.api().disabledActionBtn([0, 3]);
                    if (!!src && page._bookmarkLink.length > 0) {
                        if (page._bookmarkLink.length > 1) {
                            page._file_viewer.api().enabledActionBtn([3]);
                        }
                        if (src.indexOf("viewer.html") !== -1) {
                            page._file_viewer.api().showActionMenu();
                        }
                        else {
                            let content = $frame.contents();
                            content.find('head').append('<style type="text/css"> .light {background: #cccccc;} </style>')

                            for (var i = 0; i < page._bookmarkLink.length; i++) {
                                let anchor = page._bookmarkLink[i];
                                if (!!anchor && anchor.indexOf("#") !== -1) {
                                    content.find("a[name=" + anchor.split('#')[1] + "]").parent().addClass('light');
                                }
                            }
                        }
                    }
                }
                we_helper.hideLoader();
            },
            onPrev: function () {
                if (page._curBookmark > 0) {
                    page._curBookmark--;
                    page._file_viewer.api().gotoAnchor(page._bookmarkLink[page._curBookmark]);
                    if (page._curBookmark == 0) {
                        page._file_viewer.api().disabledActionBtn([0]);
                    }
                }
                page._file_viewer.api().enabledActionBtn([3]);
            },
            onNext: function () {
                if (page._curBookmark < page._bookmarkLink.length - 1) {
                    page._curBookmark++;
                    page._file_viewer.api().gotoAnchor(page._bookmarkLink[page._curBookmark]);
                    if (page._curBookmark == page._bookmarkLink.length - 1) {
                        page._file_viewer.api().disabledActionBtn([3]);
                    }
                }
                page._file_viewer.api().enabledActionBtn([0]);
            },
            onAction: function (btn) {
                if (btn == "4") {
                    let row = page.getTreeSelectRowData();
                    if (row == null) {
                        we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
                        return;
                    }
                    let ids = row["id"].split(';');
                    if (ids.length !== 3) {
                        we_helper.alert("Выбранные записи не удовлетворяют условиям контроля!", notificatioType.danger);
                        return;
                    }
                    var link = "";
                    if (page._bookmarkLink.length != 0) {
                        link = page._bookmarkLink[page._curBookmark];
                    }
                    page.getRandomQuestion(ids[1], ids[2], link);
                } 
            },
        });
        page.resizeTree();
        page.reloadTree();
    },
    reloadTree: function () {
        page.$tree.setGridParam({
            page: 1, datatype: 'json', postData: {
                programId: page._programId
            }
        }).trigger("reloadGrid");
        page.$tree.jqGrid('resetSelection');
    },
    resizeTree: function () {
        $('#split-0 .ui-jqgrid-bdiv').css({ 'height': ($(window).height() - 90) + 'px' });
    }, 
    getTreeSelectRowId: function () {
        return page.$tree.jqGrid('getGridParam', 'selrow');
    },
    getTreeSelectRowData: function (rowId) {
        if (!rowId) {
            rowId = page.getTreeSelectRowId();
        }
        if (rowId == null) { return null; }
        return page.$tree.jqGrid('getRowData', rowId);
    },
    getTreeNodeIcon: function (level, componentType) {
        if (level == 0) {
            return "mdi mdi-school";
        } else if (level == 1) {
            switch (componentType) {
                case 1: {
                    return "mdi mdi-bike";
                    break;
                }
                case 2: {
                    return "mdi mdi-tournament";
                    break;
                }
                case 3: {
                    return "mdi mdi-code-braces";
                    break;
                }
                default: {
                    return "mdi mdi-folder-outline";
                    break;
                }
            }
        } else if (level == 2) {
            return "mdi mdi-file-outline";
        }
        return "";
    },
    getProgramInfo: function (programid, groupid, rating) {
        $(".required-testing-info, .intermediate-attestation-info").addClass("d-none");
        we_helper.getDataDB("/Training/GetProgramTraining", {
            programId: programid,
            groupId: groupid,
            rating: rating
        }, "query", false, function (entity) {
            if (entity.redirect == "accessdenied") {
                window.open("/training?pageid=learning", "_self");
            } else if (entity.redirect == "introductory") {
                let lnk = "/testing?pageid=testselection&programid=" + programid + "&filialid=" + page._filialId + "&controltype=0";
                if (groupid !== null) {
                    lnk += "&groupid=" + groupid;
                }
                window.open(lnk, "_self");
            } else {
                if (entity.requiredTesting !== 0 && !!entity.requiredResultMark) {
                    $(".required-testing-info")
                        .html("<div class='col'>Результат контроля перед началом дистанционного обучения: <strong>" + entity.requiredResultMark + "</strong></div>")
                        .removeClass('d-none');
                }

                if (entity.intermediateAttestation !== 0) {
                    let str = "<div class='col'>";
                    if (rating < entity.intermediateAttestationBall) {
                        str += "Контроль по завершению дистанционного обучения будет доступен при рейтинге &ge; <strong>" + entity.intermediateAttestationBall + "% </strong>. ";
                        str += "Текущий рейтинг: <strong>" + rating + "% </strong>";
                    }
                    else if (!!entity.intermediateResultMark) {
                        str += "Результат контроля по завершению дистанционного обучения: <strong>" + entity.intermediateResultMark + "</strong>";
                    }
                    else {
                        let lnk = "/testing?pageid=testselection&programid=" + programid + "&filialid=" + page._filialId + "&controltype=1";
                        if (groupid !== null) {
                            lnk += "&groupid=" + groupid;
                        }
                        str += "Контроль по завершению дистанционного обучения: <strong><a href='" + lnk + "'>Начать</a></strong>";
                    }
                    str += "</div>";
                    $(".intermediate-attestation-info").html(str).removeClass("d-none")
                }
                we_helper.hideLoader();
            }
        });
    },
    getDocumentInfo: function (moduleid, documentid) {
        we_helper.getDataDB("/Training/GetDocumentTrainingData", {
            moduleId: moduleid,
            documentId: documentid
        }, "query", false, function (entity) {
            page._file_viewer.api().hideActionBtn([4]);
            if (entity.allowTrialQuestion) {
                page._file_viewer.api().showActionBtn([4]);
            }
            let link = null;
            if (entity.studyDocParts) {
                page._bookmarkLink = entity.bookMarks;
                if (page._bookmarkLink.length != 0) {
                    link = page._bookmarkLink[0];
                }
            }
            page._file_viewer.api().view(entity.file, link);
            if (entity.questionsOnUpdating) {
                page._file_viewer.api().hideActionBtn([4]);
                $(".questions-on-verification")
                    .removeClass("d-none").children("span")
                    .text("Тестовые задания на проверке с " + we_helper.convertDate(entity.questionsOnUpdating));
            }
            $(".document-info").removeClass("d-none");
            we_helper.hideLoader();
        });
    }, 
    getRandomQuestion: function (moduleid, documentid, link) {
        we_helper.getDataDB("/Training/GetRandomQuestion", {
            moduleId: moduleid,
            documentId: documentid,
            bookMark: link
        }, "query", false, function (entity) {
            page.$questionText.html(entity.name);
            page.$questionPrompt.text(entity.textHint);

            page.$btnShowFile.attr("question-id", entity.id).addClass("d-none");
            if (entity.isHaveFile) {
                page.$btnShowFile.removeClass("d-none");
            }
            page._randomQuestion = entity;
            we_testing.createAnswers(entity.questType, entity.answers, page.$listAnswers);
           
            page.$dlgRandomQuestion.modal('show');
            page.$btn_check_question.prop('disabled', false);
            we_helper.hideLoader();
        });
    } 
};