﻿$(function () {
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _cur_user_filial: we_helper.getCurUserFilial(),
    _search: null,
    $table: $(".js_table"),  
    init: function () {
        page.$table.on('click', 'a.js_export_table_record', function () {
            let data = {
                pageid: page._id,
                rowid: $(this).attr("attr-id"),
                format:".pdf"
            };
            we_helper.getDataDB("/Training/SaveReport", data, "body", false, function (entity) {
                window.open('../temp/' + entity, "_blank");
                we_helper.hideLoader();
            }); 
        }); 
        let _searchParam = {
            params: [],
            default: {
                param: 0,
                data: ""
            }
        };
        let _selectParam = [{
            id: "filial",
            title: "Структурная единица",
            url: "/Admin/GetRecordsKeyText",
            def_selected: page._cur_user_filial
        }];
        let _table_stg = {
            uid: "training_" + page._id,
            url: "/Training/GetRecords",
            colNames: [],
            colModel: [],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; }
        };
        let _actionBtn = [];
        let crumb = [{
            page: "Обучение",
            path: "#"
        }];
        switch (page._id) {
            case "learning": {
                crumb.push({ page: "Индивидуальное обучение" });
                _searchParam.params = [
                    { text: 'Учебный курс или код', placeholder: 'Введите часть наименования или код учебного курса' },
                    { text: 'Код', placeholder: 'Введите код учебного курса' },
                    { text: 'Учебный курс', placeholder: 'Введите часть наименования учебного курса' },
                    { text: 'Регламент контроля', placeholder: 'Введите часть наименования регламента контроля' }
                ];
                _table_stg.colNames = [
                    '', '', 'Код', 'Учебный курс', 'Регламент контроля', 'Структурная единица', 'Мод.', 'Эксп.'
                ];
                _table_stg.colModel = [
                    { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                    { name: "filialId", hidedlg: true, hidden: true, index: 'filialId' },
                    { name: "num", sortable: true, align: 'center', width: 20, index: 'num' },
                    { name: "name", sortable: true, align: 'left', width: 200, index: 'name' },
                    { name: "testingRegulationName", sortable: true, align: 'left', width: 100, index: 'testingRegulationName' },
                    { name: "filialName", sortable: true, align: 'left', width: 50, index: 'filialName' },
                    {
                        name: "moduleCount", sortable: true, align: 'center', width: 20, index: 'moduleCount', formatter: function (cellvalue, options, rowObject) {
                            let color = "badge-success";
                            if (rowObject.moduleCount <= 0) {
                                color = "badge-danger";
                            }
                            return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.moduleCount + "</span>";
                        }
                    },
                    {
                        name: "btnExport", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                        formatter: function (cellvalue, options, rowObject) {
                            return "<a class='mdi mdi-file-export text-info js_export_table_record' href='#' attr-id='" + rowObject.id + "' title='Отчёт о статистике успеваемости по учебному курсу'></a>";
                        }
                    }
                ];
                _table_stg.beforeSelectRow = function (rowid, e) {
                    var $link = $('a', e.target);
                    if (e.target.tagName.toUpperCase() === "A" || $link.length > 0) {
                        return false;
                    }
                    let _rowData = $(this).jqGrid('getRowData', rowid);
                    window.open("/training?pageid=studyprogram&programid=" + _rowData["id"] + "&filialid=" + _rowData["filialId"], "_self");
                };
                break;
            }
            case "attestable": {
                crumb.push({ page: "Программы аттестации" });
                _selectParam[0].def_selected = null;
                _searchParam.params = [
                    { text: 'Программа аттестации или код', placeholder: 'Введите часть наименования или код программы аттестации' },
                    { text: 'Код', placeholder: 'Введите код программы аттестации' },
                    { text: 'Программа аттестации', placeholder: 'Введите часть наименования программы аттестации' }
                ];
                _table_stg.colNames = [
                    '', '', '', 'Код', 'Программа аттестации', 'Структурная единица', 'Представители', 'Уч.курс.', 'Эксп.'
                ];
                _table_stg.colModel = [
                    { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                    { name: "filialId", hidedlg: true, hidden: true, index: 'filialId' },
                    {
                        name: "status", sortable: false, align: 'center', width: 10, index: 'status',
                        formatter: function (cellvalue, options, rowObject) {
                            return '<span class="mdi mdi-circle text-' + rowObject.status + '"></span>';
                        }
                    },
                    { name: "num", sortable: true, align: 'center', width: 35, index: 'num' },
                    { name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
                    { name: "filialName", sortable: true, align: 'left', width: 90, index: 'filialName' },
                    { name: "represents", sortable: false, align: 'left', width: 90, index: 'represents' },
                    {
                        name: "courseCount", sortable: true, align: 'center', width: 20, index: 'courseCount', formatter: function (cellvalue, options, rowObject) {
                            let color = "badge-success";
                            if (rowObject.courseCount <= 0) {
                                color = "badge-danger";
                            }
                            return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.courseCount + "</span>";
                        }
                    },
                    {
                        name: "btnExport", classes: 'overflow-none', width: 20, align: "center", sortable: false,
                        formatter: function (cellvalue, options, rowObject) {
                            return "<a class='mdi mdi-file-export text-info js_export_table_record' href='#' attr-id='" + rowObject.id + "' title='Отчёт о статистике успеваемости по программе аттестации'></a>";
                        }
                    }
                ]; 
                _table_stg.subGrid = true;
                _table_stg.subGridRowExpanded = function (subgrid_id, row_id) {
                    page.initGroupCoursesGrid(subgrid_id, row_id);
                };  
                break;
            }
            default: {
                window.open('/', '_self');
            }
        }
        we_helper.setBreadcrumb(crumb);
        page._search = $('.js_search_panel').searchPanel({
            uid: "training_" + page._id,
            selectParam: _selectParam,
            actionBtn: _actionBtn,
            searchParam: _searchParam,
            autocomplete: {
                enable: true,
                url: "/Training/GetAutocompleteRecords",
            },
            defBtn: true,
            dateBlock: {
                show: false
            },
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$table, data, 1);
            }
        });
        we_helper.initJqGrid(page.$table, _table_stg, page._search.api().get_data(), function () {
            if (page._id === "learning") {
                $(".jqgrow").addClass("cursor-pointer");
            }
        });
    },
    initGroupCoursesGrid: function (subgrid_id, row_id) {
        let subgrid_table_id = subgrid_id + "_t",
            pager_id = "p_" + subgrid_table_id;
        let groupid = row_id.split('_')[1];
        $("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
        we_helper.initJqGrid($("#" + subgrid_table_id), {
            postData: {
                groupid: groupid,
                pageid: "programsgroup"
            },
            url: "/Training/GetRecords",
            colNames: [
                '', '', '', '', 'Начало', 'Окончание', 'Назначение', '', 'Код', 'Учебный курс', 'Регламент контроля'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "groupId", hidedlg: true, hidden: true, index: 'groupId' },
                { name: "programId", hidedlg: true, hidden: true, index: 'programId' },
                {
                    name: "isValid", sortable: false, align: 'center', width: 10, index: 'isValid',
                    formatter: function (cellvalue, options, rowObject) {
                        let _color = "success";
                        if (!rowObject.isValid) {
                            _color = "danger";
                        }
                        return '<span class="mdi mdi-circle text-' + _color + '"></span>';
                    }
                },
                {
                    name: "startDate", sortable: true, align: 'center', width: 50, index: 'startDate',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i" }
                },
                {
                    name: "endDate", sortable: true, align: 'center', width: 50, index: 'endDate',
                    formatter: "date",
                    formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i" }
                },
                { name: "trainingFormName", sortable: true, align: 'center', width: 50, index: 'trainingFormName' },
                { name: "trainingForm", sortable: false, hidedlg: true, hidden: true, index: 'trainingForm' },
                { name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
                {
                    name: "programName", sortable: true, align: 'left', width: 200, index: 'programName',
                    formatter: function (cellvalue, options, rowObject) {
                        if (!rowObject.isValid && rowObject.trainingForm === 2) {
                            return "<span class='text-danger'>До старта соревнований наименование учебного курса недоступно.</span>";
                        } else {
                            return cellvalue;
                        }
                    }
                },
                { name: "testingRegulationName", sortable: true, align: 'left', width: 100, index: 'testingRegulationName' }
            ], 
            idPrefix: "s_" + row_id + "_",
            pager: "#" + pager_id,
            auto_height: true,
            sortname: 'startDate',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { 
                var rowData = $(this).jqGrid('getRowData', rowid);
                if (rowData["isValid"].indexOf("success") === -1) {
                    return false;
                }
                let _parentRowData = page.$table.jqGrid('getRowData', "g1_" + rowData["groupId"]);
                let lnk = "#";
                if (rowData["trainingForm"] === "0") {
                    lnk = "/testing?pageid=testselection&programid=" + rowData["programId"] + "&groupid=" + rowData["groupId"] + "&filialid=" + _parentRowData["filialId"] + "&controltype=2";
                } else if (rowData["trainingForm"] === "1") {
                    lnk = "/training?pageid=studyprogram&programid=" + rowData["programId"] + "&groupid=" + rowData["groupId"] + "&filialid=" + _parentRowData["filialId"];
                } else if (rowData["trainingForm"] === "2") {
                    lnk = "/testing?pageid=testselection&programid=" + rowData["programId"] + "&groupid=" + rowData["groupId"] + "&filialid=" + _parentRowData["filialId"] + "&controltype=4";
                }
                window.open(lnk, "_self");
            }
        }, {}, function () {
            $(".jqgrow", $("#" + subgrid_table_id)).addClass("cursor-pointer");
        });
        $(window).bind('resize', function () {
            $("#" + subgrid_table_id).setGridWidth($(window).width() * 0.8);
        }).trigger('resize');
    }
};
