﻿$(function () {
	page.init();
});

var page = {
	_edition: $("#assembly-config-edition").attr("value"),
	_id: we_helper.getPageId(),
	_cur_user_filial: we_helper.getCurUserFilial(),
	_sys_owner_filial: we_helper.getSystemOwnerFilial(),
	_data: {},
	_cruc: {
		url: [],
		title: [],
		$modal: $(".js_detail_modal"),
		$saveBtn: $('.js_modal_save_change', $(".js_detail_modal"))
	},
	_table_selected_rows: [],
	_search: null,
	$table: $(".js_table"),
	$dlgReportSettings: $(".js_modal_report_settings"),
	init: function (_pageInfo) {
		let crumb = [{
			page: "Планирование",
			path: "#"
		}];

		page.$dlgReportSettings.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page.$dlgReportSettings);
		});
		$('.btn-success', page.$dlgReportSettings).on('click', function (e) {
			let data = page._search.api().get_data();
			let gridParam = page.$table.jqGrid('getGridParam', 'postData');
			data["sidx"] = gridParam.sidx;
			data["sord"] = gridParam.sord;
			data["format"] = $('input[name="fileformattype"]:checked').attr("id");
			data["rowid"] = $("[name='exportrowid']").val();
			if (page._id === "protocol" && !!data["rowid"]) {
				data = $.extend(data, we_helper.getFormData($(".export-protocol")));
			}
			we_helper.getDataDB("/Tutoring/SaveReport", data, "body", false, function (entity) {
				window.open('../temp/' + entity, "_blank");
				we_helper.hideLoader();
			});
		});

		page._cruc.$modal.on('hidden.bs.modal', function (e) {
			we_helper.clearModal(page._cruc.$modal, page._data);
		});

		page._cruc.$saveBtn.on('click', function (e) {
			if (we_helper.checkValidation(page._cruc.$modal) === true) {
				page.updateRecord();
			}
			e.preventDefault();
		});
		page.$table.on('click', 'a.js_export_rsp_table_record', function () {
			let id = $(this).attr("attr-id");
			page.exportToRsp(id);
		});
		page.$table.on('click', 'a.js_export_table_record', function () {
			let legacy = $(this).attr("attr-legacy");
			if (page._id === "protocol" && legacy === "true") {
				we_helper.getDataDB("/Tutoring/SaveReport", { pageid: "protocol", rowid: $(this).attr("attr-id") }, "body", false, function (entity) {
					window.open('../temp/' + entity, "_blank");
					we_helper.hideLoader();
				});
			} else {
				$(".export-protocol").removeClass("d-none");
				we_helper.setFormData(page.$dlgReportSettings, {
					exportrowid: $(this).attr("attr-id")
				});
				page.$dlgReportSettings.modal('show');
			}
		});
		page.$table.on('click', 'a.js_edit_table_record', function () {
			page.showModal("edit", $(this).attr("attr-id"));
		});
		page.$table.on('click', 'a.js_del_table_record', function () {
			let id = $(this).attr("attr-id");
			page.deleteRecords([id], function () {
				let index = $.inArray(id, page._table_selected_rows);
				if (index !== -1) {
					page._table_selected_rows.splice(index, 1);
				}
				we_helper.reloadJqGrid(page.$table);
			});
		});
		page.$table.on('click', '.js-select-row', function () {
			we_helper.multipleSelection($(this), page._table_selected_rows);
			$('.js-select-all-row').prop('checked',
				we_helper.isAllSelected($('.js-select-row', page.$table)));
		});
		page.$table.parent().on('click', '.js-select-all-row', function () {
			we_helper.selectAllRows($('.js-select-row', page.$table), $(this).is(":checked"), page._table_selected_rows);
		});
		page.$table.on('click', 'a.js_copy_table_record', function () {
			page.showModal("copy", $(this).attr("attr-id"));
		});
		page.$table.on('click', 'a.js_send_table_record', function () {
			page.sendAlertUserInGroup($(this).attr("attr-id"));
		});
		page.$table.on('click', 'a.js_add_table_record', function () {
			let id = $(this).attr("attr-id");
			if (page._id == "includemember") {
				page.includeMembersToGroup([id], function () {
					let index = $.inArray(id, page._table_selected_rows);
					if (index !== -1) {
						page._table_selected_rows.splice(index, 1);
					}
					we_helper.reloadJqGrid(page.$table);
				});
			}
		});

		let _searchParam = {
			params: [],
			default: {
				param: 0,
				data: ""
			}
		};
		let _selectParam = [{
			id: "filial",
			title: "Структурная единица",
			url: "/Admin/GetRecordsKeyText",
			def_selected: page._cur_user_filial
		}];
		let _searchAutocomplete = {
			enable: true,
			url: "/Tutoring/GetAutocompleteRecords",
		};
		let _table_stg = {
			uid: "tutoring_" + page._id,
			url: "/Tutoring/GetRecords",
			colNames: [],
			colModel: [],
			sortname: 'num',
			sortorder: 'asc',
			beforeSelectRow: function (rowid, e) { return false; }
		};
		let _actionBtn = [
			{
				id: "add",
				icon: "mdi mdi-plus",
				style: "success",
				text: "Создать"
			},
			{
				id: "delete",
				icon: "mdi mdi-delete",
				style: "danger",
				text: "Удалить"
			},
			{
				id: "export",
				icon: "mdi mdi-database-export",
				style: "info",
				text: "Отчёт"
			}];

		switch (page._id) {
			case "group": {
				crumb.push({ page: "Программы аттестации" });
				page._cruc.url = ["/Tutoring/CreateGroup", "/Tutoring/UpdateGroup", "/Tutoring/CopyGroup"];
				page._cruc.title = ["Создание новой программы аттестации", "Редактирование параметров программы аттестации", "Создание копии программы аттестации"];
				_searchParam.params = [
					{ text: 'Программа аттестации или код', placeholder: 'Введите часть наименования или код программы аттестации' },
					{ text: 'Код', placeholder: 'Введите код программы аттестации' },
					{ text: 'Программа аттестации', placeholder: 'Введите часть наименования программы аттестации' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];
				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', '', 'Код', 'Программа аттестации', 'Структурная единица', 'Уведомлять',
					'Дата изменения', 'Изменил', 'Представителей', 'Группа', 'Уч.курс.', 'Ув.', 'Эксп.', 'Ред.', 'Коп.', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{
						name: "status", sortable: false, align: 'center', width: 10, index: 'status',
						formatter: function (cellvalue, options, rowObject) {
							return '<span class="mdi mdi-circle text-' + rowObject.status + '"></span>';
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 35, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 250, index: 'name' },
					{ name: "filialName", sortable: true, align: 'left', width: 90, index: 'filialName' },
					{
						name: "alertAboutEnd", sortable: true, align: 'center', width: 35, index: 'alertAboutEnd',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.alertAboutEnd === null || rowObject.alertAboutEnd === 0) {
								return "<span class='badge badge-pill badge-danger badge-cell'>НЕТ</span>";
							}
							return "за " + rowObject.alertAboutEnd + " дн."
						}
					},
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 70, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 90, index: 'userHasChanged' },
					{
						name: "representCount", sortable: true, align: 'center', width: 20, index: 'representCount', formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.representCount <= 0) {
								color = "badge-danger";
							}
							return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.representCount + "</span></a>";
						}
					},
					{
						name: "userCount", sortable: true, align: 'center', width: 20, index: 'userCount', formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.userCount <= 0) {
								color = "badge-danger";
							}
							return "<a href='tutoring?pageid=groupmember&groupid=" + rowObject.id + "' title='Учебная группа (список участников)'><span class='badge " + color + " badge-cell'>" + rowObject.userCount + "</span></a>";
						}
					},
					{
						name: "courseCount", sortable: true, align: 'center', width: 25, index: 'courseCount', formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.courseCount <= 0) {
								color = "badge-danger";
							}
							return "<a href='tutoring?pageid=groupprogram&groupid=" + rowObject.id + "' title='Учебные курсы программы аттестации'><span class='badge " + color + " badge-cell'>" + rowObject.courseCount + "</span></a>";
						}
					},
					{
						name: "btnSendAlert", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-email text-info js_send_table_record' href='#' attr-id='" + rowObject.id + "' title='Оповестить участников'></a>";
						}
					},
					{
						name: "btnExport", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-file-export text-info js_export_table_record' href='#' attr-id='" + rowObject.id + "' title='Отчет о статистике успеваемости участников программы аттестации'></a>";
						}
					},
					{
						name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
						}
					},
					{
						name: "btnCopy", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-content-copy text-info js_copy_table_record' href='#' attr-id='" + rowObject.id + "' title='Копировать'></a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				break;
			}
			case "groupprogram": {
				let $select_prog = $('.select2.js-program', page._cruc.$modal);
				we_helper.initSelect('/Designer/GetEnums?name=trainingForm', $('.select2.js-training-form', page._cruc.$modal), null, false, true);
				crumb.push({ page: "Программы аттестации", path: "/tutoring?pageid=group" },
					{ page: "Учебные курсы программы аттестации" });

				let groupid = we_helper.urlParam("groupid");
				$("input[name=groupId]", page._cruc.$modal).val(groupid);
				we_helper.getDataDB("/Tutoring/GetRecord", { pageid: "group", id: groupid }, "query", false, function (info) {
					$(".js_page_info").html("<strong>Программа аттестации:</strong> " + info.num + ". " + info.name).removeClass("d-none");
					we_helper.initSelect('/Designer/GetRecordsKeyText', $select_prog, {
						pageid: "close_program",
						filialid: info.filialId
					}, true, true);
					we_helper.hideLoader();
				});

				page._cruc.url = ["/Tutoring/CreateGroupProgram", "/Tutoring/UpdateGroupProgram"];
				page._cruc.title = ["Добавление учебного курса в программу аттестации", "Редактирование параметров учебного курса в программе аттестации"];
				_selectParam = [];
				_searchParam.params = [
					{ text: 'Учебный курс или код', placeholder: 'Введите часть наименования или код учебного курса' },
					{ text: 'Код', placeholder: 'Введите код учебного курса' },
					{ text: 'Учебный курс', placeholder: 'Введите часть наименования учебного курса' },
					{ text: 'Регламент контроля', placeholder: 'Введите часть наименования регламента контроля' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];

				_table_stg.sortname = 'startDate';
				_table_stg.corr_height = -40;
				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', '', 'Начало', 'Окончание', 'Назначение', 'Код', 'Учебный курс', 'Регламент контроля', 'Тест', 'Протокол', 'Дата изменения', 'Изменил', 'Мод.', 'Бил.', 'Ред.', 'Уд.'
				];

				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{
						name: "isValid", sortable: false, align: 'center', width: 10, index: 'isValid',
						formatter: function (cellvalue, options, rowObject) {
							let _color = "success";
							if (!rowObject.isValid) {
								_color = "danger";
							}
							return '<span class="mdi mdi-circle text-' + _color + '"></span>';
						}
					},
					{
						name: "startDate", sortable: true, align: 'center', width: 50, index: 'startDate',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i" }
					},
					{
						name: "endDate", sortable: true, align: 'center', width: 50, index: 'endDate',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i" }
					},
					{ name: "trainingFormName", sortable: true, align: 'center', width: 50, index: 'trainingFormName' },
					{ name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
					{ name: "programName", sortable: true, align: 'left', width: 200, index: 'programName' },
					{ name: "testingRegulationName", sortable: true, align: 'left', width: 100, index: 'testingRegulationName' },
					{
						name: "includeInControlAll", sortable: true, align: 'center', width: 40, index: 'includeInControlAll',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.includeInControlAll) {
								return 'Включать все ТЗ (варианты)';
							}
							return 'Генерировать';
						}
					},
					{
						name: "showProtocol", sortable: true, align: 'center', width: 40, index: 'showProtocol',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.showProtocol) {
								return 'Отображать';
							}
							return 'Скрывать';
						}
					},
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 60, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 70, index: 'userHasChanged' },
					{
						name: "moduleCount", sortable: true, align: 'center', width: 20, index: 'moduleCount', formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.moduleCount <= 0) {
								color = "badge-danger";
							}
							return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.moduleCount + "</span>";
						}
					},
					{
						name: "ticketCount", sortable: true, align: 'center', width: 20, index: 'ticketCount', formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.ticketCount <= 0) {
								color = "badge-danger";
							}
							return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.ticketCount + "</a>";
						}
					},
					{
						name: "btnEdit", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-pencil text-primary js_edit_table_record' href='#' attr-id='" + rowObject.id + "' title='Редактировать'></a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				we_helper.initDateTimePicker($(".date", page._cruc.$modal));
				break;
			}
			case "groupmember": {
				crumb.push({ page: "Программы аттестации", path: "/tutoring?pageid=group" }, { page: "Учебная группа" });

				let groupid = we_helper.urlParam("groupid");
				we_helper.getDataDB("/Tutoring/GetRecord", { pageid: "group", id: groupid }, "query", false, function (info) {
					$(".js_page_info").html("<strong>Программа аттестации:</strong> " + info.num + ". " + info.name).removeClass("d-none");
					we_helper.hideLoader();
				});

				_selectParam = [];
				_searchParam.params = [
					{ text: 'ФИО или код', placeholder: 'Введите часть ФИО или код пользователя' },
					{ text: 'Код', placeholder: 'Введите код пользователя' },
					{ text: 'ФИО', placeholder: 'Введите часть ФИО пользователя' },
					{ text: 'Логин', placeholder: 'Введите часть логина пользователя' },
					{ text: 'Email', placeholder: 'Введите часть наименования почтового ящика пользователя' },
					{ text: 'Структурная единица', placeholder: 'Введите часть наименования структурной единицы пользователя' },
					{ text: 'Подразделение', placeholder: 'Введите часть наименования подразделения пользователя' },
					{ text: 'Должность', placeholder: 'Введите часть наименования должности пользователя' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];
				_table_stg.corr_height = -40;
				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код', 'ФИО', 'Логин',
					'Email', 'Должность', 'Подразделение', 'Структурная единица', 'Дата изменения', 'Изменил', 'Представитель', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 120, index: 'name' },
					{ name: "login", sortable: true, align: 'left', width: 70, index: 'login' },
					{ name: "email", sortable: true, align: 'left', width: 80, index: 'email' },
					{ name: "postName", sortable: true, align: 'left', width: 70, index: 'postName' },
					{ name: "departmentName", sortable: true, align: 'left', width: 90, index: 'departmentName' },
					{ name: "filialName", sortable: true, align: 'left', width: 70, index: 'filialName' },
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 60, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 60, index: 'userHasChanged' },
					{
						name: "represent", sortable: true, align: 'center', width: 40, index: 'represent',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.represent) {
								return "<span class='badge badge-pill badge-success badge-cell'>ДА</span>";
							}
							return "<span class='badge badge-pill badge-secondary badge-cell'>НЕТ</span>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 25, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				_actionBtn[0].text = "Добавить";
				_actionBtn.push({
					id: "addtutor",
					icon: "mdi mdi-account-plus",
					style: "success",
					text: "Назначить представителей"
				},
					{
						id: "removetutor",
						icon: "mdi mdi-account-minus",
						style: "danger",
						text: "Отозвать назначение"
					});
				break;
			}
			case "includemember": {
				let groupid = we_helper.urlParam("groupid");
				crumb.push({ page: "Программы аттестации", path: "/tutoring?pageid=group" },
					{ page: "Учебная группа", path: "/tutoring?pageid=groupmember&groupid=" + groupid },
					{ page: "Включение участников в группу" });

				we_helper.getDataDB("/Tutoring/GetRecord", {
					pageid: "group",
					id: groupid
				}, "query", false, function (info) {
					$(".js_page_info").html("<strong>Программа аттестации:</strong> " + info.num + ". " + info.name).removeClass("d-none");
					we_helper.hideLoader();
				});

				_searchParam.params = [
					{ text: 'ФИО или код', placeholder: 'Введите часть ФИО или код пользователя' },
					{ text: 'Код', placeholder: 'Введите код пользователя' },
					{ text: 'ФИО', placeholder: 'Введите часть ФИО пользователя' },
					{ text: 'Логин', placeholder: 'Введите часть логина пользователя' },
					{ text: 'Email', placeholder: 'Введите часть наименования почтового ящика пользователя' },
					{ text: 'Должность', placeholder: 'Введите часть наименования должности пользователя' },
					{ text: 'Подразделение', placeholder: 'Введите часть наименования подразделения пользователя' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];
				_table_stg.corr_height = -40;
				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код', 'ФИО', 'Логин',
					'Email', 'Должность', 'Подразделение', 'Структурная единица', 'Дата изменения', 'Изменил', 'Доб.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 70, index: 'name' },
					{ name: "login", sortable: true, align: 'left', width: 70, index: 'login' },
					{ name: "email", sortable: true, align: 'left', width: 80, index: 'email' },
					{ name: "postName", sortable: true, align: 'left', width: 70, index: 'postName' },
					{ name: "departmentName", sortable: true, align: 'left', width: 90, index: 'departmentName' },
					{ name: "filialName", sortable: true, align: 'left', width: 70, index: 'filialName' },
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 60, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 60, index: 'userHasChanged' },
					{
						name: "btnAdd", classes: 'overflow-none', width: 25, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-plus text-success js_add_table_record' href='#' attr-id='" + rowObject.id + "' title='Добавить'></a>";
						}
					}
				];
				_actionBtn = [
					{
						id: "add",
						icon: "mdi mdi-plus",
						style: "success",
						text: "Добавить"
					}];
				break;
			}
			case "selftesting": {
				crumb.push({ page: "Статистика по учебным курсам" });
				_searchParam.params = [
					{ text: 'Учебный курс или код', placeholder: 'Введите часть наименования или код учебного курса' },
					{ text: 'Код', placeholder: 'Введите код учебного курса' },
					{ text: 'Учебный курс', placeholder: 'Введите часть наименования учебного курса' },
					{ text: 'Регламент контроля', placeholder: 'Введите часть наименования регламента контроля' },
					{ text: 'Изменил', placeholder: 'Введите часть фамилии (логина) пользователя' }
				];

				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Код', 'Учебный курс', 'Регламент контроля', 'Ответственное подразделение', 'Тест', 'Протокол', 'Структурная единица', 'Внутренняя', 'Дата изменения', 'Изменил', 'Мод.', 'Эксп.', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{ name: "num", sortable: true, align: 'center', width: 20, index: 'num' },
					{ name: "name", sortable: true, align: 'left', width: 200, index: 'name' },
					{ name: "testingRegulationName", sortable: true, align: 'left', width: 100, index: 'testingRegulationName' },
					{ name: "departmentName", sortable: true, align: 'left', width: 70, index: 'departmentName' },
					{
						name: "includeInControlAll", sortable: true, align: 'center', width: 35, index: 'includeInControlAll',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.includeInControlAll) {
								return 'Включать все ТЗ (варианты)';
							}
							return 'Генерировать';
						}
					},
					{
						name: "showProtocol", sortable: true, align: 'center', width: 35, index: 'showProtocol',
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.showProtocol) {
								return 'Отображать';
							}
							return 'Скрывать';
						}
					},
					{ name: "filialName", sortable: true, align: 'left', width: 50, index: 'filialName' },
					{
						name: "internal", sortable: true, align: 'center', width: 20, index: 'internal',
						formatter: function (cellvalue, options, rowObject) {
							if (cellvalue) {
								return "<span class='mdi mdi-checkbox-marked-outline' title='Доступна только внутри области данных'></span>";
							} else {
								return "<span class='mdi mdi-checkbox-blank-outline' title='Общедоступная информация'></span>";
							}
						}
					},
					{
						name: "dateOfChange", sortable: true, align: 'left', width: 60, index: 'dateOfChange',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d H:i:s", newformat: "d.m.Y H:i:s" }
					},
					{ name: "userHasChanged", sortable: true, align: 'left', width: 80, index: 'userHasChanged' },
					{
						name: "moduleCount", sortable: true, align: 'center', width: 20, index: 'moduleCount', formatter: function (cellvalue, options, rowObject) {
							let color = "badge-success";
							if (rowObject.moduleCount <= 0) {
								color = "badge-danger";
							}
							return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.moduleCount + "</span>";
						}
					},
					{
						name: "btnExport", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-file-export text-info js_export_table_record' href='#' attr-id='" + rowObject.id + "' title='Отчёт о статистике успеваемости по учебному курсу'></a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 20, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				_actionBtn = [
					{
						id: "delete",
						icon: "mdi mdi-delete",
						style: "danger",
						text: "Удалить"
					}];
				break;
			}
			case "protocol": {
				crumb.push({ page: "Журнал протоколов контроля" });
				_searchParam.params = [
					{ text: 'Аттестуемый', placeholder: 'Введите часть ФИО аттестуемого' },
					{ text: 'Учебный курс', placeholder: 'Введите часть наименования учебного курса' },
					{ text: 'Структурная единица', placeholder: 'Введите часть наименования структурной единицы аттестуемого' },
					{ text: 'Подразделение', placeholder: 'Введите часть наименования подразделения аттестуемого' },
					{ text: 'Должность', placeholder: 'Введите часть наименования должности аттестуемого' }
				];
				_table_stg.colNames = [
					'', '<input type="checkbox" class="js-select-all-row" title = "Выбрать все строки" />', 'Дата контроля', 'Аттестуемый', 'Структурная единица аттестуемого', 'Оценка', 'Вид контроля', 'Типы компонентов для контроля', 'Учебный курс', 'Продолжительность (мин.)', 'След. контроль', 'Отп.', 'Эксп.', 'Уд.'
				];
				_table_stg.colModel = [
					{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
					{
						name: "selected", width: 15, align: "center", sortable: false, title: false,
						formatter: function (cellvalue, options, rowObject) {
							var res = "<input class='js-select-row' title = 'Выбрать строку' attr-id='" + rowObject.id + "' type='checkbox'";
							if ($.inArray(rowObject.id, page._table_selected_rows) !== -1) {
								res += ' checked="checked"';
							}
							return res + '/>';
						}
					},
					{
						name: "dateTesting", sortable: true, align: 'center', width: 40, index: 'dateTesting',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d", newformat: "d.m.Y" }
					},
					{ name: "name", sortable: true, align: 'left', width: 70, index: 'name' },
					{ name: "filialName", sortable: true, align: 'left', width: 60, index: 'filialName' },
					{ name: "mark", sortable: true, align: 'center', width: 45, index: 'mark' },
					{ name: "controlTypeName", sortable: true, align: 'left', width: 65, index: 'controlTypeName' },
					{ name: "controlMethodsName", sortable: true, align: 'left', width: 65, index: 'controlMethodsName' },
					{ name: "programName", sortable: true, align: 'left', width: 195, index: 'programName' },
					{ name: "testTime", sortable: true, align: 'center', width: 30, index: 'testTime' },
					{
						name: "dateNextTesting", sortable: true, align: 'center', width: 45, index: 'dateNextTesting',
						formatter: "date",
						formatoptions: { srcformat: "Y-m-d", newformat: "d.m.Y" }
					},
					{
						name: "btnExportRsp", classes: 'overflow-none', width: 15, align: "center", sortable: false, hidden: this._edition === "SO UPS" ? false : true,
						formatter: function (cellvalue, options, rowObject) {
							if (rowObject.allowExportToRsp) {
								return "<a class='mdi mdi-cube-send text-primary js_export_rsp_table_record' href='#' attr-id='" + rowObject.id + "' title='Отправить в ИУС «РСП»'></a>";
							}
							return "";
						}
					},
					{
						name: "btnExport", classes: 'overflow-none', width: 15, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							let alert = "";
							if (rowObject.isLegacy) {
								alert = '<span class="text-danger" title="Устаревшая версия протокола">*</span>';

							}
							return "<a class='mdi mdi-file-export text-info js_export_table_record' href='#' attr-legacy='" + rowObject.isLegacy + "' attr-id='" + rowObject.id + "' title='Отчёт'>" + alert + "</a>";
						}
					},
					{
						name: "btnDelete", classes: 'overflow-none', width: 15, align: "center", sortable: false,
						formatter: function (cellvalue, options, rowObject) {
							return "<a class='mdi mdi-delete-outline text-danger js_del_table_record' href='#' attr-id='" + rowObject.id + "' title='Удалить'></a>";
						}
					},
				];
				_table_stg.sortname = 'dateTesting';
				_table_stg.sortorder = 'desc';
				_table_stg.subGrid = true;
				_table_stg.subGridRowExpanded = function (subgrid_id, row_id) {
					page.initThemesGrid(subgrid_id, row_id);
				};
				_actionBtn.splice(0, 1);
				break;
			}
			default: {
				window.open('/', '_self');
			}
		}
		we_helper.setBreadcrumb(crumb);
		page._search = $('.js_search_panel').searchPanel({
			uid: "tutoring_" + page._id,
			selectParam: _selectParam,
			actionBtn: _actionBtn,
			searchParam: _searchParam,
			autocomplete: _searchAutocomplete,
			defBtn: true,
			onSearch: function (data) {
				we_helper.reloadJqGrid(page.$table, data, 1);
			},
			onClear: function (data) {
				we_helper.reloadJqGrid(page.$table, data, 1);
			},
			onAction: function (keyBtn, data) {
				switch (keyBtn) {
					case "add": {
						if (page._id == "groupmember") {
							window.open("/tutoring?pageid=includemember&groupid=" + we_helper.urlParam("groupid"), "_self");
						} else if (page._id == "includemember") {
							if (page._table_selected_rows.length === 0) {
								we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
								return;
							}
							page.includeMembersToGroup(page._table_selected_rows, function () {
								page._table_selected_rows = [];
								we_helper.reloadJqGrid(page.$table); we_helper.reloadJqGrid(page.$table);
							});
						} else {
							page.showModal("add");
						}
						break;
					}
					case "delete": {
						if (page._table_selected_rows.length === 0) {
							we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
							return;
						}
						page.deleteRecords(page._table_selected_rows, function () {
							page._table_selected_rows = [];
							we_helper.reloadJqGrid(page.$table);
						});
						break;
					}
					case "expanded_export": {
						page.$expanded_export_modal.modal('show');
						break;
					}
					case "addtutor": {
						if (page._table_selected_rows.length === 0) {
							we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
							return;
						}
						page.makeATutor(page._table_selected_rows, true, function () {
							page._table_selected_rows = [];
							we_helper.reloadJqGrid(page.$table);
						});
						break;
					}
					case "removetutor": {
						if (page._table_selected_rows.length === 0) {
							we_helper.alert("Не выбрано ни одной записи!", notificatioType.warning);
							return;
						}
						page.makeATutor(page._table_selected_rows, false, function () {
							page._table_selected_rows = [];
							we_helper.reloadJqGrid(page.$table);
						});
						break;
					}
					case "export": {
						$(".export-protocol").addClass("d-none");
						page.$dlgReportSettings.modal('show');
						break;
					}
					default: {
						break;
					}
				}
			}
		});
		we_helper.initJqGrid(page.$table, _table_stg, page._search.api().get_data(), function () {
			$('.js-select-all-row').prop('checked',
				we_helper.isAllSelected($('.js-select-row', page.$table)));
		});
	},
	showModal: function (act, id) {
		if (act === "edit" || act === "copy") {
			we_helper.getDataDB("/Tutoring/GetRecord", { id: id, pageid: page._id }, "query", false, function (entity) {
				page._data = entity;
				page._data["actionid"] = act;
				if (page._data.startDate) {
					page._data.startDate = we_helper.convertDateMin(page._data.startDate);
				}
				if (page._data.endDate) {
					page._data.endDate = we_helper.convertDateMin(page._data.endDate);
				}
				we_helper.setFormData(page._cruc.$modal, page._data);

				let modaltitle = page._cruc.title[1];
				if (act === "copy") {
					modaltitle = page._cruc.title[2];
					$(".onlycopyproperty").removeClass("d-none");
				}
				$('.modal-title', page._cruc.$modal).text(modaltitle);
				page._cruc.$modal.modal('show');
				we_helper.hideLoader();
			});
		} else if (act === "add") {
			let search_data = page._search.api().get_data();
			if (!search_data["filialid"]) {
				if (!!page._cur_user_filial.id) {
					search_data["filialid"] = page._cur_user_filial.id;
					search_data["filialname"] = page._cur_user_filial.text;
				} else {
					search_data["filialid"] = page._sys_owner_filial.id;
					search_data["filialname"] = page._sys_owner_filial.text;
				}
			}
			we_helper.getDataDB("/Tutoring/GetNextRecordNumber", { pageid: page._id, filialid: search_data.filialid }, "query", false, function (entity) {
				we_helper.setFormData(page._cruc.$modal, {
					filialId: search_data.filialid,
					filialName: search_data.filialname,
					num: entity
				});
				$('.modal-title', page._cruc.$modal).text(page._cruc.title[0]);
				page._cruc.$modal.modal('show');
				we_helper.hideLoader();
			});
		} else {
			we_helper.alert("Некорректно задан код действия: " + act, notificatioType.warning);
		}
	},
	deleteRecords: function (ids, callback) {
		we_helper.deleteDataDB("/Tutoring/DeleteReferenceRecords", {
			pageid: page._id,
			ids: ids
		}, function () {
			if (callback) {
				callback();
			}
		});
	},
	updateRecord: function () {
		page._data = $.extend(page._data, we_helper.getFormData(page._cruc.$modal));
		let arcionUrl = page._cruc.url[0];
		if (!!page._data.id) {
			if (page._data["actionid"] === "edit") {
				arcionUrl = page._cruc.url[1]
			} else if (page._data["actionid"] === "copy") {
				arcionUrl = page._cruc.url[2]
			}
		}

		we_helper.updateDataDB(arcionUrl, page._data, function () {
			we_helper.reloadJqGrid(page.$table);
			page._cruc.$modal.modal('hide');
		});
	},
	includeMembersToGroup: function (ids, callback) {
		we_helper.updateDataDB("/Tutoring/IncludeMembersToGroup", {
			ids: ids,
			groupid: we_helper.urlParam("groupid")
		}, function () {
			if (callback) {
				callback();
			}
		});
	},
	makeATutor: function (ids, represent, callback) {
		we_helper.updateDataDB("/Tutoring/MakeATutor", {
			ids: ids,
			represent: represent
		}, function () {
			if (callback) {
				callback();
			}
		});
	},
	sendAlertUserInGroup: function (groupid) {
		bootbox.confirm({
			message: "Вы уверены, что хотите оповестить участников о начале обучения в по программе аттестации?",
			swapButtonOrder: true,
			buttons: {
				cancel: {
					label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
					className: 'btn-sm btn-danger'
				},
				confirm: {
					label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
					className: 'btn-sm btn-success'
				}
			},
			callback: function (result) {
				if (result) {
					we_helper.showLoader();
					$.ajax({
						url: "/Tutoring/SendAlertUserInGroup",
						type: 'POST',
						cache: false,
						data: {
							groupId: groupid
						},
						success: function (response) {
							if (response.result == 1) {
								we_helper.alert("Данные успешно отправлены.", notificatioType.success);

							} else {
								we_helper.alert(response.message, notificatioType.danger);
							}
							we_helper.hideLoader();
						},
						error: function (err) {
							we_helper.hideLoader();
							we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
						}
					});
				}
			}
		});
	},
	initThemesGrid: function (subgrid_id, row_id) {
		let subgrid_table_id = subgrid_id + "_t",
			pager_id = "p_" + subgrid_table_id;
		let protocolid = row_id.split('_')[1];

		$("#" + subgrid_id).html("<table id='" + subgrid_table_id + "' class='mb-1'></table><div id='" + pager_id + "' class='d-none'></div>");
		we_helper.initJqGrid($("#" + subgrid_table_id), {
			uid: "tutoring_" + page._id + "_theme",
			postData: {
				protocolid: protocolid,
				pageid: "themes"
			},
			url: "/Tutoring/GetRecords",
			colNames: [
				'', 'Код', 'Тема', 'Тип компонентов модуля', 'Оценка', 'ТЗ'
			],
			colModel: [
				{ name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
				{ name: "num", sortable: true, align: 'center', width: 30, index: 'num' },
				{ name: "name", sortable: true, align: 'left', width: 200, index: 'name' },
				{ name: "componentName", sortable: true, align: 'left', width: 65, index: 'componentName' },
				{ name: "mark", sortable: true, align: 'center', width: 50, index: 'mark' },
				{
					name: "questionCount", sortable: true, align: 'center', width: 25, index: 'questionCount',
					formatter: function (cellvalue, options, rowObject) {
						if (rowObject.componentType === 0) {
							let color = "badge-success";
							if (rowObject.questionCount <= 0) {
								color = "badge-danger";
							}
							return "<a href='tutoring?pageid=theoryprotocol&protocolid=" + protocolid + "&themeid=" + rowObject.id + "' title='Детальный просмотр'><span class='badge " + color + " badge-cell'>" + rowObject.questionCount + "</span></a>";
						}
						return "-"
					}
				}
			],
			idPrefix: "s_" + row_id + "_",
			pager: "#" + pager_id,
			auto_height: true,
			sortname: 'num',
			sortorder: 'asc',
			beforeSelectRow: function (rowid, e) { return false; },
		});
		$(window).bind('resize', function () {
			$("#" + subgrid_table_id).setGridWidth($(window).width() * 0.80);
		}).trigger('resize');
	},
	exportToRsp: (recordId) => { 
		let data = { protocolId: recordId }; 
		bootbox.confirm({
			message: "Вы уверены, что хотите отправить протокол в ИУС «РСП»?",
			swapButtonOrder: true,
			buttons: {
				cancel: {
					label: "<span class='mdi mdi-close pr-lg-1'></span><span class='d-none d-lg-inline-block'> Отмена</span>",
					className: 'btn-sm btn-danger'
				},
				confirm: {
					label: "<span class='mdi mdi-check pr-lg-1'></span><span class='d-none d-lg-inline-block'> Да</span>",
					className: 'btn-sm btn-success'
				}
			},
			callback: function (result) {
				if (result) {
					we_helper.showLoader();
					$.ajax({
						url: "/Tutoring/SendToRsp",
						type: 'POST',
						cache: false,
						data: data,
						success: function (response) {
							if (response.result == 1) {
								we_helper.alert("Данные упешно отправлены", notificatioType.success);

							} else {
								we_helper.alert(response.message, notificatioType.danger);
							}
						},
						error: function (err) {
							we_helper.alert('Ошибка загрузки страницы: ' + err.statusText + '. Закройте все окна браузера и повторите попытку.', notificatioType.danger);
						},
						complete: () => {
							we_helper.hideLoader();
						}
					});
				}
			}
		});
	}
};