﻿$(function () { 
    page.init();
});

var page = {
    _id: we_helper.getPageId(),
    _protocolid: we_helper.urlParam("protocolid"),
    _themeid: we_helper.urlParam("themeid"),
    _search: null,
    _file_viewer: null,  
    $tableTestItems: $(".js_table_test_items"),
    $tableSelectedAnswers: $(".js_table_selected_answers"),
    $tableAllAnswers: $(".js_table_all_answers"),
    init: function () {
        we_helper.setBreadcrumb([{ page: "Планирование", path: "#" },
        { page: "Журнал протоколов контроля", path: "/tutoring?pageid=protocol" },
        { page: "Детальное описание протокола контроля" }]);

        page.$tableTestItems.on('click', 'a.js_view_question_link', function () {
            page.cacheDocumentBeforeOpen($(this).attr("attr-id"), $(this).attr("link-id"));
        });
        page._file_viewer = $(".js_file_viewer_dialog").fileViewer({
            dialog: true,
            onLoad: function () {
                we_helper.hideLoader();
            }
        });
        page._search = $('.js_search_panel').searchPanel({
            selectParam: [], 
            searchParam: {
                params: [
                    { text: 'Тестовое задание или код', placeholder: 'Введите часть наименования или код тестового задания' },
                    { text: 'Код', placeholder: 'Введите код тестового задания' },
                    { text: 'Тестовое задание', placeholder: 'Введите часть наименования тестового задания' },
                    { text: 'Документ', placeholder: 'Введите часть наименования документа' },
                    { text: 'Закладка', placeholder: 'Введите часть наименования закладки документа' }, 
                ],
                default: {
                    param: 0,
                    data: ""
                }
            },
            dateBlock: {
                show: false
            },
            defBtn: true,
            onSearch: function (data) {
                we_helper.reloadJqGrid(page.$tableTestItems, data, 1);
            },
            onClear: function (data) {
                we_helper.reloadJqGrid(page.$tableTestItems, data, 1);
            }, 
        });
        we_helper.initJqGrid(page.$tableTestItems, {
            uid: "tutoring_" + page._id,
            url: "/tutoring/getrecords",
            colNames: [
                '', '', 'Код', 'Тестовое задание', 'Тип', 'Документ', 'Закладка', 'Отв.', 'Выбр.', 'Верн.'
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "questType", hidedlg: true, hidden: true, index: 'questType' },
                { name: "num", sortable: true, align: 'center', width: 25, index: 'num' },
                { name: "name", sortable: true, align: 'left', width: 160, index: 'name' },
                { name: "questTypeName", sortable: true, align: 'left', width: 50, index: 'questTypeName' },
                { name: "documentName", sortable: true, align: 'left', width: 100, index: 'documentName' },
                {
                    name: "bookMark", sortable: true, align: 'left', width: 55, index: 'bookMark', formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.bookMark !== null && rowObject.bookMark !== "") {
                            return "<a class='text-info js_view_question_link' href='#' link-id='" + rowObject.bookMark + "' attr-id='" + rowObject.documentId + "'>" + rowObject.bookMark + "</a>";
                        }
                        return "";
                    }
                },
                {
                    name: "answerCount", sortable: false, align: 'center', width: 20, index: 'answerCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.answerCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.answerCount + "</span>";
                    }
                }, 
                {
                    name: "selectedCount", sortable: false, align: 'center', width: 20, index: 'selectedCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.selectedCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.selectedCount + "</span>";
                    }
                }, 
                {
                    name: "correctedCount", sortable: false, align: 'center', width: 20, index: 'correctedCount', formatter: function (cellvalue, options, rowObject) {
                        let color = "badge-success";
                        if (rowObject.correctedCount <= 0) {
                            color = "badge-danger";
                        }
                        return "<span class='badge badge-pill " + color + " badge-cell'>" + rowObject.correctedCount + "</span>";
                    }
                }, 
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { 
                return $(this).getGridParam('selrow') != rowid;
            },
            onSelectRow: function (id) {
                let row = $(this).jqGrid('getRowData', id); 
                page.$tableAllAnswers.hideCol(["num", "name", "conformity", "correct", "numeric", "prec"]);
                page.$tableSelectedAnswers.hideCol(["num", "name", "conformity", "numeric", "prec"]);
                if (!!row) {
                    if (row.questType === "0") {
                        page.$tableAllAnswers.showCol(["num", "name", "correct"]);
                        page.$tableSelectedAnswers.showCol(["num", "name"]);
                    } else if (row.questType === "1") {
                        page.$tableAllAnswers.showCol(["num", "name"]);
                        page.$tableSelectedAnswers.showCol(["num", "name"]);
                    } else if (row.questType === "2") {
                        page.$tableAllAnswers.showCol(["name", "conformity"]);
                        page.$tableSelectedAnswers.showCol(["name", "conformity"]);
                    } else if (row.questType === "3") {
                        page.$tableAllAnswers.showCol(["numeric", "prec"]);
                        page.$tableSelectedAnswers.showCol(["num", "name"]);
                    }
                    we_helper.reloadJqGrid(page.$tableSelectedAnswers, {
                        questionid: row.id,
                        questType: row.questType
                    }, 1);

                    we_helper.reloadJqGrid(page.$tableAllAnswers, {
                        questionid: row.id
                    }, 1);
                }
            },
            widthContainer: ".test-item-with-container"
        }, page._search.api().get_data(), function () {
            $(".jqgrow", $(".js_table_test_items")).addClass("cursor-pointer");
        });
        we_helper.initJqGrid(page.$tableSelectedAnswers, {
            url: "/tutoring/getrecords",
            datatype: "local",
            colNames: [
                '', 'Код', 'Ответ', 'Ассоциация', 'Верно',
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: false, align: 'center', width: 20, index: 'num' },
                { name: "name", sortable: false, align: 'left', width: 150, index: 'name' },
                { name: "conformity", sortable: false, align: 'left', width: 150, index: 'conformity', hidden: true }, 
                {
                    name: "correct", sortable: false, align: 'center', width: 30, index: 'correct',
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.correct) {
                            return 'ДА';
                        }
                        return 'НЕТ';
                    }
                },
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
            widthContainer: ".answer-with-container", 
            corr_height: 0.45
        }, {  pageid: "protocolselectedanswer" });

        we_helper.initJqGrid(page.$tableAllAnswers, {
            url: "/tutoring/getrecords",
            datatype: "local",
            colNames: [
                '', 'Код', 'Ответ', 'Ассоциация', 'Верно', 'Эталон', 'Точность',
            ],
            colModel: [
                { name: "id", hidedlg: true, hidden: true, key: true, index: 'id' },
                { name: "num", sortable: false, align: 'center', width: 20, index: 'num' },
                { name: "name", sortable: false, align: 'left', width: 150, index: 'name' },
                { name: "conformity", sortable: false, align: 'left', width: 150, index: 'conformity', hidden: true },
                {
                    name: "correct", sortable: false, align: 'center', width: 30, index: 'correct',
                    formatter: function (cellvalue, options, rowObject) {
                        if (rowObject.correct) {
                            return 'ДА';
                        }
                        return 'НЕТ';
                    }
                },
                { name: "numeric", sortable: false, align: 'left', width: 100, index: 'numeric', hidden: true },
                { name: "prec", sortable: false, align: 'left', width: 100, index: 'prec', hidden: true },
            ],
            sortname: 'num',
            sortorder: 'asc',
            beforeSelectRow: function (rowid, e) { return false; },
            widthContainer: ".answer-with-container", 
            corr_height: 0.46
        }, { pageid: "protocolallanswer" });
        we_helper.hideLoader();
    },
    cacheDocumentBeforeOpen: function (id, link) {
        we_helper.getDataDB("/Designer/CacheDocumentBeforeOpen", { documentid: id }, "query", false, function (entity) {
            page._file_viewer.api().view(entity, link);
        });
    },
};
